DEFLNG A-Z
REDIM SpellingWord(0) AS STRING

InitializeSpellchecker
DO
    LINE INPUT "Give me a sentence ="; sentence$
    IF sentence$ = "" THEN SYSTEM
    bad = CheckSentence(sentence$, bad$)
    IF bad THEN
        PRINT "There were"; -bad; " mistakes found.  They were:"
        PRINT bad$
    ELSE
        PRINT "Sentence good!"
    END IF
LOOP
END


SUB InitializeSpellchecker
    SHARED SpellingWord$
    SHARED SpellingWord() AS STRING
    PRINT "Initializing spelling lists.  Be patient a moment."
    SpellingWord$ = CHR$(10)
    DO
        READ W$
        W$ = UCASE$(W$)
        IF W$ = "XDONE" THEN EXIT DO
        counter = counter + 1
        REDIM _PRESERVE SpellingWord(counter) AS STRING
        SpellingWord(counter) = W$
        SpellingWord$ = SpellingWord$ + CHR$(10) + W$ + CHR$(13)
    LOOP


    PRINT "Spelling lists ready."
    PRINT
    PRINT

END SUB


FUNCTION CheckSentence (sent$, bad$)
    SHARED SpellingWord$
    SHARED SpellingWord() AS STRING
    REDIM suggestion(0) AS STRING
    REDIM percent(0) AS INTEGER
    DIM result AS SINGLE

    text$ = LTRIM$(RTRIM$(sent$)) + " "
    FOR i = 1 TO LEN(text$)
        x = ASC(UCASE$(text$), i)
        IF x > 64 AND x < 92 OR x = 39 THEN text1$ = text1$ + MID$(text$, i, 1) ELSE text1$ = text1$ + " "
    NEXT
    text$ = LTRIM$(RTRIM$(text1$)) + " "

    bad = 0 'It's not bad to start with
    bad$ = "" 'not bad string to start with either

    DO UNTIL finished
        l = INSTR(l + 1, text$, " ")
        IF l > 0 THEN
            word$ = MID$(text$, oldl, l - oldl): oldl = l + 1
            IF LEN(word$) < 2 THEN
                'Word too small to check, we still count it as good
            ELSE
                IF INSTR(SpellingWord$, CHR$(10) + UCASE$(word$) + CHR$(13)) THEN
                    'It's in there!, that's a valid word!
                ELSE
                    s = 0: bad = bad - 1
                    wl = LEN(word$)
                    FOR i = 1 TO UBOUND(SpellingWord)
                        IF wl > LEN(SpellingWord(i)) * .8 AND wl < LEN(SpellingWord(i)) * 1.2 THEN 'no need to check words too short or too long to generate a positive result
                            result = SpellCheck(word$, SpellingWord(i))
                            IF result < -80 THEN
                                s = s + 1
                                REDIM _PRESERVE suggestion(s)
                                REDIM _PRESERVE percent(s)
                                suggestion(s) = SpellingWord(i)
                                percent(s) = result
                            END IF
                        END IF
                    NEXT
                    bad$ = bad$ + word$ + " -- " + STR$(s) + " SUGGESTIONS: "
                    FOR i = 1 TO s
                        bad$ = bad$ + suggestion(i) '+ "(" + STR$(-percent(i)) + ")"           'Unremark this line if we want to see the percentage match we generated
                        IF i <> s THEN bad$ = bad$ + ", "
                    NEXT
                    bad$ = bad$ + CHR$(10) 'a simple linux file ending for easy parsing later
                END IF
            END IF
        ELSE
            finished = -1
        END IF

    LOOP
    CheckSentence = bad
END SUB

FUNCTION SpellCheck (useranswer$, answer$)
    IF useranswer$ = answer$ THEN SpellCheck = 100: EXIT FUNCTION 'It's a perfect match

    DIM alphabit(26), useralphabit(26)
    FOR j = 0 TO 26: alphabit(j) = 0: useralphabit(j) = 0: NEXT
    FOR j = 1 TO LEN(answer$)
        x = ASC(UCASE$(MID$(answer$, j, 1)))
        IF x = 39 THEN alphabit(0) = alphabit(0) + 1: length = length + 1
        IF x > 64 AND x < 91 THEN ' we have letters to check the spell checker against!
            alphabit(x - 64) = alphabit(x - 64) + 1
            length = length + 1
        END IF
    NEXT
    FOR j = 1 TO LEN(useranswer$)
        x = ASC(UCASE$(MID$(useranswer$, j, 1)))
        IF x = 39 THEN useralphabit(0) = useralphabit(0) + 1
        IF x > 64 AND x < 91 THEN useralphabit(x - 64) = useralphabit(x - 64) + 1
    NEXT
    wordright = 0: wordwrong = 0
    FOR j = 0 TO 26
        IF alphabit(j) <= useralphabit(j) THEN
            wordright = wordright + alphabit(j)
            wordwrong = wordwrong + useralphabit(j) - alphabit(j)
        ELSE
            wordright = wordright + useralphabit(j)
        END IF
    NEXT
    IF LEN(useranswer$) <= 6 THEN
        SpellCheck = -wordright / length * 100
    ELSE
        SpellCheck = -(ABS(wordright - wordwrong / 2) / length * 100)
    END IF
    IF wordwrong >= wordright THEN SpellCheck = 0 'If we get more letters wrong than we did right, count it bad.
END FUNCTION


DATA "10th","1st","2nd","3rd","4th","5th","6th","7th","8th","9th","a","a&m","a&p","a's","aaa","aaas","aarhus","aaron","aau","aba"
DATA "ababa","aback","abacus","abalone","abandon","abase","abash","abate","abater","abbas","abbe","abbey","abbot","abbott","abbreviate","abc","abdicate","abdomen","abdominal","abduct"
DATA "abe","abed","abel","abelian","abelson","aberdeen","abernathy","aberrant","aberrate","abet","abetted","abetting","abeyance","abeyant","abhorred","abhorrent","abide","abidjan","abigail","abject"
DATA "ablate","ablaze","able","ablution","abner","abnormal","abo","aboard","abode","abolish","abolition","abominable","abominate","aboriginal","aborigine","aborning","abort","abound","about","above"
DATA "aboveboard","aboveground","abovementioned","abrade","abraham","abram","abramson","abrasion","abrasive","abreact","abreast","abridge","abridgment","abroad","abrogate","abrupt","abscess","abscissa","abscissae","absence"
DATA "absent","absentee","absenteeism","absentia","absentminded","absinthe","absolute","absolution","absolve","absorb","absorbent","absorption","absorptive","abstain","abstention","abstinent","abstract","abstracter","abstractor","abstruse"
DATA "absurd","abuilding","abundant","abusable","abuse","abusive","abut","abutted","abutting","abysmal","abyss","abyssinia","ac","academe","academia","academic","academician","academy","acadia","acanthus"
DATA "acapulco","accede","accelerate","accelerometer","accent","accentual","accentuate","accept","acceptant","acceptor","access","accessible","accession","accessory","accident","accidental","accipiter","acclaim","acclamation","acclimate"
DATA "accolade","accommodate","accompaniment","accompanist","accompany","accomplice","accomplish","accord","accordant","accordion","accost","account","accountant","accra","accredit","accreditate","accreditation","accretion","accrual","accrue"
DATA "acculturate","accumulate","accuracy","accurate","accusation","accusative","accusatory","accuse","accustom","ace","acerbic","acerbity","acetate","acetic","acetone","acetylene","ache","achieve","achilles","aching"
DATA "achromatic","acid","acidic","acidulous","ackerman","ackley","acknowledge","acknowledgeable","acm","acme","acolyte","acorn","acoustic","acquaint","acquaintance","acquiesce","acquiescent","acquire","acquisition","acquisitive"
DATA "acquit","acquittal","acquitting","acre","acreage","acrid","acrimonious","acrimony","acrobacy","acrobat","acrobatic","acronym","acropolis","across","acrylate","acrylic","acs","act","actaeon","actinic"
DATA "actinide","actinium","actinolite","actinometer","activate","activation","activism","acton","actor","actress","acts","actual","actuarial","actuate","acuity","acumen","acute","acyclic","ad","ada"
DATA "adage","adagio","adair","adam","adamant","adams","adamson","adapt","adaptation","adaptive","add","added","addend","addenda","addendum","addict","addis","addison","addition","additional"
DATA "additive","addle","address","addressee","addressograph","adduce","adelaide","adele","adelia","aden","adenine","adenoma","adenosine","adept","adequacy","adequate","adhere","adherent","adhesion","adhesive"
DATA "adiabatic","adieu","adipic","adirondack","adjacent","adject","adjectival","adjective","adjoin","adjoint","adjourn","adjudge","adjudicate","adjunct","adjust","adjutant","adkins","adler","administer","administrable"
DATA "administrate","administratrix","admiral","admiralty","admiration","admire","admissible","admission","admit","admittance","admitted","admitting","admix","admixture","admonish","admonition","ado","adobe","adolescent","adolph"
DATA "adolphus","adonis","adopt","adoption","adoptive","adore","adorn","adposition","adrenal","adrenaline","adrian","adriatic","adrienne","adrift","adroit","adsorb","adsorbate","adsorption","adsorptive","adulate"
DATA "adult","adulterate","adulterous","adultery","adulthood","advance","advantage","advantageous","advent","adventitious","adventure","adventurous","adverb","adverbial","adversary","adverse","advert","advertise","advice","advisable"
DATA "advise","advisee","advisor","advisory","advocacy","advocate","aegean","aegis","aeneas","aeneid","aeolian","aeolus","aerate","aerial","aerobacter","aerobic","aerodynamic","aerogene","aeronautic","aerosol"
DATA "aerospace","aeschylus","aesthete","aesthetic","afar","affable","affair","affect","affectate","affectation","affectionate","afferent","affiance","affidavit","affiliate","affine","affinity","affirm","affirmation","affirmative"
DATA "affix","afflict","affluence","affluent","afford","afforest","afforestation","affricate","affront","afghan","afghanistan","aficionado","afield","afire","aflame","afloat","afoot","aforementioned","aforesaid","aforethought"
DATA "afoul","afraid","afresh","africa","afro","aft","aftereffect","afterglow","afterimage","afterlife","aftermath","afternoon","afterthought","afterward","afterword","again","against","agamemnon","agate","agatha"
DATA "agave","age","agee","agenda","agent","agglomerate","agglutinate","agglutinin","aggravate","aggregate","aggression","aggressive","aggressor","aggrieve","aghast","agile","aging","agitate","agleam","agnes"
DATA "agnew","agnomen","agnostic","ago","agone","agony","agouti","agrarian","agree","agreeable","agreed","agreeing","agribusiness","agricola","agricultural","agriculture","agrimony","ague","agway","ah"
DATA "ahead","ahem","ahmadabad","ahmedabad","ahoy","aid","aida","aide","aides","aiken","ail","ailanthus","aile","aileen","aileron","aim","ain't","ainu","air","airborne"
DATA "aircraft","airdrop","airedale","aires","airfare","airfield","airflow","airfoil","airframe","airlift","airline","airlock","airmail","airman","airmass","airmen","airpark","airplane","airport","airspace"
DATA "airspeed","airstrip","airtight","airway","airy","aisle","aitken","ajar","ajax","ak","akers","akin","akron","al","ala","alabama","alabamian","alabaster","alacrity","alai"
DATA "alameda","alamo","alan","alarm","alaska","alb","alba","albacore","albania","albanian","albany","albatross","albeit","alberich","albert","alberta","alberto","albrecht","albright","album"
DATA "albumin","albuquerque","alcestis","alchemy","alcmena","alcoa","alcohol","alcoholic","alcoholism","alcott","alcove","aldebaran","aldehyde","alden","alder","alderman","aldermen","aldrich","aldrin","ale"
DATA "alec","aleck","aleph","alert","alewife","alex","alexander","alexandra","alexandre","alexandria","alexei","alexis","alfalfa","alfonso","alfred","alfredo","alfresco","alga","algae","algaecide"
DATA "algal","algebra","algebraic","algenib","alger","algeria","algerian","algiers","alginate","algol","algonquin","algorithm","algorithmic","alhambra","ali","alia","alias","alibi","alice","alicia"
DATA "alien","alienate","alight","align","alike","alimony","aliphatic","aliquot","alison","alistair","alive","alizarin","alkali","alkaline","alkaloid","alkane","alkene","all","allah","allan"
DATA "allay","allegate","allegation","allege","allegheny","allegiant","allegoric","allegory","allegra","allegro","allele","allemand","allen","allentown","allergic","allergy","alleviate","alley","alleyway","alliance"
DATA "allied","alligator","allis","allison","alliterate","allocable","allocate","allot","allotropic","allotted","allotting","allow","allowance","alloy","allspice","allstate","allude","allure","allusion","allusive"
DATA "alluvial","alluvium","ally","allyl","allyn","alma","almaden","almagest","almanac","almighty","almond","almost","aloe","aloft","aloha","alone","along","alongside","aloof","aloud"
DATA "alp","alpenstock","alpert","alpha","alphabet","alphabetic","alphameric","alphanumeric","alpheratz","alphonse","alpine","alps","already","alsatian","also","alsop","altair","altar","alter","alterate"
DATA "alteration","altercate","alterman","altern","alternate","althea","although","altimeter","altitude","alto","altogether","alton","altruism","altruist","alum","alumina","aluminate","alumna","alumnae","alumni"
DATA "alumnus","alundum","alva","alvarez","alveolar","alveoli","alveolus","alvin","alway","always","alyssum","am","ama","amadeus","amalgam","amalgamate","amanita","amanuensis","amaranth","amarillo"
DATA "amass","amateur","amateurish","amatory","amaze","amazon","ambassador","amber","ambiance","ambidextrous","ambient","ambiguity","ambiguous","ambition","ambitious","ambivalent","amble","ambling","ambrose","ambrosia"
DATA "ambrosial","ambulant","ambulate","ambulatory","ambuscade","ambush","amelia","ameliorate","amen","amend","amende","amerada","america","american","americana","americanism","americium","ames","ameslan","amethyst"
DATA "amethystine","amherst","ami","amicable","amid","amide","amidst","amigo","amino","aminobenzoic","amiss","amity","amman","ammerman","ammeter","ammo","ammonia","ammoniac","ammonium","ammunition"
DATA "amnesia","amoco","amoeba","amoebae","amok","among","amongst","amoral","amorous","amorphous","amort","amos","amount","amp","amperage","ampere","ampersand","ampex","amphetamine","amphibian"
DATA "amphibious","amphibole","amphibology","amphioxis","ample","amplifier","amplify","amplitude","amply","amputate","amputee","amra","amsterdam","amtrak","amulet","amuse","amy","amygdaloid","an","ana"
DATA "anabaptist","anabel","anachronism","anachronistic","anaconda","anaerobic","anaglyph","anagram","anaheim","analeptic","analgesic","analogous","analogue","analogy","analyses","analysis","analyst","analytic","anamorphic","anaplasmosis"
DATA "anarch","anarchic","anarchy","anastasia","anastigmat","anastigmatic","anastomosis","anastomotic","anathema","anatole","anatomic","anatomy","ancestor","ancestral","ancestry","anchor","anchorage","anchorite","anchoritism","anchovy"
DATA "ancient","ancillary","and","andean","andersen","anderson","andes","andesine","andesite","andiron","andorra","andover","andre","andrea","andrei","andrew","andrews","andromache","andromeda","andy"
DATA "anecdotal","anecdote","anemone","anent","anew","angel","angela","angeles","angelfish","angelic","angelica","angelina","angeline","angelo","anger","angie","angiosperm","angle","angles","anglican"
DATA "anglicanism","angling","anglo","anglophobia","angola","angora","angry","angst","angstrom","anguish","angular","angus","anharmonic","anheuser","anhydride","anhydrite","anhydrous","ani","aniline","animadversion"
DATA "animadvert","animal","animate","animism","animosity","anion","anionic","anise","aniseikonic","anisotropic","anisotropy","anita","ankara","ankle","ann","anna","annal","annale","annalen","annals"
DATA "annapolis","anne","anneal","annette","annex","annie","annihilate","anniversary","annotate","announce","annoy","annoyance","annual","annuity","annul","annular","annuli","annulled","annulling","annulus"
DATA "annum","annunciate","anode","anodic","anomalous","anomaly","anomie","anonymity","anonymous","anorexia","anorthic","anorthite","anorthosite","another","anselm","anselmo","ansi","answer","ant","antacid"
DATA "antaeus","antagonism","antagonist","antagonistic","antarctic","antarctica","antares","ante","anteater","antebellum","antecedent","antedate","antelope","antenna","antennae","anterior","anteroom","anthem","anther","anthology"
DATA "anthony","anthracite","anthracnose","anthropogenic","anthropology","anthropomorphic","anthropomorphism","anti","antic","anticipate","anticipatory","antietam","antigen","antigone","antigorite","antimony","antioch","antipasto","antipathy","antiperspirant"
DATA "antiphonal","antipode","antipodean","antipodes","antiquarian","antiquary","antiquated","antique","antiquity","antisemite","antisemitic","antisemitism","antithetic","antler","antoine","antoinette","anton","antonio","antony","antonym"
DATA "antwerp","anus","anvil","anxiety","anxious","any","anybody","anybody'd","anyhow","anyone","anyplace","anything","anyway","anywhere","aorta","apace","apache","apart","apartheid","apathetic"
DATA "apathy","apatite","ape","aperiodic","aperture","apex","aphasia","aphasic","aphelion","aphid","aphorism","aphrodite","apices","apiece","aplomb","apocalypse","apocalyptic","apocrypha","apocryphal","apogee"
DATA "apollo","apollonian","apologetic","apologia","apology","apostate","apostle","apostolic","apostrophe","apothecary","apothegm","apotheosis","appalachia","appall","appanage","apparatus","apparel","apparent","apparition","appeal"
DATA "appear","appearance","appeasable","appease","appellant","appellate","append","appendage","appendices","appendix","apperception","appertain","appetite","appian","applaud","applause","apple","appleby","applejack","appleton"
DATA "appliance","applicable","applicant","applicate","application","applied","applique","apply","appoint","appointe","appointee","apport","apportion","apposite","apposition","appraisal","appraise","appreciable","appreciate","apprehend"
DATA "apprehension","apprehensive","apprentice","apprise","approach","approbation","appropriable","appropriate","approval","approve","approximable","approximant","approximate","apr","apricot","april","apron","apropos","aps","apse"
DATA "apt","aptitude","aqua","aquarium","aquarius","aquatic","aqueduct","aqueous","aquila","aquinas","ar","arab","arabesque","arabia","arabic","araby","arachne","arachnid","arbiter","arbitrage"
DATA "arbitrary","arbitrate","arboreal","arboretum","arbutus","arc","arcade","arcadia","arcana","arcane","arccos","arccosine","arch","archae","archaic","archaism","archangel","archbishop","archdiocese","archenemy"
DATA "archer","archery","archetype","archetypical","archfool","archibald","archimedes","arching","archipelago","architect","architectonic","architectural","architecture","archival","archive","arcing","arclength","arcsin","arcsine","arctan"
DATA "arctangent","arctic","arcturus","arden","ardency","ardent","arduous","are","area","areaway","areawide","aren't","arena","arenaceous","arequipa","ares","argentina","argillaceous","arginine","argive"
DATA "argo","argon","argonaut","argonne","argot","argue","argument","argumentation","argumentative","argus","arhat","ariadne","arianism","arid","aries","arise","arisen","aristocracy","aristocrat","aristocratic"
DATA "aristotelean","aristotelian","aristotle","arithmetic","arizona","ark","arkansan","arkansas","arlen","arlene","arlington","arm","armada","armadillo","armageddon","armament","armata","armature","armchair","armco"
DATA "armenia","armenian","armful","armhole","armillaria","armistice","armload","armoire","armonk","armour","armpit","armstrong","army","arnold","aroma","aromatic","arose","around","arousal","arouse"
DATA "arpa","arpeggio","arrack","arragon","arraign","arrange","arrangeable","array","arrear","arrest","arrhenius","arrival","arrive","arrogant","arrogate","arrow","arrowhead","arrowroot","arroyo","arsenal"
DATA "arsenate","arsenic","arsenide","arsine","arson","art","artemis","artemisia","arterial","arteriole","arteriolosclerosis","arteriosclerosis","artery","artful","arthritis","arthur","artichoke","article","articulate","articulatory"
DATA "artie","artifact","artifice","artificial","artillery","artisan","artistry","arturo","artwork","arty","aruba","arum","aryl","as","asbestos","ascend","ascendant","ascension","ascent","ascertain"
DATA "ascetic","asceticism","ascomycetes","ascribe","ascription","aseptic","asexual","ash","ashame","ashamed","ashen","asher","asheville","ashland","ashley","ashman","ashmen","ashmolean","ashore","ashtray"
DATA "ashy","asia","asiatic","aside","asilomar","asinine","ask","askance","askew","asleep","asocial","asparagine","asparagus","aspartic","aspect","aspen","asperity","aspersion","asphalt","aspheric"
DATA "asphyxiate","aspidistra","aspirant","aspirate","aspire","aspirin","asplenium","ass","assai","assail","assailant","assam","assassin","assassinate","assault","assay","assemblage","assemble","assent","assert"
DATA "assess","assessor","asset","assiduity","assiduous","assign","assignation","assignee","assimilable","assimilate","assist","assistant","associable","associate","assonant","assort","assuage","assume","assumption","assurance"
DATA "assure","assyria","assyriology","astarte","astatine","aster","asteria","asterisk","asteroid","asteroidal","asthma","astigmat","astigmatic","astigmatism","astm","astonish","astor","astoria","astound","astraddle"
DATA "astral","astray","astride","astringent","astrology","astronaut","astronautic","astronomer","astronomic","astronomy","astrophysical","astrophysicist","astrophysics","astute","asuncion","asunder","asylum","asymmetry","asymptote","asymptotic"
DATA "asynchronous","asynchrony","at","at&t","atalanta","atavism","atavistic","atchison","ate","athabascan","atheism","atheist","athena","athenian","athens","athlete","athletic","athwart","atkins","atkinson"
DATA "atlanta","atlantes","atlantic","atlantica","atlantis","atlas","atmosphere","atmospheric","atom","atomic","atonal","atone","atop","atreus","atrium","atrocious","atrocity","atrophic","atrophy","atropos"
DATA "attach","attache","attack","attain","attainder","attempt","attend","attendant","attendee","attention","attentive","attenuate","attest","attestation","attic","attica","attire","attitude","attitudinal","attorney"
DATA "attract","attribute","attribution","attributive","attrition","attune","atwater","atwood","atypic","auberge","aubrey","auburn","auckland","auction","auctioneer","audacious","audacity","audible","audience","audio"
DATA "audiotape","audiovisual","audit","audition","auditor","auditorium","auditory","audrey","audubon","auerbach","aug","augean","augend","auger","augite","augment","augmentation","augur","august","augusta"
DATA "augustan","augustine","augustus","auk","aunt","auntie","aura","aural","aurelius","aureomycin","auric","auriga","aurochs","aurora","auschwitz","auspices","auspicious","austenite","austere","austin"
DATA "australia","australis","australite","austria","authentic","authenticate","author","authoritarian","authoritative","autism","autistic","auto","autobiography","autoclave","autocollimate","autocorrelate","autocracy","autocrat","autocratic","autograph"
DATA "automat","automata","automate","automatic","automaton","automobile","automorphic","automorphism","automotive","autonomic","autonomous","autonomy","autopsy","autosuggestible","autotransformer","autumn","autumnal","auxiliary","avail","avalanche"
DATA "avarice","avaricious","ave","avenge","aventine","avenue","aver","average","averred","averring","averse","aversion","avert","avertive","avery","avesta","aviary","aviate","aviatrix","avid"
DATA "avionic","avis","aviv","avocado","avocate","avocation","avocet","avogadro","avoid","avoidance","avon","avow","avowal","avuncular","await","awake","awaken","award","aware","awash"
DATA "away","awe","awesome","awful","awhile","awkward","awl","awn","awoke","awry","ax","axe","axes","axial","axiology","axiom","axiomatic","axis","axisymmetric","axle"
DATA "axolotl","axon","aye","ayers","aylesbury","az","azalea","azerbaijan","azimuth","azimuthal","aztec","aztecan","azure","b","b's","babbitt","babble","babcock","babe","babel"
DATA "baboon","baby","babyhood","babylon","babylonian","babysat","babysit","babysitter","babysitting","baccalaureate","baccarat","bacchus","bach","bachelor","bacilli","bacillus","back","backboard","backbone","backdrop"
DATA "backfill","backgammon","background","backhand","backlash","backlog","backorder","backpack","backplane","backplate","backscatter","backside","backspace","backstage","backstitch","backstop","backtrack","backup","backward","backwater"
DATA "backwood","backyard","bacon","bacteria","bacterial","bacterium","bad","bade","baden","badge","badinage","badland","badminton","baffin","baffle","bag","bagatelle","bagel","baggage","bagging"
DATA "baggy","baghdad","bagley","bagpipe","bah","bahama","bahrein","bail","bailey","bailiff","bainite","baird","bait","bake","bakelite","bakersfield","bakery","bakhtiari","baklava","baku"
DATA "balance","balboa","balcony","bald","baldpate","baldwin","baldy","bale","baleen","baleful","balfour","bali","balinese","balk","balkan","balky","ball","ballad","ballard","ballast"
DATA "balled","ballerina","ballet","balletic","balletomane","ballfield","balloon","ballot","ballroom","ballyhoo","balm","balmy","balsa","balsam","baltic","baltimore","baltimorean","balustrade","balzac","bam"
DATA "bamako","bamberger","bambi","bamboo","ban","banach","banal","banana","banbury","band","bandage","bandgap","bandit","bandpass","bandstand","bandstop","bandwagon","bandwidth","bandy","bane"
DATA "baneberry","baneful","bang","bangkok","bangladesh","bangle","bangor","bangui","banish","banister","banjo","bank","bankrupt","bankruptcy","banks","banquet","banshee","bantam","banter","bantu"
DATA "bantus","baptism","baptismal","baptist","baptiste","baptistery","bar","barb","barbados","barbara","barbarian","barbaric","barbarism","barbarous","barbecue","barbell","barber","barberry","barbital","barbiturate"
DATA "barbour","barbudo","barcelona","barclay","bard","bare","barefaced","barefoot","barfly","bargain","barge","baritone","barium","bark","barkeep","barley","barlow","barn","barnabas","barnacle"
DATA "barnard","barnes","barnet","barnett","barney","barnhard","barnstorm","barnyard","barometer","baron","baroness","baronet","baronial","barony","baroque","barr","barrack","barracuda","barrage","barre"
DATA "barrel","barren","barrett","barrette","barricade","barrier","barrington","barrow","barry","barrymore","barstow","bart","bartend","bartender","barter","barth","bartholomew","bartlett","bartok","barton"
DATA "barycentric","basal","basalt","base","baseball","baseband","baseboard","basel","baseline","baseman","basemen","baseplate","basepoint","bash","bashaw","bashful","basic","basidiomycetes","basil","basilar"
DATA "basilisk","basin","basis","bask","basket","basketball","basophilic","bass","bassett","bassi","bassinet","basso","basswood","bastard","baste","bastion","bat","batavia","batch","batchelder"
DATA "bate","bateau","bateman","bater","bates","bath","bathe","bathos","bathrobe","bathroom","bathtub","bathurst","batik","baton","bator","batt","battalion","battelle","batten","battery"
DATA "battle","battlefield","battlefront","battleground","batwing","bauble","baud","baudelaire","bauer","bauhaus","bausch","bauxite","bavaria","bawd","bawdy","bawl","baxter","bay","bayberry","bayda"
DATA "bayed","bayesian","baylor","bayonet","bayonne","bayou","bayport","bayreuth","bazaar","be","beach","beachcomb","beachhead","beacon","bead","beadle","beady","beak","beam","bean"
DATA "bear","bearberry","beard","beardsley","bearish","beast","beastie","beat","beaten","beater","beatific","beatify","beatitude","beatnik","beatrice","beau","beaujolais","beaumont","beauregard","beauteous"
DATA "beautiful","beautify","beauty","beaux","beaver","bebop","becalm","became","because","bechtel","beck","becker","becket","beckman","beckon","becky","becloud","become","bed","bedazzle"
DATA "bedbug","bedevil","bedfast","bedford","bedim","bedimmed","bedimming","bedlam","bedpost","bedraggle","bedridden","bedrock","bedroom","bedside","bedspread","bedspring","bedstraw","bedtime","bee","beebe"
DATA "beebread","beech","beecham","beechwood","beef","beefsteak","beefy","beehive","been","beep","beer","beet","beethoven","beetle","befall","befallen","befell","befit","befitting","befog"
DATA "befogging","before","beforehand","befoul","befuddle","beg","began","beget","begetting","beggar","beggary","begging","begin","beginner","beginning","begonia","begotten","begrudge","beguile","begun"
DATA "behalf","behave","behavioral","behead","beheld","behest","behind","behold","beige","beijing","being","beirut","bel","bela","belate","belch","belfast","belfry","belgian","belgium"
DATA "belgrade","belie","belief","belies","believe","belittle","bell","bella","belladonna","bellamy","bellatrix","bellboy","belle","bellflower","bellhop","bellicose","belligerent","bellingham","bellini","bellman"
DATA "bellmen","bellow","bellum","bellwether","belly","bellyache","bellyfull","belmont","beloit","belong","belove","below","belshazzar","belt","beltsville","belvedere","belvidere","belying","bema","bemadden"
DATA "beman","bemoan","bemuse","ben","bench","benchmark","bend","bender","bendix","beneath","benedict","benedictine","benediction","benedikt","benefactor","benefice","beneficent","beneficial","beneficiary","benefit"
DATA "benelux","benevolent","bengal","bengali","benight","benign","benjamin","bennett","bennington","benny","benson","bent","bentham","benthic","bentley","benton","benz","benzedrine","benzene","beograd"
DATA "beowulf","beplaster","bequeath","bequest","berate","berea","bereave","bereft","berenices","beresford","beret","berg","bergamot","bergen","bergland","berglund","bergman","bergson","bergstrom","beribbon"
DATA "beriberi","berkeley","berkelium","berkowitz","berkshire","berlin","berlioz","berlitz","berman","bermuda","bern","bernadine","bernard","bernardino","bernardo","berne","bernet","bernhard","bernice","bernie"
DATA "berniece","bernini","bernoulli","bernstein","berra","berry","berserk","bert","berth","bertha","bertie","bertram","bertrand","berwick","beryl","beryllium","beseech","beset","besetting","beside"
DATA "besiege","besmirch","besotted","bespeak","bespectacled","bespoke","bess","bessel","bessemer","bessie","best","bestial","bestir","bestirring","bestow","bestowal","bestseller","bestselling","bestubble","bet"
DATA "beta","betatron","betel","betelgeuse","beth","bethel","bethesda","bethlehem","bethought","betide","betoken","betony","betray","betrayal","betrayer","betroth","betrothal","betsey","betsy","bette"
DATA "bettor","betty","between","betwixt","bevel","beverage","beverly","bevy","bewail","beware","bewhisker","bewilder","bewitch","bey","beyond","bezel","bhoy","bhutan","bialystok","bianco"
DATA "bias","biaxial","bib","bibb","bible","biblical","bibliography","bibliophile","bicameral","bicarbonate","bicentennial","bicep","biceps","bichromate","bicker","biconcave","biconnected","bicycle","bid","biddable"
DATA "bidden","biddy","bide","bidiagonal","bidirectional","bien","biennial","biennium","bifocal","bifurcate","big","bigelow","biggs","bigot","bigotry","biharmonic","bijection","bijective","bijouterie","bike"
DATA "bikini","bilabial","bilateral","bilayer","bile","bilge","bilharziasis","bilinear","bilingual","bilk","bill","billboard","billet","billfold","billiard","billie","billiken","billings","billion","billionth"
DATA "billow","billy","biltmore","bimetallic","bimetallism","bimini","bimodal","bimolecular","bimonthly","bin","binary","binaural","bind","bindery","bindle","bindweed","bing","binge","bingham","binghamton"
DATA "bingle","bini","binocular","binomial","binuclear","biochemic","biography","biology","biometrika","biometry","biopsy","biota","biotic","biotite","bipartisan","bipartite","biplane","bipolar","biracial","birch"
DATA "bird","birdbath","birdie","birdlike","birdseed","birdwatch","birefringent","birgit","birmingham","birth","birthday","birthplace","birthright","biscuit","bisect","bisexual","bishop","bishopric","bismarck","bismark"
DATA "bismuth","bison","bisque","bissau","bistable","bistate","bit","bitch","bite","bitnet","bitt","bitten","bittern","bitternut","bitterroot","bittersweet","bitumen","bituminous","bitwise","bivalve"
DATA "bivariate","bivouac","biz","bizarre","bizet","blab","black","blackball","blackberry","blackbird","blackboard","blackbody","blackburn","blacken","blackfeet","blackjack","blackmail","blackman","blackout","blacksmith"
DATA "blackstone","blackwell","bladder","bladdernut","bladderwort","blade","blaine","blair","blake","blame","blameworthy","blanc","blanch","blanchard","blanche","bland","blandish","blank","blanket","blare"
DATA "blaspheme","blasphemous","blasphemy","blast","blastula","blat","blatant","blather","blatz","blaze","blazon","bleach","bleak","bleary","bleat","bled","bleed","bleeker","blemish","blend"
DATA "blenheim","bless","blest","blew","blight","blimp","blind","blindfold","blink","blinn","blip","bliss","blissful","blister","blithe","blitz","blizzard","bloat","blob","bloc"
DATA "bloch","block","blockade","blockage","blockhouse","blocky","bloke","blomberg","blomquist","blond","blonde","blood","bloodbath","bloodhound","bloodline","bloodroot","bloodshed","bloodshot","bloodstain","bloodstone"
DATA "bloodstream","bloody","bloom","bloomfield","bloomington","bloop","blossom","blot","blotch","blouse","blow","blowback","blowfish","blown","blowup","blubber","bludgeon","blue","blueback","blueberry"
DATA "bluebill","bluebird","bluebonnet","bluebook","bluebush","bluefish","bluegill","bluegrass","bluejacket","blueprint","bluestocking","bluet","bluff","bluish","blum","blumenthal","blunder","blunt","blur","blurb"
DATA "blurry","blurt","blush","bluster","blustery","blutwurst","blvd","blythe","bmw","boa","boar","board","boardinghouse","boast","boastful","boat","boathouse","boatload","boatman","boatmen"
DATA "boatswain","boatyard","bob","bobbie","bobbin","bobble","bobby","bobcat","bobolink","boca","bock","bocklogged","bode","bodhisattva","bodice","bodied","bodleian","body","bodybuild","bodybuilder"
DATA "bodybuilding","bodyguard","boeing","boeotia","boeotian","bog","bogey","bogeymen","bogging","boggle","boggy","bogota","bogus","bogy","bohemia","bohr","boil","bois","boise","boisterous"
DATA "bold","boldface","bole","boletus","bolivar","bolivia","bolo","bologna","bolometer","bolshevik","bolshevism","bolshevist","bolshoi","bolster","bolt","bolton","boltzmann","bomb","bombard","bombast"
DATA "bombastic","bombay","bombproof","bon","bona","bonanza","bonaparte","bonaventure","bond","bondage","bondholder","bondsman","bondsmen","bone","bonfire","bong","bongo","boniface","bonito","bonn"
DATA "bonnet","bonneville","bonnie","bonus","bony","bonze","boo","booby","boogie","book","bookbind","bookcase","bookend","bookie","bookish","bookkeep","booklet","bookmobile","bookplate","bookseller"
DATA "bookshelf","bookshelves","bookstore","booky","boolean","boom","boomerang","boon","boone","boor","boorish","boost","boot","bootes","booth","bootleg","bootlegged","bootlegger","bootlegging","bootstrap"
DATA "bootstrapped","bootstrapping","booty","booze","bop","borate","borax","bordeaux","bordello","borden","border","borderland","borderline","bore","borealis","boreas","boredom","borg","boric","boris"
DATA "born","borne","borneo","boron","borosilicate","borough","borroughs","borrow","bosch","bose","bosom","boson","bosonic","boss","boston","bostonian","boswell","botanic","botanist","botany"
DATA "botch","botfly","both","bothersome","botswana","bottle","bottleneck","bottom","bottommost","botulin","botulism","boucher","bouffant","bough","bought","boulder","boule","boulevard","bounce","bouncy"
DATA "bound","boundary","bounty","bouquet","bourbaki","bourbon","bourgeois","bourgeoisie","bourn","boustrophedon","bout","boutique","bovine","bow","bowditch","bowdoin","bowel","bowen","bowfin","bowie"
DATA "bowl","bowline","bowman","bowmen","bowstring","box","boxcar","boxwood","boxy","boy","boyar","boyce","boycott","boyd","boyfriend","boyhood","boyish","boyle","boylston","bp"
DATA "brace","bracelet","bracken","bracket","brackish","bract","brad","bradbury","bradford","bradley","bradshaw","brady","brae","brag","bragg","braggart","bragging","brahmaputra","brahms","brahmsian"
DATA "braid","braille","brain","brainard","brainchild","brainchildren","brainstorm","brainwash","brainy","brake","brakeman","bramble","bran","branch","brand","brandeis","brandenburg","brandish","brandon","brandt"
DATA "brandy","brandywine","braniff","brant","brash","brasilia","brass","brassiere","brassy","bratwurst","braun","bravado","brave","bravery","bravo","bravura","brawl","bray","brazen","brazier"
DATA "brazil","brazilian","brazzaville","breach","bread","breadboard","breadfruit","breadroot","breadth","breadwinner","break","breakage","breakaway","breakdown","breakfast","breakoff","breakpoint","breakthrough","breakup","breakwater"
DATA "bream","breast","breastplate","breastwork","breath","breathe","breathtaking","breathy","breccia","bred","breech","breeches","breed","breeze","breezy","bremen","bremsstrahlung","brenda","brendan","brennan"
DATA "brenner","brent","brest","brethren","breton","brett","breve","brevet","brevity","brew","brewery","brewster","brian","briar","bribe","bribery","brice","brick","brickbat","bricklay"
DATA "bricklayer","bricklaying","bridal","bride","bridegroom","bridesmaid","bridge","bridgeable","bridgehead","bridgeport","bridget","bridgetown","bridgewater","bridgework","bridle","brief","briefcase","brig","brigade","brigadier"
DATA "brigantine","briggs","brigham","bright","brighten","brighton","brilliant","brillouin","brim","brimful","brimstone","brindisi","brindle","brine","bring","brink","brinkmanship","briny","brisbane","brisk"
DATA "bristle","bristol","britain","britannic","britannica","britches","british","briton","brittany","britten","brittle","broach","broad","broadcast","broaden","broadloom","broadside","broadway","brocade","broccoli"
DATA "brochure","brock","brockle","broglie","broil","broke","broken","brokerage","bromfield","bromide","bromine","bromley","bronchi","bronchial","bronchiolar","bronchiole","bronchitis","bronchus","bronco","brontosaurus"
DATA "bronx","bronze","bronzy","brood","broody","brook","brooke","brookhaven","brookline","brooklyn","brookside","broom","broomcorn","broth","brothel","brother","brotherhood","brought","brouhaha","brow"
DATA "browbeaten","brown","browne","brownell","brownian","brownie","brownish","browse","bruce","brucellosis","bruckner","bruegel","bruise","bruit","brumidi","brunch","brunette","brunhilde","bruno","brunswick"
DATA "brunt","brush","brushfire","brushlike","brushwork","brushy","brusque","brussels","brutal","brute","bryan","bryant","bryce","bryn","bryophyta","bryophyte","bryozoa","bstj","btl","btu"
DATA "bub","bubble","buchanan","bucharest","buchenwald","buchwald","buck","buckaroo","buckboard","bucket","bucketfull","buckeye","buckhorn","buckle","buckley","bucknell","buckshot","buckskin","buckthorn","buckwheat"
DATA "bucolic","bud","budapest","budd","buddha","buddhism","buddhist","buddy","budge","budget","budgetary","budweiser","buena","buenos","buff","buffalo","buffet","bufflehead","buffoon","bug"
DATA "bugaboo","bugeyed","bugging","buggy","bugle","buick","build","buildup","built","builtin","bujumbura","bulb","bulblet","bulgaria","bulge","bulk","bulkhead","bulky","bull","bulldog"
DATA "bulldoze","bullet","bulletin","bullfinch","bullfrog","bullhead","bullhide","bullish","bullock","bullseye","bullwhack","bully","bullyboy","bulrush","bulwark","bum","bumble","bumblebee","bump","bumptious"
DATA "bun","bunch","bundestag","bundle","bundoora","bundy","bungalow","bungle","bunk","bunkmate","bunny","bunsen","bunt","bunyan","buoy","buoyant","burbank","burch","burden","burdensome"
DATA "burdock","bureau","bureaucracy","bureaucrat","bureaucratic","buret","burette","burg","burgeon","burgess","burgher","burglar","burglarproof","burglary","burgundian","burgundy","burial","buried","burke","burl"
DATA "burlap","burlesque","burley","burlington","burly","burma","burmese","burn","burnett","burnham","burnish","burnout","burnside","burnt","burp","burr","burro","burroughs","burrow","bursitis"
DATA "burst","bursty","burt","burton","burtt","burundi","bury","bus","busboy","busch","buses","bush","bushel","bushmaster","bushnell","bushwhack","bushy","business","businessman","businessmen"
DATA "buss","bust","bustard","bustle","busy","but","butadiene","butane","butch","butchery","butene","buteo","butler","butt","butte","butterball","buttercup","butterfat","butterfield","butterfly"
DATA "buttermilk","butternut","buttery","buttock","button","buttonhole","buttonweed","buttress","buttrick","butyl","butyrate","butyric","buxom","buxtehude","buxton","buy","buyer","buzz","buzzard","buzzer"
DATA "buzzing","buzzsaw","buzzword","buzzy","by","bye","byers","bygone","bylaw","byline","bypass","bypath","byproduct","byrd","byrne","byroad","byron","byronic","bystander","byte"
DATA "byway","byword","byzantine","byzantium","c","c's","ca","cab","cabal","cabana","cabaret","cabbage","cabdriver","cabin","cabinet","cabinetmake","cabinetry","cable","cabot","cacao"
DATA "cachalot","cache","cackle","cacm","cacophonist","cacophony","cacti","cactus","cadaver","cadaverous","caddis","caddy","cadent","cadenza","cadet","cadillac","cadmium","cadre","cady","caesar"
DATA "cafe","cafeteria","cage","cagey","cahill","cahoot","caiman","cain","caine","cairn","cairo","cajole","cake","cal","calais","calamitous","calamity","calamus","calcareous","calcify"
DATA "calcine","calcite","calcium","calculable","calculate","calculi","calculus","calcutta","calder","caldera","caldwell","caleb","calendar","calendrical","calf","calfskin","calgary","calhoun","caliber","calibrate"
DATA "calibre","calico","california","californium","caliper","caliph","caliphate","calisthenic","calkins","call","calla","callaghan","callahan","caller","calligraph","calligraphy","calliope","callisto","callous","callus"
DATA "calm","caloric","calorie","calorimeter","calumet","calumniate","calumny","calvary","calve","calvert","calvin","calvinist","calypso","cam","camaraderie","camber","cambodia","cambrian","cambric","cambridge"
DATA "camden","came","camel","camelback","camellia","camelopard","camelot","cameo","camera","cameraman","cameramen","cameron","cameroun","camilla","camille","camino","camouflage","camp","campaign","campanile"
DATA "campbell","campfire","campground","campion","campsite","campus","can","can't","canaan","canada","canadian","canal","canary","canaveral","canberra","cancel","cancellate","cancelled","cancelling","cancer"
DATA "cancerous","candace","candela","candelabra","candid","candidacy","candidate","candide","candle","candlelight","candlelit","candlestick","candlewick","candy","cane","canfield","canine","canis","canister","canker"
DATA "cankerworm","canna","cannabis","cannel","cannery","cannibal","cannister","cannon","cannonball","cannot","canny","canoe","canoga","canon","canonic","canopy","canst","cant","cantabrigian","cantaloupe"
DATA "canteen","canterbury","canterelle","canticle","cantilever","cantle","canto","canton","cantonese","cantor","canvas","canvasback","canvass","canyon","cap","capacious","capacitance","capacitate","capacitive","capacitor"
DATA "capacity","cape","capella","caper","capetown","capillary","capistrano","capita","capital","capitol","capitoline","capitulate","capo","caprice","capricious","capricorn","capsize","capstan","capstone","capsule"
DATA "captain","captaincy","caption","captious","captivate","captive","captor","capture","caputo","capybara","car","carabao","caracas","caramel","caravan","caraway","carbide","carbine","carbohydrate","carboloy"
DATA "carbon","carbonaceous","carbonate","carbondale","carbone","carbonic","carbonium","carbonyl","carborundum","carboxy","carboxylic","carboy","carbuncle","carburetor","carcass","carcinogen","carcinogenic","carcinoma","card","cardamom"
DATA "cardboard","cardiac","cardiff","cardinal","cardiod","cardioid","cardiology","cardiovascular","care","careen","career","carefree","careful","caress","caret","caretaker","careworn","carey","carfare","cargill"
DATA "cargo","cargoes","carib","caribbean","caribou","caricature","carl","carla","carleton","carlin","carlisle","carlo","carload","carlson","carlton","carlyle","carmela","carmen","carmichael","carmine"
DATA "carnage","carnal","carnation","carne","carnegie","carney","carnival","carob","carol","carolina","caroline","carolingian","carolinian","carolyn","carouse","carp","carpathia","carpenter","carpentry","carpet"
DATA "carport","carr","carrageen","carrara","carrel","carriage","carrie","carrion","carroll","carrot","carruthers","carry","carryover","carson","cart","carte","cartel","cartesian","carthage","carthaginian"
DATA "cartilage","cartilaginous","cartographer","cartographic","cartography","carton","cartoon","cartridge","cartwheel","caruso","carve","carven","caryatid","casanova","casbah","cascade","cascara","case","casebook","casein"
DATA "casework","casey","cash","cashew","cashier","cashmere","casino","cask","casket","caspian","cassandra","casserole","cassette","cassiopeia","cassius","cassock","cast","castanet","caste","casteth"
DATA "castigate","castillo","castle","castor","castro","casual","casualty","cat","catabolic","cataclysm","cataclysmic","catalina","catalogue","catalpa","catalysis","catalyst","catalytic","catapult","cataract","catastrophe"
DATA "catastrophic","catatonia","catatonic","catawba","catbird","catcall","catch","catchup","catchword","catchy","catechism","categoric","category","catenate","cater","caterpillar","catfish","catharsis","cathedra","cathedral"
DATA "catherine","catherwood","catheter","cathode","cathodic","catholic","catholicism","cathy","cation","cationic","catkin","catlike","catnip","catskill","catsup","cattail","cattle","cattleman","cattlemen","catv"
DATA "caucasian","caucasus","cauchy","caucus","caught","cauldron","cauliflower","caulk","causal","causate","causation","cause","caustic","caution","cautionary","cautious","cavalcade","cavalier","cavalry","cave"
DATA "caveat","caveman","cavemen","cavendish","cavern","cavernous","caviar","cavil","cavilling","caviness","cavitate","cavort","caw","cayenne","cayley","cayuga","cb","cbs","ccny","cdc"
DATA "cease","cecil","cecilia","cecropia","cedar","cede","cedilla","cedric","ceil","celandine","celanese","celebes","celebrant","celebrate","celebrity","celerity","celery","celesta","celeste","celestial"
DATA "celia","celibacy","cell","cellar","cellophane","cellular","celluloid","cellulose","celsius","celtic","cement","cemetery","cenozoic","censor","censorial","censorious","censure","census","cent","centaur"
DATA "centenary","centennial","centerline","centerpiece","centigrade","centimeter","centipede","central","centrex","centric","centrifugal","centrifugate","centrifuge","centrist","centroid","centum","century","cepheus","ceq","ceramic"
DATA "ceramium","cerberus","cereal","cerebellum","cerebral","cerebrate","ceremonial","ceremonious","ceremony","ceres","cereus","cerise","cerium","cern","certain","certainty","certificate","certified","certify","certiorari"
DATA "certitude","cerulean","cervantes","cervix","cesare","cesium","cessation","cession","cessna","cetera","cetus","ceylon","cezanne","cf","chablis","chad","chadwick","chafe","chaff","chagrin"
DATA "chain","chair","chairlady","chairman","chairmen","chairperson","chairwoman","chairwomen","chaise","chalcedony","chalcocite","chalet","chalice","chalk","chalkboard","chalkline","chalky","challenge","chalmers","chamber"
DATA "chamberlain","chambermaid","chambers","chameleon","chamfer","chamois","chamomile","champ","champagne","champaign","champion","champlain","chance","chancel","chancellor","chancery","chancy","chandelier","chandler","chang"
DATA "change","changeable","changeover","channel","chanson","chant","chantey","chantilly","chantry","chao","chaos","chaotic","chap","chaparral","chapel","chaperon","chaperone","chaplain","chaplaincy","chaplin"
DATA "chapman","chapter","char","character","characteristic","charcoal","chard","charge","chargeable","chariot","charisma","charismatic","charitable","charity","charlemagne","charles","charleston","charley","charlie","charlotte"
DATA "charlottesville","charm","charon","chart","charta","chartres","chartreuse","chartroom","charybdis","chase","chasm","chassis","chaste","chastise","chastity","chat","chateau","chateaux","chatham","chattanooga"
DATA "chattel","chatty","chaucer","chauffeur","chauncey","chautauqua","chaw","cheap","cheat","cheater","check","checkbook","checkerberry","checkerboard","checklist","checkmate","checkout","checkpoint","checksum","checksummed"
DATA "checksumming","checkup","cheek","cheekbone","cheeky","cheer","cheerful","cheerlead","cheerleader","cheery","cheese","cheesecake","cheesecloth","cheesy","cheetah","chef","chelate","chemic","chemise","chemisorb"
DATA "chemisorption","chemist","chemistry","chemotherapy","chen","cheney","chenille","cherish","cherokee","cherry","chert","cherub","cherubim","cheryl","chesapeake","cheshire","chess","chest","chester","chesterton"
DATA "chestnut","chevalier","chevrolet","chevron","chevy","chew","cheyenne","chi","chiang","chianti","chic","chicago","chicagoan","chicanery","chicano","chick","chickadee","chicken","chickweed","chicory"
DATA "chide","chief","chiefdom","chieftain","chiffon","chigger","chignon","chilblain","child","childbear","childbirth","childhood","childish","childlike","children","chile","chilean","chili","chill","chilly"
DATA "chime","chimera","chimeric","chimique","chimney","chimpanzee","chin","china","chinaman","chinamen","chinatown","chinch","chinchilla","chine","chinese","chink","chinook","chinquapin","chip","chipboard"
DATA "chipmunk","chippendale","chiropractor","chirp","chisel","chisholm","chit","chiton","chivalrous","chivalry","chive","chlorate","chlordane","chloride","chlorinate","chlorine","chloroform","chlorophyll","chloroplast","chloroplatinate"
DATA "chock","chocolate","choctaw","choice","choir","choirmaster","choke","chokeberry","cholera","cholesterol","cholinesterase","chomp","chomsky","choose","choosy","chop","chopin","choppy","choral","chorale"
DATA "chord","chordal","chordata","chordate","chore","choreograph","choreography","chorine","chortle","chorus","chose","chosen","chou","chow","chowder","chris","christ","christen","christendom","christensen"
DATA "christenson","christian","christiana","christianson","christie","christina","christine","christlike","christmas","christoffel","christoph","christopher","christy","chromate","chromatic","chromatin","chromatogram","chromatograph","chromatography","chrome"
DATA "chromic","chromium","chromosome","chromosphere","chronic","chronicle","chronograph","chronography","chronology","chrysanthemum","chrysler","chrysolite","chub","chubby","chuck","chuckle","chuckwalla","chuff","chug","chugging"
DATA "chum","chummy","chump","chungking","chunk","chunky","church","churchgo","churchgoer","churchgoing","churchill","churchillian","churchman","churchmen","churchwoman","churchwomen","churchyard","churn","chute","chutney"
DATA "cia","cicada","cicero","ciceronian","cider","cigar","cigarette","cilia","ciliate","cinch","cincinnati","cinder","cinderella","cindy","cinema","cinematic","cinerama","cinnabar","cinnamon","cinquefoil"
DATA "cipher","circa","circe","circle","circlet","circuit","circuitous","circuitry","circulant","circular","circulate","circulatory","circumcircle","circumcise","circumcision","circumference","circumferential","circumflex","circumlocution","circumpolar"
DATA "circumscribe","circumscription","circumspect","circumsphere","circumstance","circumstantial","circumvent","circumvention","circus","cistern","cit","citadel","citation","cite","citizen","citizenry","citrate","citric","citroen","citron"
DATA "citrus","city","cityscape","citywide","civet","civic","civil","civilian","clad","cladophora","claim","claimant","claire","clairvoyant","clam","clamber","clammy","clamorous","clamp","clamshell"
DATA "clan","clandestine","clang","clank","clannish","clap","clapboard","clapeyron","clara","clare","claremont","clarence","clarendon","claret","clarify","clarinet","clarity","clark","clarke","clash"
DATA "clasp","class","classic","classification","classificatory","classify","classmate","classroom","classy","clatter","clattery","claude","claudia","claudio","claus","clause","clausen","clausius","claustrophobia","claustrophobic"
DATA "claw","clay","clayton","clean","cleanse","cleanup","clear","clearance","clearheaded","clearwater","cleat","cleavage","cleave","cleft","clement","clemson","clench","clergy","clergyman","clergymen"
DATA "cleric","clerk","cleveland","clever","cliche","click","client","clientele","cliff","cliffhang","clifford","clifton","climactic","climate","climatic","climatology","climax","climb","clime","clinch"
DATA "cling","clinging","clinic","clinician","clink","clint","clinton","clio","clip","clipboard","clique","clitoris","clive","cloak","cloakroom","clobber","clock","clockwatcher","clockwise","clockwork"
DATA "clod","cloddish","clog","clogging","cloister","clomp","clone","clonic","close","closet","closeup","closure","clot","cloth","clothbound","clothe","clothesbrush","clotheshorse","clothesline","clothesman"
DATA "clothesmen","clothier","clotho","cloture","cloud","cloudburst","cloudy","clout","clove","cloven","clown","cloy","club","clubhouse","clubroom","cluck","clue","cluj","clump","clumsy"
DATA "clung","cluster","clutch","clutter","clyde","clytemnestra","co","coach","coachman","coachmen","coachwork","coadjutor","coagulable","coagulate","coal","coalesce","coalescent","coalition","coarse","coarsen"
DATA "coast","coastal","coastline","coat","coates","coattail","coauthor","coax","coaxial","cobalt","cobb","cobble","cobblestone","cobol","cobra","cobweb","coca","cocaine","coccidiosis","cochineal"
DATA "cochlea","cochran","cochrane","cock","cockatoo","cockcrow","cockeye","cockle","cocklebur","cockleshell","cockpit","cockroach","cocksure","cocktail","cocky","coco","cocoa","coconut","cocoon","cod"
DATA "coda","coddington","coddle","code","codebreak","codeposit","codetermine","codeword","codfish","codicil","codify","codomain","codon","codpiece","cody","coed","coeditor","coeducation","coefficient","coequal"
DATA "coerce","coercible","coercion","coercive","coexist","coexistent","coextensive","cofactor","coffee","coffeecup","coffeepot","coffer","coffey","coffin","coffman","cog","cogent","cogitate","cognac","cognate"
DATA "cognition","cognitive","cognizable","cognizant","cohen","cohere","coherent","cohesion","cohesive","cohn","cohomology","cohort","cohosh","coiffure","coil","coin","coinage","coincide","coincident","coincidental"
DATA "coke","col","cola","colander","colatitude","colby","cold","cole","coleman","coleridge","colette","coleus","colgate","colicky","coliform","coliseum","collaborate","collage","collagen","collapse"
DATA "collapsible","collar","collarbone","collard","collate","collateral","colleague","collect","collectible","collector","college","collegial","collegian","collegiate","collet","collide","collie","collier","collimate","collinear"
DATA "collins","collision","collocation","colloidal","colloq","colloquia","colloquial","colloquium","colloquy","collude","collusion","cologne","colombia","colombo","colon","colonel","colonial","colonist","colonnade","colony"
DATA "colorado","colorate","coloratura","colorimeter","colossal","colosseum","colossi","colossus","colt","coltish","coltsfoot","columbia","columbine","columbus","column","columnar","colza","coma","comanche","comatose"
DATA "comb","combat","combatant","combatted","combinate","combination","combinator","combinatorial","combinatoric","combine","combustible","combustion","come","comeback","comedian","comedy","comet","cometary","cometh","comfort"
DATA "comic","cominform","comma","command","commandant","commandeer","commando","commemorate","commend","commendation","commendatory","commensurable","commensurate","comment","commentary","commentator","commerce","commercial","commingle","commiserate"
DATA "commissariat","commissary","commission","commit","committable","committal","committed","committee","committeeman","committeemen","committeewoman","committeewomen","committing","commodious","commodity","commodore","common","commonality","commonplace","commonweal"
DATA "commonwealth","commotion","communal","commune","communicable","communicant","communicate","communion","communique","commutate","commute","compact","compacter","compactify","compagnie","companion","companionway","company","comparative","comparator"
DATA "compare","comparison","compartment","compass","compassion","compassionate","compatible","compatriot","compel","compellable","compelled","compelling","compendia","compendium","compensable","compensate","compensatory","compete","competent","competition"
DATA "competitive","competitor","compilation","compile","complacent","complain","complainant","complaint","complaisant","compleat","complement","complementarity","complementary","complementation","complete","completion","complex","complexion","compliant","complicate"
DATA "complicity","compliment","complimentary","compline","comply","component","componentry","comport","compose","composite","composition","compositor","compost","composure","compote","compound","comprehend","comprehensible","comprehension","comprehensive"
DATA "compress","compressible","compression","compressive","compressor","comprise","compromise","compton","comptroller","compulsion","compulsive","compulsory","compunction","computation","compute","comrade","con","conakry","conant","concatenate"
DATA "concave","conceal","concede","conceit","conceive","concentrate","concentric","concept","conception","conceptual","concern","concert","concerti","concertina","concertmaster","concerto","concession","concessionaire","conch","concierge"
DATA "conciliate","conciliatory","concise","concision","conclave","conclude","conclusion","conclusive","concoct","concocter","concomitant","concord","concordant","concourse","concrete","concretion","concubine","concur","concurred","concurrent"
DATA "concurring","concussion","condemn","condemnate","condemnatory","condensate","condense","condensible","condescend","condescension","condiment","condition","condolence","condominium","condone","conduce","conducive","conduct","conductance","conductor"
DATA "conduit","cone","coneflower","conestoga","coney","confabulate","confect","confectionery","confederacy","confederate","confer","conferee","conference","conferrable","conferred","conferring","confess","confession","confessor","confidant"
DATA "confidante","confide","confident","confidential","configuration","configure","confine","confirm","confirmation","confirmatory","confiscable","confiscate","confiscatory","conflagrate","conflagration","conflict","confluent","confocal","conform","conformal"
DATA "conformance","conformation","confound","confrere","confront","confrontation","confucian","confucianism","confucius","confuse","confusion","confute","congeal","congener","congenial","congenital","congest","congestion","congestive","conglomerate"
DATA "congo","congolese","congratulate","congratulatory","congregate","congress","congressional","congressman","congressmen","congresswoman","congresswomen","congruent","conic","conifer","coniferous","conjectural","conjecture","conjoin","conjoint","conjugacy"
DATA "conjugal","conjugate","conjunct","conjuncture","conjure","conklin","conley","conn","connally","connect","connecticut","connector","conner","connie","connivance","connive","connoisseur","connors","connotation","connotative"
DATA "connote","connubial","conquer","conqueror","conquest","conquistador","conrad","conrail","consanguine","consanguineous","conscience","conscientious","conscionable","conscious","conscript","conscription","consecrate","consecutive","consensus","consent"
DATA "consequent","consequential","conservation","conservatism","conservative","conservator","conservatory","conserve","consider","considerate","consign","consignee","consignor","consist","consistent","consolation","console","consolidate","consonant","consonantal"
DATA "consort","consortium","conspicuous","conspiracy","conspirator","conspiratorial","conspire","constance","constant","constantine","constantinople","constellate","consternate","constipate","constituent","constitute","constitution","constitutive","constrain","constraint"
DATA "constrict","constrictor","construct","constructible","constructor","construe","consul","consular","consulate","consult","consultant","consultation","consultative","consume","consummate","consumption","consumptive","contact","contagion","contagious"
DATA "contain","contaminant","contaminate","contemplate","contemporaneous","contemporary","contempt","contemptible","contemptuous","contend","content","contention","contentious","contest","contestant","context","contextual","contiguity","contiguous","continent"
DATA "continental","contingent","continua","continual","continuant","continuation","continue","continued","continuity","continuo","continuous","continuum","contort","contour","contraband","contrabass","contraception","contraceptive","contract","contractor"
DATA "contractual","contradict","contradictory","contradistinct","contradistinction","contradistinguish","contralateral","contralto","contraption","contrariety","contrariwise","contrary","contrast","contravariant","contravene","contravention","contretemps","contribute","contribution","contributor"
DATA "contributory","contrite","contrition","contrivance","contrive","control","controllable","controlled","controller","controlling","controversial","controversy","controvertible","contumacy","contusion","conundrum","convair","convalesce","convalescent","convect"
DATA "convene","convenient","convent","convention","converge","convergent","conversant","conversation","converse","conversion","convert","convertible","convex","convey","conveyance","conveyor","convict","convince","convivial","convocate"
DATA "convocation","convoke","convolute","convolution","convolve","convoy","convulse","convulsion","convulsive","conway","cony","coo","cook","cookbook","cooke","cookery","cookie","cooky","cool","coolant"
DATA "cooley","coolheaded","coolidge","coon","coop","cooperate","coordinate","coors","coot","cop","cope","copeland","copenhagen","copernican","copernicus","copious","coplanar","copolymer","copperas","copperfield"
DATA "copperhead","coppery","copra","coprinus","coproduct","copter","copy","copybook","copyright","copywriter","coquette","coquina","coral","coralberry","coralline","corbel","corbett","corcoran","cord","cordage"
DATA "cordial","cordite","cordon","corduroy","core","corey","coriander","corinth","corinthian","coriolanus","cork","corkscrew","cormorant","corn","cornbread","cornea","cornelia","cornelius","cornell","cornerstone"
DATA "cornet","cornfield","cornflower","cornish","cornmeal","cornstarch","cornucopia","cornwall","corny","corollary","corona","coronado","coronary","coronate","coroner","coronet","coroutine","corp","corpora","corporal"
DATA "corporate","corporeal","corps","corpse","corpsman","corpsmen","corpulent","corpus","corpuscular","corral","corralled","correct","corrector","correlate","correspond","correspondent","corridor","corrigenda","corrigendum","corrigible"
DATA "corroborate","corroboree","corrode","corrodible","corrosion","corrosive","corrugate","corrupt","corruptible","corruption","corsage","corset","cortege","cortex","cortical","cortland","corundum","coruscate","corvallis","corvette"
DATA "corvus","cos","cosec","coset","cosgrove","cosh","cosine","cosmetic","cosmic","cosmology","cosmopolitan","cosmos","cosponsor","cossack","cost","costa","costello","costume","cosy","cot"
DATA "cotangent","cotillion","cotman","cotoneaster","cotta","cottage","cotton","cottonmouth","cottonseed","cottonwood","cottony","cottrell","cotty","cotyledon","couch","cougar","cough","could","couldn't","coulomb"
DATA "coulter","council","councilman","councilmen","councilwoman","councilwomen","counsel","counselor","count","countdown","countenance","counteract","counterargument","counterattack","counterbalance","counterclockwise","counterexample","counterfeit","counterflow","counterintuitive"
DATA "counterman","countermen","counterpart","counterpoint","counterpoise","counterproductive","counterproposal","countersink","countersunk","countervail","countrify","country","countryman","countrymen","countryside","countrywide","county","countywide","coup","coupe"
DATA "couple","coupon","courage","courageous","courier","course","court","courteous","courtesan","courtesy","courthouse","courtier","courtney","courtroom","courtyard","couscous","cousin","couturier","covalent","covariant"
DATA "covariate","covary","cove","coven","covenant","coventry","cover","coverage","coverall","coverlet","covert","covet","covetous","cow","cowan","coward","cowardice","cowbell","cowbird","cowboy"
DATA "cowgirl","cowhand","cowherd","cowhide","cowl","cowlick","cowman","cowmen","coworker","cowpea","cowpoke","cowpony","cowpox","cowpunch","cowry","cowslip","cox","coxcomb","coy","coyote"
DATA "coypu","cozen","cozy","cpa","cpu","crab","crabapple","crabmeat","crack","crackle","crackpot","cradle","craft","craftsman","craftsmen","craftspeople","craftsperson","crafty","crag","craggy"
DATA "craig","cram","cramer","cramp","cranberry","crandall","crane","cranelike","cranford","crania","cranium","crank","crankcase","crankshaft","cranky","cranny","cranston","crap","crappie","crash"
DATA "crass","crate","crater","cravat","crave","craven","craw","crawford","crawl","crawlspace","crayfish","crayon","craze","crazy","creak","creaky","cream","creamery","creamy","crease"
DATA "create","creating","creature","creche","credent","credential","credenza","credible","credit","creditor","credo","credulity","credulous","creed","creedal","creek","creekside","creep","creepy","cremate"
DATA "crematory","creole","creon","creosote","crepe","crept","crescendo","crescent","cress","crest","crestfallen","crestview","cretaceous","cretan","crete","cretin","cretinous","crevice","crew","crewcut"
DATA "crewel","crewman","crewmen","crib","cricket","cried","crime","crimea","criminal","crimp","crimson","cringe","crinkle","cripple","crises","crisis","crisp","crispin","criss","crisscross"
DATA "criteria","criterion","critic","critique","critter","croak","croatia","crochet","crock","crockery","crockett","crocodile","crocodilian","crocus","croft","croix","cromwell","cromwellian","crone","crony"
DATA "crook","croon","crop","croquet","crosby","cross","crossarm","crossbar","crossbill","crossbow","crosscut","crosshatch","crosslink","crossover","crosspoint","crossroad","crosstalk","crosswalk","crossway","crosswise"
DATA "crossword","crosswort","crotch","crotchety","crouch","croupier","crow","crowbait","crowberry","crowd","crowfoot","crowley","crown","croydon","crt","crucial","crucible","crucifix","crucifixion","crucify"
DATA "crud","cruddy","crude","cruel","cruelty","cruickshank","cruise","crumb","crumble","crummy","crump","crumple","crunch","crupper","crusade","crush","crusoe","crust","crusty","crutch"
DATA "crux","cruz","cry","cryogenic","cryostat","crypt","cryptanalysis","cryptanalyst","cryptanalytic","cryptanalyze","cryptic","cryptogram","cryptographer","cryptography","cryptology","crystal","crystalline","crystallite","crystallographer","crystallography"
DATA "csnet","ct","cub","cuba","cubbyhole","cube","cubic","cuckoo","cucumber","cud","cuddle","cuddly","cudgel","cue","cuff","cufflink","cuisine","culbertson","culinary","cull"
DATA "culminate","culpa","culpable","culprit","cult","cultivable","cultivate","cultural","culture","culver","culvert","cumberland","cumbersome","cumin","cummings","cummins","cumulate","cumulus","cunard","cunning"
DATA "cunningham","cuny","cup","cupboard","cupful","cupid","cupidity","cupric","cuprous","cur","curate","curb","curbside","curd","curdle","cure","curfew","curia","curie","curio"
DATA "curiosity","curious","curium","curl","curlew","curlicue","curran","currant","current","curricula","curricular","curriculum","curry","curse","cursive","cursor","cursory","curt","curtail","curtain"
DATA "curtis","curtsey","curvaceous","curvature","curve","curvilinear","cushing","cushion","cushman","cusp","custer","custodial","custodian","custody","custom","customary","customhouse","cut","cutaneous","cutback"
DATA "cute","cutesy","cutlass","cutler","cutlet","cutoff","cutout","cutover","cutset","cutthroat","cuttlebone","cuttlefish","cutworm","cyanamid","cyanate","cyanic","cyanide","cybernetic","cybernetics","cycad"
DATA "cyclades","cycle","cyclic","cyclist","cyclone","cyclopean","cyclops","cyclorama","cyclotomic","cyclotron","cygnus","cylinder","cylindric","cynic","cynthia","cypress","cyprian","cypriot","cyprus","cyril"
DATA "cyrillic","cyrus","cyst","cysteine","cytochemistry","cytology","cytolysis","cytoplasm","cytosine","cz","czar","czarina","czech","czechoslovakia","czerniak","d","d'art","d'etat","d'oeuvre","d's"
DATA "dab","dabble","dacca","dachshund","dactyl","dactylic","dad","dada","dadaism","dadaist","daddy","dade","daedalus","daffodil","daffy","dagger","dahl","dahlia","dahomey","dailey"
DATA "daimler","dainty","dairy","dairylea","dairyman","dairymen","dais","daisy","dakar","dakota","dale","daley","dalhousie","dallas","dally","dalton","daly","dalzell","dam","damage"
DATA "damascus","damask","dame","damn","damnation","damon","damp","dampen","damsel","dan","dana","danbury","dance","dandelion","dandy","dane","dang","danger","dangerous","dangle"
DATA "daniel","danielson","danish","dank","danny","dante","danube","danubian","danzig","daphne","dapper","dapple","dar","dare","daredevil","darius","dark","darken","darkle","darlene"
DATA "darling","darn","darpa","darrell","darry","dart","dartmouth","darwin","darwinian","dash","dashboard","dastard","data","database","date","dateline","dater","datsun","datum","daub"
DATA "daugherty","daughter","daunt","dauphin","dauphine","dave","davenport","david","davidson","davies","davis","davison","davit","davy","dawn","dawson","day","daybed","daybreak","daydream"
DATA "daylight","daytime","dayton","daytona","daze","dazzle","dc","de","deacon","deaconess","deactivate","dead","deaden","deadhead","deadline","deadlock","deadwood","deaf","deafen","deal"
DATA "deallocate","dealt","dean","deane","deanna","dear","dearborn","dearie","dearth","death","deathbed","deathward","debacle","debar","debarring","debase","debate","debater","debauch","debauchery"
DATA "debbie","debby","debenture","debilitate","debility","debit","debonair","deborah","debra","debrief","debris","debt","debtor","debug","debugged","debugger","debugging","debunk","debussy","debut"
DATA "debutante","dec","decade","decadent","decaffeinate","decal","decant","decathlon","decatur","decay","decca","decease","decedent","deceit","deceitful","deceive","decelerate","december","decennial","decent"
DATA "deception","deceptive","decertify","decibel","decide","deciduous","decile","decimal","decimate","decipher","decision","decisional","decisionmake","decisive","deck","decker","declaim","declamation","declamatory","declaration"
DATA "declarative","declarator","declaratory","declare","declassify","declination","decline","declivity","decode","decolletage","decollimate","decolonize","decommission","decompile","decomposable","decompose","decomposition","decompress","decompression","decontrol"
DATA "decontrolled","decontrolling","deconvolution","deconvolve","decor","decorate","decorous","decorticate","decorum","decouple","decoy","decrease","decree","decreeing","decrement","decry","decrypt","decryption","dedicate","deduce"
DATA "deducible","deduct","deductible","dee","deed","deem","deemphasize","deep","deepen","deer","deere","deerskin","deerstalker","deface","default","defeat","defecate","defect","defector","defend"
DATA "defendant","defensible","defensive","defer","deferent","deferrable","deferral","deferred","deferring","defiant","deficient","deficit","define","definite","definition","definitive","deflate","deflater","deflect","deflector"
DATA "defocus","deforest","deforestation","deform","deformation","defraud","defray","defrock","defrost","deft","defunct","defuse","defy","degas","degassing","degeneracy","degenerate","degradation","degrade","degrease"
DATA "degree","degum","degumming","dehumidify","dehydrate","deify","deign","deity","deja","deject","del","delaney","delano","delaware","delay","delectable","delectate","delegable","delegate","delete"
DATA "deleterious","deletion","delft","delhi","delia","deliberate","delicacy","delicate","delicatessen","delicious","delicti","delight","delightful","delilah","delimit","delimitation","delineament","delineate","delinquent","deliquesce"
DATA "deliquescent","delirious","delirium","deliver","deliverance","delivery","dell","della","delmarva","delouse","delphi","delphic","delphine","delphinium","delphinus","delta","deltoid","delude","deluge","delusion"
DATA "delusive","deluxe","delve","demagnify","demagogue","demand","demarcate","demark","demean","demented","dementia","demerit","demigod","demijohn","demiscible","demise","demit","demitted","demitting","demo"
DATA "democracy","democrat","democratic","demodulate","demography","demolish","demolition","demon","demoniac","demonic","demonstrable","demonstrate","demote","demountable","dempsey","demultiplex","demur","demure","demurred","demurrer"
DATA "demurring","demystify","den","denature","dendrite","dendritic","deneb","denebola","deniable","denial","denigrate","denizen","denmark","dennis","denny","denominate","denotation","denotative","denote","denouement"
DATA "denounce","dense","densitometer","dent","dental","dentistry","denton","denture","denudation","denude","denumerable","denunciate","denunciation","denver","deny","deodorant","deoxyribonucleic","deoxyribose","depart","department"
DATA "departure","depend","dependent","depict","deplete","depletion","deplore","deploy","deport","deportation","deportee","depose","deposit","depositary","deposition","depositor","depository","depot","deprave","deprecate"
DATA "deprecatory","depreciable","depreciate","depredate","depress","depressant","depressible","depression","depressive","depressor","deprivation","deprive","depth","deputation","depute","deputy","derail","derange","derate","derby"
DATA "derbyshire","dereference","deregulate","deregulatory","derek","derelict","deride","derision","derisive","derivate","derive","derogate","derogatory","derrick","derriere","dervish","des","descant","descartes","descend"
DATA "descendant","descendent","descent","describe","description","descriptive","descriptor","desecrate","desecrater","desegregate","desert","deserve","desicate","desiderata","desideratum","design","designate","desire","desirous","desist"
DATA "desk","desmond","desolate","desolater","desorption","despair","desperado","desperate","despicable","despise","despite","despoil","despond","despondent","despot","despotic","dessert","dessicate","destabilize","destinate"
DATA "destine","destiny","destitute","destroy","destruct","destructor","desuetude","desultory","detach","detail","detain","detect","detector","detent","detente","detention","deter","detergent","deteriorate","determinant"
DATA "determinate","determine","deterred","deterrent","deterring","detest","detestation","detonable","detonate","detour","detoxify","detract","detractor","detriment","detroit","deuce","deus","deuterate","deuterium","deuteron"
DATA "devastate","develop","deviant","deviate","device","devil","devilish","devious","devise","devisee","devoid","devolution","devolve","devon","devonshire","devote","devotee","devotion","devour","devout"
DATA "dew","dewar","dewdrop","dewey","dewitt","dewy","dexter","dexterity","dextrose","dextrous","dey","dhabi","dharma","diabase","diabetes","diabetic","diabolic","diachronic","diacritic","diacritical"
DATA "diadem","diagnosable","diagnose","diagnoses","diagnosis","diagnostic","diagnostician","diagonal","diagram","diagrammatic","dial","dialect","dialectic","dialogue","dialup","dialysis","diamagnetic","diamagnetism","diameter","diamond"
DATA "diana","diane","dianne","diaper","diaphanous","diaphragm","diary","diathermy","diathesis","diatom","diatomaceous","diatomic","diatonic","diatribe","dibble","dice","dichloride","dichondra","dichotomize","dichotomous"
DATA "dichotomy","dick","dickcissel","dickens","dickerson","dickey","dickinson","dickson","dicotyledon","dicta","dictate","dictatorial","diction","dictionary","dictum","did","didactic","diddle","didn't","dido"
DATA "die","diebold","died","diego","diehard","dieldrin","dielectric","diem","diesel","diet","dietary","dietetic","diethylstilbestrol","dietician","dietrich","diety","dietz","diffeomorphic","diffeomorphism","differ"
DATA "different","differentiable","differential","differentiate","difficult","difficulty","diffident","diffract","diffractometer","diffuse","diffusible","diffusion","diffusive","difluoride","dig","digest","digestible","digestion","digestive","digging"
DATA "digit","digital","digitalis","digitate","dignify","dignitary","dignity","digram","digress","digression","dihedral","dilapidate","dilatation","dilate","dilatory","dilemma","dilettante","diligent","dill","dillon"
DATA "dilogarithm","diluent","dilute","dilution","dim","dime","dimension","dimethyl","diminish","diminution","diminutive","dimple","din","dinah","dine","ding","dinghy","dingo","dingy","dinnertime"
DATA "dinnerware","dinosaur","dint","diocesan","diocese","diode","dionysian","dionysus","diophantine","diopter","diorama","diorite","dioxide","dip","diphtheria","diphthong","diploid","diploidy","diploma","diplomacy"
DATA "diplomat","diplomatic","dipole","dirac","dire","direct","director","directorate","directorial","directory","directrices","directrix","dirge","dirichlet","dirt","dirty","dis","disaccharide","disambiguate","disastrous"
DATA "disburse","disc","discern","discernible","disciple","disciplinarian","disciplinary","discipline","disco","discoid","discomfit","discordant","discovery","discreet","discrepant","discrete","discretion","discretionary","discriminable","discriminant"
DATA "discriminate","discriminatory","discus","discuss","discussant","discussion","disdain","disdainful","disembowel","disgruntle","disgustful","dish","dishes","dishevel","dishwasher","dishwater","disjunct","disk","dismal","dismissal"
DATA "disney","disneyland","disparage","disparate","dispel","dispelled","dispelling","dispensable","dispensary","dispensate","dispense","dispersal","disperse","dispersible","dispersion","dispersive","disposable","disposal","disputant","dispute"
DATA "disquietude","disquisition","disrupt","disruption","disruptive","dissemble","disseminate","dissension","dissertation","dissident","dissipate","dissociable","dissociate","dissonant","dissuade","distaff","distal","distant","distillate","distillery"
DATA "distinct","distinguish","distort","distortion","distraught","distribution","distributive","distributor","district","disturb","disturbance","disulfide","disyllable","ditch","dither","ditto","ditty","ditzel","diurnal","diva"
DATA "divalent","divan","dive","diverge","divergent","diverse","diversify","diversion","diversionary","divert","divest","divestiture","divide","dividend","divination","divine","divisible","division","divisional","divisive"
DATA "divisor","divorce","divorcee","divulge","dixie","dixieland","dixon","dizzy","djakarta","dna","dnieper","do","dobbin","dobbs","doberman","dobson","docile","dock","docket","dockside"
DATA "dockyard","doctor","doctoral","doctorate","doctrinaire","doctrinal","doctrine","document","documentary","documentation","dod","dodd","dodecahedra","dodecahedral","dodecahedron","dodge","dodo","dodson","doe","doesn't"
DATA "doff","dog","dogbane","dogberry","doge","dogfish","dogging","doggone","doghouse","dogleg","dogma","dogmatic","dogmatism","dogtooth","dogtrot","dogwood","doherty","dolan","dolce","doldrum"
DATA "doldrums","dole","doleful","doll","dollar","dollop","dolly","dolomite","dolomitic","dolores","dolphin","dolt","doltish","domain","dome","domenico","domesday","domestic","domesticate","domicile"
DATA "dominant","dominate","domineer","domingo","dominic","dominican","dominick","dominion","dominique","domino","don","don't","donahue","donald","donaldson","donate","done","doneck","donkey","donna"
DATA "donnelly","donner","donnybrook","donor","donovan","doodle","dooley","doolittle","doom","doomsday","door","doorbell","doorkeep","doorkeeper","doorknob","doorman","doormen","doorstep","doorway","dopant"
DATA "dope","doppler","dora","dorado","dorcas","dorchester","doreen","doria","doric","doris","dormant","dormitory","dorothea","dorothy","dorset","dortmund","dosage","dose","dosimeter","dossier"
DATA "dostoevsky","dot","dote","double","doubleday","doubleheader","doublet","doubleton","doubloon","doubt","doubtful","douce","doug","dough","dougherty","doughnut","douglas","douglass","dour","douse"
DATA "dove","dovekie","dovetail","dow","dowager","dowel","dowitcher","dowling","down","downbeat","downcast","downdraft","downey","downfall","downgrade","downhill","downing","downplay","downpour","downright"
DATA "downriver","downs","downside","downslope","downspout","downstairs","downstate","downstream","downtown","downtrend","downtrodden","downturn","downward","downwind","dowry","doyle","doze","dozen","dr","drab"
DATA "draco","draft","draftee","draftsman","draftsmen","draftsperson","drafty","drag","dragging","dragnet","dragon","dragonfly","dragonhead","dragoon","drain","drainage","drake","dram","drama","dramatic"
DATA "dramatist","dramaturgy","drank","drape","drapery","drastic","draw","drawback","drawbridge","drawl","drawn","dread","dreadful","dreadnought","dream","dreamboat","dreamlike","dreamt","dreamy","dreary"
DATA "dredge","dreg","drench","dress","dressmake","dressy","drew","drexel","dreyfuss","drib","dribble","dried","drier","drift","drill","drink","drip","drippy","driscoll","drive"
DATA "driven","driveway","drizzle","drizzly","droll","dromedary","drone","drool","droop","droopy","drop","drophead","droplet","dropout","drosophila","dross","drought","drove","drown","drowse"
DATA "drowsy","drub","drudge","drudgery","drug","drugging","drugstore","druid","drum","drumhead","drumlin","drummond","drunk","drunkard","drunken","drury","dry","dryad","dryden","du"
DATA "dual","dualism","duane","dub","dubhe","dubious","dubitable","dublin","ducat","duchess","duck","duckling","duct","ductile","ductwork","dud","dudley","due","duel","duet"
DATA "duff","duffel","duffy","dug","dugan","dugout","duke","dukedom","dulcet","dull","dully","dulse","duluth","duly","duma","dumb","dumbbell","dummy","dump","dumpty"
DATA "dumpy","dun","dunbar","duncan","dunce","dune","dunedin","dung","dungeon","dunham","dunk","dunkirk","dunlap","dunlop","dunn","duopolist","duopoly","dupe","duplex","duplicable"
DATA "duplicate","duplicity","dupont","duquesne","durable","durance","durango","duration","durer","duress","durham","during","durkee","durkin","durrell","durward","dusenberg","dusenbury","dusk","dusky"
DATA "dusseldorf","dust","dustbin","dusty","dutch","dutchess","dutchman","dutchmen","dutiable","dutiful","dutton","duty","dwarf","dwarves","dwell","dwelt","dwight","dwindle","dwyer","dyad"
DATA "dyadic","dye","dyeing","dyer","dying","dyke","dylan","dynamic","dynamism","dynamite","dynamo","dynast","dynastic","dynasty","dyne","dysentery","dyspeptic","dysplasia","dysprosium","dystrophy"
DATA "e","e'er","e's","e.g","each","eagan","eager","eagle","ear","eardrum","earl","earmark","earn","earnest","earphone","earring","earsplitting","earth","earthen","earthenware"
DATA "earthmen","earthmove","earthmover","earthmoving","earthquake","earthshaking","earthworm","earthy","earwig","ease","easel","east","eastbound","eastern","easternmost","eastland","eastman","eastward","eastwood","easy"
DATA "easygoing","eat","eaten","eater","eaton","eave","eavesdrop","eavesdropped","eavesdropper","eavesdropping","ebb","eben","ebony","ebullient","eccentric","eccles","ecclesiastic","echelon","echidna","echinoderm"
DATA "echo","echoes","eclat","eclectic","eclipse","ecliptic","eclogue","ecole","ecology","econometric","econometrica","economic","economist","economy","ecosystem","ecstasy","ecstatic","ectoderm","ectopic","ecuador"
DATA "ecumenic","ecumenist","ed","eddie","eddy","edelweiss","edematous","eden","edgar","edge","edgerton","edgewise","edging","edgy","edible","edict","edifice","edify","edinburgh","edison"
DATA "edit","edith","edition","editor","editorial","edmonds","edmondson","edmonton","edmund","edna","edt","eduardo","educable","educate","edward","edwardian","edwardine","edwards","edwin","edwina"
DATA "eel","eelgrass","eeoc","eerie","eerily","efface","effaceable","effect","effectual","effectuate","effeminate","efferent","effete","efficacious","efficacy","efficient","effie","effloresce","efflorescent","effluent"
DATA "effluvia","effluvium","effort","effusion","effusive","eft","egalitarian","egan","egg","egghead","eggplant","eggshell","ego","egocentric","egotism","egotist","egregious","egress","egret","egypt"
DATA "egyptian","eh","ehrlich","eider","eidetic","eigenfunction","eigenspace","eigenstate","eigenvalue","eigenvector","eight","eighteen","eighteenth","eightfold","eighth","eightieth","eighty","eileen","einstein","einsteinian"
DATA "einsteinium","eire","eisenhower","eisner","either","ejaculate","eject","ejector","eke","ekstrom","ektachrome","el","elaborate","elaine","elan","elapse","elastic","elastomer","elate","elba"
DATA "elbow","elder","eldest","eldon","eleanor","eleazar","elect","elector","electoral","electorate","electra","electress","electret","electric","electrician","electrify","electro","electrocardiogram","electrocardiograph","electrode"
DATA "electroencephalogram","electroencephalograph","electroencephalography","electrolysis","electrolyte","electrolytic","electron","electronic","electrophoresis","electrophorus","elegant","elegiac","elegy","element","elementary","elena","elephant","elephantine","elevate","eleven"
DATA "eleventh","elfin","elgin","eli","elicit","elide","eligible","elijah","eliminate","elinor","eliot","elisabeth","elisha","elision","elite","elizabeth","elizabethan","elk","elkhart","ell"
DATA "ella","ellen","elliot","elliott","ellipse","ellipsis","ellipsoid","ellipsoidal","ellipsometer","elliptic","ellis","ellison","ellsworth","ellwood","elm","elmer","elmhurst","elmira","elmsford","eloise"
DATA "elongate","elope","eloquent","else","elsevier","elsewhere","elsie","elsinore","elton","eluate","elucidate","elude","elusive","elute","elution","elves","ely","elysee","elysian","em"
DATA "emaciate","emanate","emancipate","emanuel","emasculate","embalm","embank","embarcadero","embargo","embargoes","embark","embarrass","embassy","embattle","embed","embeddable","embedded","embedder","embedding","embellish"
DATA "ember","embezzle","emblazon","emblem","emblematic","embodiment","embody","embolden","emboss","embouchure","embower","embrace","embraceable","embrittle","embroider","embroidery","embroil","embryo","embryology","embryonic"
DATA "emcee","emendable","emerald","emerge","emergent","emeriti","emeritus","emerson","emery","emigrant","emigrate","emil","emile","emilio","emily","eminent","emirate","emissary","emission","emissivity"
DATA "emit","emittance","emitted","emitter","emitting","emma","emmanuel","emmett","emolument","emory","emotion","emotional","empathy","emperor","emphases","emphasis","emphatic","emphysema","emphysematous","empire"
DATA "empiric","emplace","employ","employed","employee","employer","employing","emporium","empower","empress","empty","emulate","emulsify","emulsion","en","enable","enamel","encapsulate","encephalitis","enchantress"
DATA "enclave","encomia","encomium","encore","encroach","encryption","encumber","encumbrance","encyclopedic","end","endemic","endgame","endicott","endoderm","endogamous","endogamy","endogenous","endomorphism","endorse","endosperm"
DATA "endothelial","endothermic","endow","endpoint","endurance","endure","enemy","energetic","energy","enervate","enfant","enfield","enforceable","enforcible","eng","engage","engel","engine","engineer","england"
DATA "englander","engle","englewood","english","englishman","englishmen","enhance","enid","enigma","enigmatic","enjoinder","enlargeable","enliven","enmity","enoch","enol","enormity","enormous","enos","enough"
DATA "enquire","enquiry","enrico","enrollee","ensconce","ensemble","enstatite","entendre","enter","enterprise","entertain","enthalpy","enthrall","enthusiasm","enthusiast","enthusiastic","entice","entire","entirety","entity"
DATA "entomology","entourage","entranceway","entrant","entrepreneur","entrepreneurial","entropy","entry","enumerable","enumerate","enunciable","enunciate","envelop","envelope","enviable","envious","environ","envoy","envy","enzymatic"
DATA "enzyme","enzymology","eocene","eohippus","eosine","epa","epaulet","ephemeral","ephemerides","ephemeris","ephesian","ephesus","ephraim","epic","epicure","epicurean","epicycle","epicyclic","epidemic","epidemiology"
DATA "epidermic","epidermis","epigenetic","epigram","epigrammatic","epigraph","epileptic","epilogue","epimorphism","epiphany","epiphyseal","epiphysis","episcopal","episcopalian","episcopate","episode","episodic","epistemology","epistle","epistolatory"
DATA "epitaph","epitaxial","epitaxy","epithelial","epithelium","epithet","epitome","epoch","epochal","epoxy","epsilon","epsom","epstein","equable","equal","equanimity","equate","equatorial","equestrian","equidistant"
DATA "equilateral","equilibrate","equilibria","equilibrium","equine","equinoctial","equinox","equip","equipoise","equipotent","equipped","equipping","equitable","equitation","equity","equivalent","equivocal","equivocate","era","eradicable"
DATA "eradicate","erasable","erase","erasmus","erastus","erasure","erato","eratosthenes","erbium","erda","ere","erect","erg","ergative","ergodic","eric","erich","erickson","ericsson","erie"
DATA "erik","erlenmeyer","ernest","ernestine","ernie","ernst","erode","erodible","eros","erosible","erosion","erosive","erotic","erotica","err","errancy","errand","errant","errantry","errata"
DATA "erratic","erratum","errol","erroneous","error","ersatz","erskine","erudite","erudition","erupt","eruption","ervin","erwin","escadrille","escalate","escapade","escape","escapee","escheat","escherichia"
DATA "eschew","escort","escritoire","escrow","escutcheon","eskimo","esmark","esophagi","esoteric","especial","espionage","esplanade","esposito","espousal","espouse","esprit","esquire","essay","essen","essence"
DATA "essential","essex","est","establish","estate","esteem","estella","ester","estes","esther","estimable","estimate","estonia","estop","estoppal","estrange","estuarine","estuary","et","eta"
DATA "etc","etch","eternal","eternity","ethan","ethane","ethanol","ethel","ether","ethereal","ethic","ethiopia","ethnic","ethnography","ethnology","ethology","ethos","ethyl","ethylene","etiology"
DATA "etiquette","etruscan","etude","etymology","eucalyptus","eucharist","euclid","euclidean","eucre","eugene","eugenia","eugenic","eukaryote","euler","eulerian","eulogy","eumenides","eunice","euphemism","euphemist"
DATA "euphorbia","euphoria","euphoric","euphrates","eurasia","eureka","euridyce","euripides","europa","europe","european","europium","eurydice","eutectic","euterpe","euthanasia","eva","evacuate","evade","evaluable"
DATA "evaluate","evanescent","evangel","evangelic","evans","evanston","evansville","evaporate","evasion","evasive","eve","evelyn","even","evenhanded","evensong","event","eventful","eventide","eventual","eventuate"
DATA "eveready","everett","everglades","evergreen","everhart","everlasting","every","everybody","everyday","everyman","everyone","everything","everywhere","evict","evident","evidential","evil","evildoer","evince","evocable"
DATA "evocate","evocation","evoke","evolution","evolutionary","evolve","evzone","ewe","ewing","ex","exacerbate","exact","exacter","exaggerate","exalt","exaltation","exam","examination","examine","example"
DATA "exasperate","exasperater","excavate","exceed","excel","excelled","excellent","excelling","excelsior","except","exception","exceptional","excerpt","excess","excessive","exchange","exchangeable","exchequer","excisable","excise"
DATA "excision","excitation","excitatory","excite","exciton","exclaim","exclamation","exclamatory","exclude","exclusion","exclusionary","exclusive","excommunicate","excoriate","excrescent","excrete","excretion","excretory","excruciate","exculpate"
DATA "exculpatory","excursion","excursus","excusable","excuse","execrable","execrate","execute","execution","executive","executor","executrix","exegesis","exegete","exemplar","exemplary","exemplify","exempt","exemption","exercisable"
DATA "exercise","exert","exeter","exhale","exhaust","exhaustible","exhaustion","exhaustive","exhibit","exhibition","exhibitor","exhilarate","exhort","exhortation","exhumation","exhume","exigent","exile","exist","existent"
DATA "existential","exit","exodus","exogamous","exogamy","exogenous","exonerate","exorbitant","exorcise","exorcism","exorcist","exoskeleton","exothermic","exotic","exotica","expand","expanse","expansible","expansion","expansive"
DATA "expatiate","expect","expectant","expectation","expectorant","expectorate","expedient","expedite","expedition","expeditious","expel","expellable","expelled","expelling","expend","expenditure","expense","expensive","experience","experiential"
DATA "experiment","experimentation","expert","expertise","expiable","expiate","expiration","expire","explain","explanation","explanatory","expletive","explicable","explicate","explicit","explode","exploit","exploitation","exploration","exploratory"
DATA "explore","explosion","explosive","exponent","exponential","exponentiate","export","exportation","expose","exposit","exposition","expositor","expository","exposure","expound","express","expressible","expression","expressive","expressway"
DATA "expropriate","expulsion","expunge","expurgate","exquisite","extant","extemporaneous","extempore","extend","extendible","extensible","extension","extensive","extensor","extent","extenuate","exterior","exterminate","external","extinct"
DATA "extinguish","extirpate","extol","extolled","extoller","extolling","extort","extra","extracellular","extract","extractor","extracurricular","extraditable","extradite","extradition","extralegal","extralinguistic","extramarital","extramural","extraneous"
DATA "extraordinary","extrapolate","extraterrestrial","extravagant","extravaganza","extrema","extremal","extreme","extremis","extremum","extricable","extricate","extrinsic","extroversion","extrovert","extrude","extrusion","extrusive","exuberant","exudate"
DATA "exudation","exude","exult","exultant","exultation","exxon","eye","eyeball","eyebright","eyebrow","eyed","eyeful","eyeglass","eyelash","eyelet","eyelid","eyepiece","eyesight","eyesore","eyewitness"
DATA "ezekiel","ezra","f","f's","faa","faber","fabian","fable","fabric","fabricate","fabulous","facade","face","faceplate","facet","facetious","facial","facile","facilitate","facsimile"
DATA "fact","factious","facto","factor","factorial","factory","factual","facultative","faculty","fad","fade","fadeout","faery","fafnir","fag","fahey","fahrenheit","fail","failsafe","failsoft"
DATA "failure","fain","faint","fair","fairchild","fairfax","fairfield","fairgoer","fairport","fairway","fairy","faith","faithful","fake","falcon","falconry","fall","fallacious","fallacy","fallen"
DATA "fallible","falloff","fallout","fallow","falmouth","false","falsehood","falsify","falstaff","falter","fame","familial","familiar","familiarly","familism","family","famine","famish","famous","fan"
DATA "fanatic","fanciful","fancy","fanfare","fanfold","fang","fangled","fanny","fanout","fantasia","fantasist","fantastic","fantasy","fantod","far","farad","faraday","farber","farce","farcical"
DATA "fare","farewell","farfetched","fargo","farina","farkas","farley","farm","farmhouse","farmington","farmland","farnsworth","faro","farrell","farsighted","farther","farthest","fascicle","fasciculate","fascinate"
DATA "fascism","fascist","fashion","fast","fasten","fastidious","fat","fatal","fate","fateful","father","fathom","fatigue","fatima","fatten","fatty","fatuous","faucet","faulkner","fault"
DATA "faulty","faun","fauna","faust","faustian","faustus","fawn","fay","fayette","fayetteville","faze","fbi","fcc","fda","fe","fealty","fear","fearful","fearsome","feasible"
DATA "feast","feat","feather","featherbed","featherbedding","featherbrain","feathertop","featherweight","feathery","feature","feb","febrile","february","fecund","fed","fedders","federal","federate","fedora","fee"
DATA "feeble","feed","feedback","feel","feeney","feet","feign","feint","feldman","feldspar","felice","felicia","felicitous","felicity","feline","felix","fell","fellow","felon","felonious"
DATA "felony","felsite","felt","female","feminine","feminism","feminist","femur","fence","fencepost","fend","fennel","fenton","fenugreek","ferber","ferdinand","ferguson","fermat","ferment","fermentation"
DATA "fermi","fermion","fermium","fern","fernando","fernery","ferocious","ferocity","ferreira","ferrer","ferret","ferric","ferris","ferrite","ferroelectric","ferromagnet","ferromagnetic","ferromagnetism","ferrous","ferruginous"
DATA "ferrule","ferry","fertile","fervent","fescue","fest","festival","festive","fetal","fetch","fete","fetid","fetish","fetter","fettle","fetus","feud","feudal","feudatory","fever"
DATA "feverish","few","fiance","fiancee","fiasco","fiat","fib","fiberboard","fiberglas","fibonacci","fibration","fibrin","fibrosis","fibrous","fiche","fickle","fiction","fictitious","fictive","fiddle"
DATA "fiddlestick","fide","fidelity","fidget","fiducial","fiduciary","fief","fiefdom","field","fields","fieldstone","fieldwork","fiend","fiendish","fierce","fiery","fiesta","fife","fifo","fifteen"
DATA "fifteenth","fifth","fiftieth","fifty","fig","figaro","fight","figural","figurate","figure","figurine","filament","filamentary","filbert","filch","file","filet","filial","filibuster","filigree"
DATA "filipino","fill","filled","filler","fillet","fillip","filly","film","filmdom","filmmake","filmstrip","filmy","filter","filth","filthy","filtrate","fin","final","finale","finance"
DATA "financial","financier","finch","find","fine","finery","finesse","finessed","finessing","finger","fingernail","fingerprint","fingertip","finial","finicky","finish","finitary","finite","fink","finland"
DATA "finley","finn","finnegan","finnish","finny","fir","fire","firearm","fireboat","firebreak","firebug","firecracker","firefly","firehouse","firelight","fireman","firemen","fireplace","firepower","fireproof"
DATA "fireside","firestone","firewall","firewood","firework","firm","firmware","first","firsthand","fiscal","fischbein","fischer","fish","fisherman","fishermen","fishery","fishmonger","fishpond","fishy","fisk"
DATA "fiske","fissile","fission","fissure","fist","fisticuff","fit","fitch","fitchburg","fitful","fitzgerald","fitzpatrick","fitzroy","five","fivefold","fix","fixate","fixture","fizeau","fizzle"
DATA "fjord","fl","flabbergast","flabby","flack","flag","flagellate","flageolet","flagging","flagler","flagpole","flagrant","flagstaff","flagstone","flail","flair","flak","flake","flaky","flam"
DATA "flamboyant","flame","flamingo","flammable","flanagan","flanders","flange","flank","flannel","flap","flare","flash","flashback","flashlight","flashy","flask","flat","flatbed","flathead","flatiron"
DATA "flatland","flatten","flattery","flatulent","flatus","flatware","flatworm","flaunt","flautist","flaw","flax","flaxen","flaxseed","flea","fleabane","fleawort","fleck","fled","fledge","fledgling"
DATA "flee","fleece","fleeing","fleet","fleming","flemish","flesh","fleshy","fletch","fletcher","flew","flex","flexible","flexural","flexure","flick","flier","flight","flimsy","flinch"
DATA "fling","flint","flintlock","flinty","flip","flipflop","flippant","flirt","flirtation","flirtatious","flit","flo","float","floc","flocculate","flock","floe","flog","flogging","flood"
DATA "floodgate","floodlight","floodlit","floor","floorboard","flop","floppy","flora","floral","florence","florentine","florican","florid","florida","floridian","florin","florist","flotation","flotilla","flounce"
DATA "flounder","flour","flourish","floury","flout","flow","flowchart","flowerpot","flowery","flown","floyd","flu","flub","fluctuate","flue","fluency","fluent","fluff","fluffy","fluid"
DATA "fluke","flung","flunk","fluoresce","fluorescein","fluorescent","fluoridate","fluoride","fluorine","fluorite","fluorocarbon","fluorspar","flurry","flush","fluster","flute","flutter","fluvial","flux","fly"
DATA "flycatcher","flyer","flynn","flyway","fm","fmc","foal","foam","foamflower","foamy","fob","focal","foci","focus","focussed","fodder","foe","fog","fogarty","fogging"
DATA "foggy","fogy","foible","foil","foist","fold","foldout","foley","foliage","foliate","folio","folk","folklore","folksong","folksy","follicle","follicular","follow","followeth","folly"
DATA "fomalhaut","fond","fondle","fondly","font","fontaine","fontainebleau","food","foodstuff","fool","foolhardy","foolish","foolproof","foot","footage","football","footbridge","foote","footfall","foothill"
DATA "footman","footmen","footnote","footpad","footpath","footprint","footstep","footstool","footwear","footwork","fop","foppish","for","forage","foray","forbade","forbear","forbearance","forbes","forbid"
DATA "forbidden","forbidding","forbore","forborne","force","forceful","forcible","ford","fordham","fore","foregoing","foreign","forensic","forest","forestry","forever","forfeit","forfeiture","forfend","forgave"
DATA "forge","forgery","forget","forgetful","forgettable","forgetting","forgive","forgiven","forgo","forgot","forgotten","fork","forklift","forlorn","form","formal","formaldehyde","formant","format","formate"
DATA "formatted","formatting","formic","formica","formidable","formosa","formula","formulae","formulaic","formulate","forrest","forsake","forsaken","forsook","forswear","forsythe","fort","forte","fortescue","forth"
DATA "forthcome","forthright","forthwith","fortieth","fortify","fortin","fortiori","fortitude","fortnight","fortran","fortress","fortuitous","fortunate","fortune","forty","forum","forward","forwent","foss","fossil"
DATA "fossiliferous","foster","fosterite","fought","foul","foulmouth","found","foundation","foundling","foundry","fount","fountain","fountainhead","four","fourfold","fourier","foursome","foursquare","fourteen","fourteenth"
DATA "fourth","fovea","fowl","fox","foxglove","foxhall","foxhole","foxhound","foxtail","foxy","foyer","fpc","fraction","fractionate","fractious","fracture","fragile","fragment","fragmentary","fragmentation"
DATA "fragrant","frail","frailty","frambesia","frame","framework","fran","franc","franca","france","frances","franchise","francine","francis","franciscan","francisco","francium","franco","francoise","frangipani"
DATA "frank","frankel","frankfort","frankfurt","frankfurter","franklin","frantic","franz","fraser","fraternal","fraternity","frau","fraud","fraudulent","fraught","fray","frayed","frazier","frazzle","freak"
DATA "freakish","freckle","fred","freddie","freddy","frederic","frederick","fredericks","fredericksburg","fredericton","fredholm","fredrickson","free","freeboot","freed","freedman","freedmen","freedom","freehand","freehold"
DATA "freeing","freeman","freemen","freeport","freer","freest","freestone","freethink","freetown","freeway","freewheel","freeze","freight","french","frenchman","frenchmen","frenetic","frenzy","freon","frequent"
DATA "fresco","frescoes","fresh","freshen","freshman","freshmen","freshwater","fresnel","fresno","fret","freud","freudian","frey","freya","friable","friar","fricative","frick","friction","frictional"
DATA "friday","fried","friedman","friedrich","friend","frieze","frigate","frigga","fright","frighten","frightful","frigid","frigidaire","frill","frilly","fringe","frisky","fritillary","fritter","fritz"
DATA "frivolity","frivolous","frizzle","fro","frock","frog","frolic","from","front","frontage","frontal","frontier","frontiersman","frontiersmen","frost","frostbite","frostbitten","frosty","froth","frothy"
DATA "frown","frowzy","froze","frozen","fructify","fructose","fruehauf","frugal","fruit","fruitful","fruition","frustrate","frustrater","frustum","fry","frye","ft","ftc","fuchs","fuchsia"
DATA "fudge","fuel","fugal","fugitive","fugue","fuji","fujitsu","fulcrum","fulfill","full","fullback","fullerton","fully","fulminate","fulsome","fulton","fum","fumble","fume","fumigant"
DATA "fumigate","fun","function","functionary","functor","functorial","fund","fundamental","fundraise","funeral","funereal","fungal","fungi","fungible","fungicide","fungoid","fungus","funk","funnel","funny"
DATA "fur","furbish","furious","furl","furlong","furlough","furman","furnace","furnish","furniture","furrier","furrow","furry","further","furtherance","furthermore","furthermost","furthest","furtive","fury"
DATA "furze","fuse","fuselage","fusible","fusiform","fusillade","fusion","fuss","fussy","fusty","futile","future","fuzz","fuzzy","g","g's","ga","gab","gabardine","gabble"
DATA "gabbro","gaberones","gable","gabon","gabriel","gabrielle","gad","gadfly","gadget","gadgetry","gadolinium","gadwall","gaelic","gaff","gaffe","gag","gage","gagging","gaggle","gagwriter"
DATA "gaiety","gail","gaillardia","gain","gaines","gainesville","gainful","gait","gaithersburg","gal","gala","galactic","galactose","galapagos","galatea","galatia","galaxy","galbreath","gale","galen"
DATA "galena","galenite","galilee","gall","gallagher","gallant","gallantry","gallberry","gallery","galley","gallinule","gallium","gallivant","gallon","gallonage","gallop","galloway","gallows","gallstone","gallup"
DATA "gallus","galois","galt","galvanic","galvanism","galvanometer","galveston","galway","gam","gambia","gambit","gamble","gambol","game","gamecock","gamesman","gamin","gamma","gamut","gander"
DATA "gang","ganges","gangland","gangling","ganglion","gangplank","gangster","gangway","gannet","gannett","gantlet","gantry","ganymede","gao","gap","gape","gar","garage","garb","garbage"
DATA "garble","garcia","garden","gardenia","gardner","garfield","gargantuan","gargle","garibaldi","garish","garland","garlic","garner","garnet","garrett","garrison","garrisonian","garrulous","garry","garter"
DATA "garth","garvey","gary","gas","gascony","gaseous","gases","gash","gasify","gasket","gaslight","gasohol","gasoline","gasp","gaspee","gassy","gaston","gastrointestinal","gastronome","gastronomy"
DATA "gate","gatekeep","gates","gateway","gather","gatlinburg","gator","gauche","gaucherie","gaudy","gauge","gaugeable","gauguin","gaul","gauleiter","gaulle","gaunt","gauntlet","gaur","gauss"
DATA "gaussian","gauze","gave","gavel","gavin","gavotte","gawk","gawky","gay","gaylord","gaze","gazelle","gazette","ge","gear","gecko","gedanken","gee","geese","gegenschein"
DATA "geiger","geigy","geisha","gel","gelable","gelatin","gelatine","gelatinous","geld","gem","geminate","gemini","gemlike","gemma","gemstone","gender","gene","genealogy","genera","general"
DATA "generate","generic","generosity","generous","genesco","genesis","genetic","geneva","genevieve","genial","genie","genii","genital","genitive","genius","genoa","genotype","genre","gent","genteel"
DATA "gentian","gentile","gentility","gentle","gentleman","gentlemen","gentry","genuine","genus","geocentric","geochemical","geochemistry","geochronology","geodesic","geodesy","geodetic","geoduck","geoffrey","geographer","geography"
DATA "geology","geometer","geometrician","geophysical","geophysics","geopolitic","george","georgetown","georgia","gerald","geraldine","geranium","gerard","gerber","gerbil","gerhard","gerhardt","geriatric","germ","german"
DATA "germane","germanic","germanium","germantown","germany","germicidal","germicide","germinal","germinate","gerontology","gerry","gershwin","gertrude","gerund","gerundial","gerundive","gestalt","gestapo","gesticulate","gesture"
DATA "get","getaway","getty","gettysburg","geyser","ghana","ghastly","ghent","gherkin","ghetto","ghost","ghostlike","ghostly","ghoul","ghoulish","giacomo","giant","giantess","gibberish","gibbet"
DATA "gibbon","gibbons","gibbous","gibbs","gibby","gibe","giblet","gibraltar","gibson","giddap","giddy","gideon","gifford","gift","gig","gigabit","gigabyte","gigacycle","gigahertz","gigaherz"
DATA "gigantic","gigavolt","gigawatt","gigging","giggle","gil","gila","gilbert","gilbertson","gilchrist","gild","gilead","giles","gill","gillespie","gillette","gilligan","gilmore","gilt","gimbal"
DATA "gimbel","gimmick","gimmickry","gimpy","gin","gina","ginger","gingham","gingko","ginkgo","ginmill","ginn","gino","ginsberg","ginsburg","ginseng","giovanni","giraffe","gird","girdle"
DATA "girl","girlie","girlish","girth","gist","giuliano","giuseppe","give","giveaway","given","giveth","glacial","glaciate","glacier","glacis","glad","gladden","gladdy","glade","gladiator"
DATA "gladiolus","gladstone","gladys","glamor","glamorous","glamour","glance","gland","glandular","glans","glare","glasgow","glass","glassine","glassware","glasswort","glassy","glaswegian","glaucoma","glaucous"
DATA "glaze","gleam","glean","gleason","glee","gleeful","glen","glenda","glendale","glenn","glib","glidden","glide","glimmer","glimpse","glint","glissade","glisten","glitch","glitter"
DATA "gloat","glob","global","globe","globular","globule","globulin","glom","glomerular","gloom","gloomy","gloria","gloriana","glorify","glorious","glory","gloss","glossary","glossed","glossolalia"
DATA "glossy","glottal","glottis","gloucester","glove","glow","glucose","glue","glued","gluey","gluing","glum","glut","glutamate","glutamic","glutamine","glutinous","glutton","glyceride","glycerin"
DATA "glycerinate","glycerine","glycerol","glycine","glycogen","glycol","glyph","gm","gmt","gnarl","gnash","gnat","gnaw","gneiss","gnome","gnomon","gnomonic","gnostic","gnp","gnu"
DATA "go","goa","goad","goal","goat","goatherd","gob","gobble","gobbledygook","goblet","god","goddard","goddess","godfather","godfrey","godhead","godkin","godlike","godmother","godparent"
DATA "godsend","godson","godwin","godwit","goer","goes","goethe","goff","gog","goggle","gogh","gogo","gold","goldberg","golden","goldeneye","goldenrod","goldenseal","goldfinch","goldfish"
DATA "goldman","goldsmith","goldstein","goldstine","goldwater","goleta","golf","goliath","golly","gondola","gone","gong","goniometer","gonzales","gonzalez","goober","good","goodbye","goode","goodman"
DATA "goodrich","goodwill","goodwin","goody","goodyear","goof","goofy","goose","gooseberry","gop","gopher","gordian","gordon","gore","goren","gorge","gorgeous","gorgon","gorham","gorilla"
DATA "gorky","gorse","gorton","gory","gosh","goshawk","gosling","gospel","gossamer","gossip","got","gotham","gothic","gotten","gottfried","goucher","gouda","gouge","gould","gourd"
DATA "gourmet","gout","govern","governance","governess","governor","gown","gpo","grab","grace","graceful","gracious","grackle","grad","gradate","grade","gradient","gradual","graduate","grady"
DATA "graff","graft","graham","grail","grain","grainy","grammar","grammarian","grammatic","granary","grand","grandchild","grandchildren","granddaughter","grandeur","grandfather","grandiloquent","grandiose","grandma","grandmother"
DATA "grandnephew","grandniece","grandpa","grandparent","grandson","grandstand","granite","granitic","granny","granola","grant","grantee","grantor","granular","granulate","granule","granville","grape","grapefruit","grapevine"
DATA "graph","grapheme","graphic","graphite","grapple","grasp","grass","grassland","grassy","grata","grate","grateful","grater","gratify","gratis","gratitude","gratuitous","gratuity","grave","gravel"
DATA "graven","graves","gravestone","graveyard","gravid","gravitate","gravy","gray","graybeard","grayish","grayson","graywacke","graze","grease","greasy","great","greatcoat","greater","grebe","grecian"
DATA "greece","greed","greedy","greek","green","greenbelt","greenberg","greenblatt","greenbriar","greene","greenery","greenfield","greengrocer","greenhouse","greenish","greenland","greensboro","greensward","greenware","greenwich"
DATA "greenwood","greer","greet","greg","gregarious","gregg","gregory","gremlin","grenade","grendel","grenoble","gresham","greta","gretchen","grew","grey","greyhound","greylag","grid","griddle"
DATA "gridiron","grief","grievance","grieve","grievous","griffin","griffith","grill","grille","grilled","grillwork","grim","grimace","grimaldi","grime","grimes","grimm","grin","grind","grindstone"
DATA "grip","gripe","grippe","grisly","grist","gristmill","griswold","grit","gritty","grizzle","grizzly","groan","groat","grocer","grocery","groggy","groin","grommet","groom","groove"
DATA "grope","grosbeak","gross","grosset","grossman","grosvenor","grotesque","groton","ground","groundsel","groundskeep","groundwork","group","groupoid","grout","grove","grovel","grover","grow","growl"
DATA "grown","grownup","growth","grub","grubby","grudge","gruesome","gruff","grumble","grumman","grunt","gryphon","gsa","gu","guam","guanidine","guanine","guano","guarantee","guaranteeing"
DATA "guarantor","guaranty","guard","guardhouse","guardia","guardian","guatemala","gubernatorial","guelph","guenther","guerdon","guernsey","guerrilla","guess","guesswork","guest","guffaw","guggenheim","guiana","guidance"
DATA "guide","guidebook","guideline","guidepost","guiding","guignol","guild","guildhall","guile","guilford","guillemot","guillotine","guilt","guilty","guinea","guise","guitar","gules","gulf","gull"
DATA "gullah","gullet","gullible","gully","gulp","gum","gumbo","gumdrop","gummy","gumption","gumshoe","gun","gunderson","gunfight","gunfire","gunflint","gunk","gunky","gunman","gunmen"
DATA "gunnery","gunny","gunplay","gunpowder","gunshot","gunsling","gunther","gurgle","gurkha","guru","gus","gush","gusset","gust","gustafson","gustav","gustave","gustavus","gusto","gusty"
DATA "gut","gutenberg","guthrie","gutsy","guttural","guy","guyana","guzzle","gwen","gwyn","gym","gymnasium","gymnast","gymnastic","gymnosperm","gyp","gypsite","gypsum","gypsy","gyrate"
DATA "gyrfalcon","gyro","gyrocompass","gyroscope","h","h's","ha","haag","haas","habeas","haberdashery","haberman","habib","habit","habitant","habitat","habitation","habitual","habituate","hacienda"
DATA "hack","hackberry","hackett","hackle","hackmatack","hackney","hackneyed","hacksaw","had","hadamard","haddad","haddock","hades","hadley","hadn't","hadrian","hadron","hafnium","hagen","hager"
DATA "haggard","haggle","hagstrom","hague","hahn","haifa","haiku","hail","hailstone","hailstorm","haines","hair","haircut","hairdo","hairpin","hairy","haiti","haitian","hal","halcyon"
DATA "hale","haley","half","halfback","halfhearted","halfway","halibut","halide","halifax","halite","hall","hallelujah","halley","hallmark","hallow","halloween","hallucinate","hallway","halma","halo"
DATA "halocarbon","halogen","halpern","halsey","halstead","halt","halvah","halve","halverson","ham","hamal","hamburg","hamburger","hamilton","hamlet","hamlin","hammerhead","hammock","hammond","hamper"
DATA "hampshire","hampton","hamster","han","hancock","hand","handbag","handbook","handclasp","handcuff","handel","handful","handgun","handhold","handicap","handicapped","handicapper","handicapping","handicraft","handicraftsman"
DATA "handicraftsmen","handiwork","handkerchief","handle","handleable","handlebar","handline","handmade","handmaiden","handout","handset","handshake","handsome","handspike","handstand","handwaving","handwrite","handwritten","handy","handyman"
DATA "handymen","haney","hanford","hang","hangable","hangar","hangman","hangmen","hangout","hangover","hank","hankel","hanley","hanlon","hanna","hannah","hannibal","hanoi","hanover","hanoverian"
DATA "hans","hansel","hansen","hansom","hanson","hanukkah","hap","haphazard","haploid","haploidy","haplology","happen","happenstance","happy","hapsburg","harangue","harass","harbin","harbinger","harcourt"
DATA "hard","hardbake","hardboard","hardboiled","hardcopy","harden","hardhat","hardin","harding","hardscrabble","hardtack","hardtop","hardware","hardwood","hardworking","hardy","hare","harelip","harem","hark"
DATA "harlan","harlem","harley","harm","harmful","harmon","harmonic","harmonica","harmonious","harmony","harness","harold","harp","harpoon","harpsichord","harpy","harriet","harriman","harrington","harris"
DATA "harrisburg","harrison","harrow","harry","harsh","harshen","hart","hartford","hartley","hartman","harvard","harvest","harvestman","harvey","hash","hashish","hasn't","hasp","hassle","hast"
DATA "haste","hasten","hastings","hasty","hat","hatch","hatchet","hatchway","hate","hateful","hater","hatfield","hath","hathaway","hatred","hatteras","hattie","hattiesburg","haugen","haughty"
DATA "haul","haulage","haunch","haunt","hausdorff","havana","have","haven","haven't","havilland","havoc","haw","hawaii","hawaiian","hawk","hawkins","hawley","hawthorn","hawthorne","hay"
DATA "hayden","haydn","hayes","hayfield","haynes","hays","haystack","hayward","hazard","hazardous","haze","hazel","hazelnut","hazy","he","he'd","he'll","head","headache","headboard"
DATA "headdress","headland","headlight","headline","headmaster","headphone","headquarter","headquarters","headroom","headset","headsman","headsmen","headstand","headstone","headstrong","headwall","headwater","headway","headwind","heady"
DATA "heal","healey","health","healthful","healthy","healy","heap","hear","heard","hearken","hearsay","hearse","hearst","heart","heartbeat","heartbreak","hearten","heartfelt","hearth","hearty"
DATA "heat","heater","heath","heathen","heathenish","heathkit","heave","heaven","heavenward","heavy","heavyweight","hebe","hebephrenic","hebraic","hebrew","hecate","hecatomb","heck","heckle","heckman"
DATA "hectic","hector","hecuba","hedge","hedgehog","hedonism","hedonist","heed","heel","heft","hefty","hegelian","hegemony","heidelberg","heigh","height","heighten","heine","heinrich","heinz"
DATA "heir","heiress","heisenberg","held","helen","helena","helene","helga","helical","helicopter","heliocentric","heliotrope","helium","helix","hell","hellbender","hellebore","hellenic","hellfire","hellgrammite"
DATA "hellish","hello","helm","helmet","helmholtz","helmsman","helmsmen","helmut","help","helpful","helpmate","helsinki","helvetica","hem","hematite","hemingway","hemisphere","hemispheric","hemlock","hemoglobin"
DATA "hemolytic","hemorrhage","hemorrhoid","hemosiderin","hemp","hempstead","hen","henbane","hence","henceforth","henchman","henchmen","henderson","hendrick","hendricks","hendrickson","henequen","henley","henpeck","henri"
DATA "henrietta","henry","hepatica","hepatitis","hepburn","heptane","her","hera","heraclitus","herald","herb","herbert","herculean","hercules","herd","herdsman","here","hereabout","hereafter","hereby"
DATA "hereditary","heredity","hereford","herein","hereinabove","hereinafter","hereinbelow","hereof","heresy","heretic","hereto","heretofore","hereunder","hereunto","herewith","heritable","heritage","herkimer","herman","hermann"
DATA "hermeneutic","hermes","hermetic","hermite","hermitian","hermosa","hernandez","hero","herodotus","heroes","heroic","heroin","heroine","heroism","heron","herpes","herpetology","herr","herringbone","herschel"
DATA "herself","hershel","hershey","hertz","hertzog","hesitant","hesitate","hesitater","hesperus","hess","hesse","hessian","hester","heterocyclic","heterodyne","heterogamous","heterogeneity","heterogeneous","heterosexual","heterostructure"
DATA "heterozygous","hetman","hettie","hetty","heublein","heuristic","heusen","heuser","hew","hewett","hewitt","hewlett","hewn","hex","hexachloride","hexadecimal","hexafluoride","hexagon","hexagonal","hexameter"
DATA "hexane","hey","heyday","hi","hiatt","hiatus","hiawatha","hibachi","hibbard","hibernate","hibernia","hick","hickey","hickman","hickory","hicks","hid","hidalgo","hidden","hide"
DATA "hideaway","hideous","hideout","hierarchal","hierarchic","hierarchy","hieratic","hieroglyphic","hieronymus","hifalutin","higgins","high","highball","highboy","highest","highfalutin","highhanded","highland","highlight","highroad"
DATA "hightail","highway","highwayman","highwaymen","hijack","hijinks","hike","hilarious","hilarity","hilbert","hildebrand","hill","hillbilly","hillcrest","hillel","hillman","hillmen","hillock","hillside","hilltop"
DATA "hilly","hilt","hilton","hilum","him","himalaya","himself","hind","hindmost","hindrance","hindsight","hindu","hinduism","hines","hinge","hinman","hint","hinterland","hip","hippo"
DATA "hippocrates","hippocratic","hippodrome","hippopotamus","hippy","hipster","hiram","hire","hireling","hiroshi","hiroshima","hirsch","hirsute","his","hispanic","hiss","histamine","histidine","histochemic","histochemistry"
DATA "histogram","histology","historian","historic","historiography","history","histrionic","hit","hitachi","hitch","hitchcock","hither","hitherto","hitler","hive","ho","hoagie","hoagland","hoagy","hoar"
DATA "hoard","hoarfrost","hoarse","hob","hobart","hobbes","hobble","hobbs","hobby","hobbyhorse","hobgoblin","hobo","hoboken","hoc","hock","hockey","hocus","hodge","hodgepodge","hodges"
DATA "hodgkin","hoe","hoff","hoffman","hog","hogan","hogging","hoi","hokan","holbrook","holcomb","hold","holden","holdout","holdover","holdup","hole","holeable","holiday","holland"
DATA "hollandaise","holler","hollerith","hollingsworth","hollister","hollow","holloway","hollowware","holly","hollyhock","hollywood","holm","holman","holmdel","holmes","holmium","holocaust","holocene","hologram","holography"
DATA "holst","holstein","holster","holt","holyoke","holystone","hom","homage","home","homebound","homebuild","homebuilder","homebuilding","homecome","homecoming","homeland","homemade","homemake","homeomorph","homeomorphic"
DATA "homeopath","homeostasis","homeown","homeowner","homeric","homesick","homestead","homeward","homework","homicidal","homicide","homily","homo","homogenate","homogeneity","homogeneous","homologous","homologue","homology","homomorphic"
DATA "homomorphism","homonym","homophobia","homosexual","homotopy","homozygous","homunculus","honda","hondo","honduras","hone","honest","honesty","honey","honeybee","honeycomb","honeydew","honeymoon","honeysuckle","honeywell"
DATA "hong","honk","honolulu","honoraria","honorarium","honorary","honoree","honorific","honshu","hooch","hood","hoodlum","hoof","hoofmark","hook","hookup","hookworm","hooligan","hoop","hoopla"
DATA "hoosegow","hoosier","hoot","hoover","hooves","hop","hope","hopeful","hopkins","hopkinsian","hopple","hopscotch","horace","horatio","horde","horehound","horizon","horizontal","hormone","horn"
DATA "hornbeam","hornblende","hornblower","hornet","hornmouth","horntail","hornwort","horny","horology","horoscope","horowitz","horrendous","horrible","horrid","horrify","horror","horse","horseback","horsedom","horseflesh"
DATA "horsefly","horsehair","horseman","horsemen","horseplay","horsepower","horseshoe","horsetail","horsewoman","horsewomen","horticulture","horton","horus","hose","hosiery","hospice","hospitable","hospital","host","hostage"
DATA "hostelry","hostess","hostile","hostler","hot","hotbed","hotbox","hotel","hotelman","hothead","hothouse","hotrod","hotshot","houdaille","houdini","hough","houghton","hound","hour","hourglass"
DATA "house","houseboat","housebreak","housebroken","housefly","household","housekeep","housewares","housewife","housewives","housework","houston","hove","hovel","hover","how","howard","howdy","howe","howell"
DATA "however","howl","howsoever","howsomever","hoy","hoyden","hoydenish","hoyt","hrothgar","hub","hubbard","hubbell","hubbub","hubby","huber","hubert","hubris","huck","huckleberry","huckster"
DATA "huddle","hudson","hue","hued","huff","huffman","hug","huge","hugging","huggins","hugh","hughes","hugo","huh","hulk","hull","hum","human","humane","humanitarian"
DATA "humanoid","humble","humboldt","humerus","humid","humidify","humidistat","humiliate","humility","hummel","hummingbird","hummock","humorous","hump","humpback","humphrey","humpty","humus","hun","hunch"
DATA "hundred","hundredfold","hundredth","hung","hungarian","hungary","hungry","hunk","hunt","hunter","huntington","huntley","huntsville","hurd","hurdle","hurl","hurley","huron","hurrah","hurray"
DATA "hurricane","hurry","hurst","hurt","hurtle","hurty","hurwitz","husband","husbandman","husbandmen","husbandry","hush","husky","hustle","huston","hut","hutch","hutchins","hutchinson","hutchison"
DATA "huxley","huxtable","huzzah","hyacinth","hyades","hyaline","hyannis","hybrid","hyde","hydra","hydrangea","hydrant","hydrate","hydraulic","hydride","hydro","hydrocarbon","hydrochemistry","hydrochloric","hydrochloride"
DATA "hydrodynamic","hydroelectric","hydrofluoric","hydrogen","hydrogenate","hydrology","hydrolysis","hydrometer","hydronium","hydrophilic","hydrophobia","hydrophobic","hydrosphere","hydrostatic","hydrothermal","hydrous","hydroxide","hydroxy","hydroxyl","hydroxylate"
DATA "hyena","hygiene","hygrometer","hygroscopic","hying","hyman","hymen","hymn","hymnal","hyperbola","hyperbolic","hyperboloid","hyperboloidal","hypertensive","hyphen","hyphenate","hypnosis","hypnotic","hypoactive","hypochlorite"
DATA "hypochlorous","hypocrisy","hypocrite","hypocritic","hypocritical","hypocycloid","hypodermic","hypophyseal","hypotenuse","hypothalamic","hypothalamus","hypotheses","hypothesis","hypothetic","hypothyroid","hysterectomy","hysteresis","hysteria","hysteric","hysteron"
DATA "i","i'd","i'll","i'm","i's","i've","i.e","ia","iambic","ian","iberia","ibex","ibid","ibis","ibm","ibn","icarus","icc","ice","iceberg"
DATA "icebox","iceland","icelandic","ichneumon","icicle","icky","icon","iconic","iconoclasm","iconoclast","icosahedra","icosahedral","icosahedron","icy","id","ida","idaho","idea","ideal","ideate"
DATA "idempotent","identical","identify","identity","ideolect","ideologue","ideology","idiocy","idiom","idiomatic","idiosyncrasy","idiosyncratic","idiot","idiotic","idle","idol","idolatry","idyll","idyllic","ieee"
DATA "if","iffy","ifni","igloo","igneous","ignite","ignition","ignoble","ignominious","ignoramus","ignorant","ignore","igor","ii","iii","ike","il","ileum","iliac","iliad"
DATA "ill","illegal","illegible","illegitimacy","illegitimate","illicit","illimitable","illinois","illiteracy","illiterate","illogic","illume","illuminate","illumine","illusion","illusionary","illusive","illusory","illustrate","illustrious"
DATA "ilona","ilyushin","image","imagen","imagery","imaginary","imaginate","imagine","imbalance","imbecile","imbibe","imbrium","imbroglio","imbrue","imbue","imitable","imitate","immaculate","immanent","immaterial"
DATA "immature","immeasurable","immediacy","immediate","immemorial","immense","immerse","immersion","immigrant","immigrate","imminent","immiscible","immobile","immobility","immoderate","immodest","immodesty","immoral","immortal","immovable"
DATA "immune","immunization","immunoelectrophoresis","immutable","imp","impact","impair","impale","impalpable","impart","impartation","impartial","impassable","impasse","impassion","impassive","impatient","impeach","impeccable","impedance"
DATA "impede","impediment","impel","impelled","impeller","impelling","impend","impenetrable","imperate","imperative","imperceivable","imperceptible","imperfect","imperial","imperil","imperious","imperishable","impermeable","impermissible","impersonal"
DATA "impersonate","impertinent","imperturbable","impervious","impetuous","impetus","impiety","impinge","impious","impish","implacable","implant","implantation","implausible","implement","implementation","implementer","implementor","implicant","implicate"
DATA "implicit","implode","implore","implosion","impolite","impolitic","imponderable","import","important","importation","importunate","importune","impose","imposition","impossible","impost","imposture","impotent","impound","impoverish"
DATA "impracticable","impractical","imprecate","imprecise","imprecision","impregnable","impregnate","impresario","impress","impressible","impression","impressive","imprimatur","imprint","imprison","improbable","impromptu","improper","impropriety","improve"
DATA "improvident","improvisate","improvisation","improvise","imprudent","impudent","impugn","impulse","impulsive","impunity","impure","imputation","impute","in","inability","inaccessible","inaccuracy","inaccurate","inaction","inactivate"
DATA "inactive","inadequacy","inadequate","inadmissible","inadvertent","inadvisable","inalienable","inalterable","inane","inanimate","inappeasable","inapplicable","inappreciable","inapproachable","inappropriate","inapt","inaptitude","inarticulate","inasmuch","inattention"
DATA "inattentive","inaudible","inaugural","inaugurate","inauspicious","inboard","inborn","inbred","inbreed","inc","inca","incalculable","incandescent","incant","incantation","incapable","incapacitate","incapacity","incarcerate","incarnate"
DATA "incaution","incautious","incendiary","incense","incentive","inception","inceptor","incessant","incest","incestuous","inch","incident","incidental","incinerate","incipient","incise","incisive","incite","inclement","inclination"
DATA "incline","inclose","include","inclusion","inclusive","incoherent","incombustible","income","incommensurable","incommensurate","incommunicable","incommutable","incomparable","incompatible","incompetent","incomplete","incompletion","incomprehensible","incomprehension","incompressible"
DATA "incomputable","inconceivable","inconclusive","incondensable","incongruity","incongruous","inconsequential","inconsiderable","inconsiderate","inconsistent","inconsolable","inconspicuous","inconstant","incontestable","incontrollable","incontrovertible","inconvenient","inconvertible","incorporable","incorporate"
DATA "incorrect","incorrigible","incorruptible","increasable","increase","incredible","incredulity","incredulous","increment","incriminate","incubate","incubi","incubus","inculcate","inculpable","incumbent","incur","incurred","incurrer","incurring"
DATA "incursion","indebted","indecent","indecipherable","indecision","indecisive","indecomposable","indeed","indefatigable","indefensible","indefinable","indefinite","indelible","indelicate","indemnify","indemnity","indent","indentation","indenture","independent"
DATA "indescribable","indestructible","indeterminable","indeterminacy","indeterminate","index","india","indian","indiana","indianapolis","indicant","indicate","indices","indict","indicter","indies","indifferent","indigene","indigenous","indigent"
DATA "indigestible","indigestion","indignant","indignation","indignity","indigo","indira","indirect","indiscernible","indiscoverable","indiscreet","indiscretion","indiscriminate","indispensable","indispose","indisposition","indisputable","indissoluble","indistinct","indistinguishable"
DATA "indium","individual","individualism","individuate","indivisible","indochina","indochinese","indoctrinate","indoeuropean","indolent","indomitable","indonesia","indoor","indorse","indubitable","induce","inducible","induct","inductance","inductee"
DATA "inductor","indulge","indulgent","industrial","industrialism","industrious","industry","indwell","indy","ineducable","ineffable","ineffective","ineffectual","inefficacy","inefficient","inelastic","inelegant","ineligible","ineluctable","inept"
DATA "inequality","inequitable","inequity","inequivalent","ineradicable","inert","inertance","inertia","inertial","inescapable","inestimable","inevitable","inexact","inexcusable","inexhaustible","inexorable","inexpedient","inexpensive","inexperience","inexpert"
DATA "inexpiable","inexplainable","inexplicable","inexplicit","inexpressible","inextinguishable","inextricable","infallible","infamous","infamy","infancy","infant","infantile","infantry","infantryman","infantrymen","infarct","infatuate","infeasible","infect"
DATA "infectious","infelicitous","infelicity","infer","inference","inferential","inferior","infernal","inferno","inferred","inferring","infertile","infest","infestation","infidel","infield","infight","infighting","infiltrate","infima"
DATA "infimum","infinite","infinitesimal","infinitive","infinitude","infinitum","infinity","infirm","infirmary","infix","inflame","inflammable","inflammation","inflammatory","inflate","inflater","inflationary","inflect","inflexible","inflict"
DATA "inflicter","inflow","influence","influent","influential","influenza","influx","info","inform","informal","informant","informatica","information","informative","infra","infract","infrared","infrastructure","infrequent","infringe"
DATA "infuriate","infuse","infusible","infusion","ingather","ingenious","ingenuity","ingenuous","ingersoll","ingest","ingestible","ingestion","inglorious","ingot","ingram","ingrate","ingratiate","ingratitude","ingredient","ingrown"
DATA "inhabit","inhabitant","inhabitation","inhalation","inhale","inharmonious","inhere","inherent","inherit","inheritance","inheritor","inhibit","inhibition","inhibitor","inhibitory","inholding","inhomogeneity","inhomogeneous","inhospitable","inhuman"
DATA "inhumane","inimical","inimitable","iniquitous","iniquity","initial","initiate","inject","injudicious","injun","injunct","injunction","injure","injurious","injury","injustice","ink","inkling","inlaid","inland"
DATA "inlay","inlet","inman","inmate","inn","innards","innate","inner","innermost","innkeeper","innocent","innocuous","innovate","innuendo","innumerable","inoculate","inoffensive","inoperable","inoperative","inopportune"
DATA "inordinate","inorganic","input","inputting","inquest","inquire","inquiry","inquisition","inquisitive","inquisitor","inroad","insane","insatiable","inscribe","inscription","inscrutable","insect","insecticide","insecure","inseminate"
DATA "insensible","insensitive","inseparable","insert","inset","inshore","inside","insidious","insight","insightful","insignia","insignificant","insincere","insinuate","insipid","insist","insistent","insofar","insolent","insoluble"
DATA "insolvable","insolvent","insomnia","insomniac","insouciant","inspect","inspector","inspiration","inspire","instable","install","installation","instalment","instance","instant","instantaneous","instantiate","instead","instep","instigate"
DATA "instill","instillation","instinct","instinctual","institute","institution","instruct","instructor","instrument","instrumentation","insubordinate","insubstantial","insufferable","insufficient","insular","insulate","insulin","insult","insuperable","insupportable"
DATA "insuppressible","insurance","insure","insurgent","insurmountable","insurrect","insurrection","intact","intake","intangible","integer","integrable","integral","integrand","integrate","integrity","integument","intellect","intellectual","intelligent"
DATA "intelligentsia","intelligible","intemperance","intemperate","intend","intendant","intense","intensify","intensive","intent","intention","inter","intercalate","intercept","interception","interceptor","intercom","interdict","interest","interfere"
DATA "interference","interferometer","interim","interior","interject","interlude","intermediary","intermit","intermittent","intern","internal","internecine","internescine","interpol","interpolant","interpolate","interpolatory","interpret","interpretation","interpretive"
DATA "interregnum","interrogate","interrogatory","interrupt","interruptible","interruption","intersect","intersperse","interstice","interstitial","interval","intervene","intervenor","intervention","interviewee","intestate","intestinal","intestine","intimacy","intimal"
DATA "intimate","intimater","intimidate","into","intolerable","intolerant","intonate","intone","intoxicant","intoxicate","intractable","intramolecular","intransigent","intransitive","intrepid","intricacy","intricate","intrigue","intrinsic","introduce"
DATA "introduction","introductory","introit","introject","introspect","introversion","introvert","intrude","intrusion","intrusive","intuit","intuitable","intuition","intuitive","inundate","inure","invade","invalid","invalidate","invaluable"
DATA "invariable","invariant","invasion","invasive","invective","inveigh","inveigle","invent","invention","inventive","inventor","inventory","inverness","inverse","inversion","invert","invertebrate","invertible","invest","investigate"
DATA "investigatory","investor","inveterate","inviable","invidious","invigorate","invincible","inviolable","inviolate","invisible","invitation","invite","invitee","invocate","invoice","invoke","involuntary","involute","involution","involutorial"
DATA "involutory","involve","invulnerable","inward","io","iodate","iodide","iodinate","iodine","ion","ionic","ionosphere","ionospheric","iota","iowa","ipecac","ipsilateral","ipso","iq","ir"
DATA "ira","iran","iranian","iraq","irate","ire","ireland","irene","iridium","iris","irish","irishman","irishmen","irk","irksome","irma","iron","ironic","ironside","ironstone"
DATA "ironwood","irony","iroquois","irradiate","irrational","irrawaddy","irreclaimable","irreconcilable","irrecoverable","irredeemable","irredentism","irredentist","irreducible","irrefutable","irregular","irrelevancy","irrelevant","irremediable","irremovable","irreparable"
DATA "irreplaceable","irrepressible","irreproachable","irreproducible","irresistible","irresolute","irresolution","irresolvable","irrespective","irresponsible","irretrievable","irreverent","irreversible","irrevocable","irrigate","irritable","irritant","irritate","irruption","irs"
DATA "irvin","irvine","irving","irwin","is","isaac","isaacson","isabel","isabella","isadore","isaiah","isentropic","isfahan","ising","isinglass","isis","islam","islamabad","islamic","island"
DATA "isle","isn't","isochronal","isochronous","isocline","isolate","isolde","isomer","isomorph","isomorphic","isopleth","isotherm","isothermal","isotope","isotopic","isotropic","isotropy","israel","israeli","israelite"
DATA "issuance","issuant","issue","istanbul","istvan","it","it&t","it'd","it'll","italian","italic","italy","itch","item","iterate","ithaca","itinerant","itinerary","ito","itself"
DATA "itt","iv","ivan","ivanhoe","iverson","ivory","ivy","ix","izvestia","j","j's","jab","jablonsky","jack","jackanapes","jackass","jackboot","jackdaw","jacket","jackie"
DATA "jackknife","jackman","jackpot","jackson","jacksonian","jacksonville","jacky","jacm","jacob","jacobean","jacobi","jacobian","jacobite","jacobs","jacobsen","jacobson","jacobus","jacqueline","jacques","jade"
DATA "jaeger","jag","jagging","jaguar","jail","jaime","jakarta","jake","jalopy","jam","jamaica","jamboree","james","jamestown","jan","jane","janeiro","janet","jangle","janice"
DATA "janissary","janitor","janitorial","janos","jansenist","january","janus","japan","japanese","jar","jargon","jarvin","jason","jasper","jaundice","jaunty","java","javelin","jaw","jawbone"
DATA "jawbreak","jay","jazz","jazzy","jealous","jealousy","jean","jeannie","jed","jeep","jeff","jefferson","jeffersonian","jeffrey","jehovah","jejune","jejunum","jelly","jellyfish","jenkins"
DATA "jennie","jennifer","jennings","jenny","jensen","jeopard","jeopardy","jeremiah","jeremy","jeres","jericho","jerk","jerky","jeroboam","jerome","jerry","jersey","jerusalem","jess","jesse"
DATA "jessica","jessie","jest","jesuit","jesus","jet","jetliner","jettison","jew","jewel","jewell","jewelry","jewett","jewish","jibe","jiffy","jig","jigging","jiggle","jigsaw"
DATA "jill","jilt","jim","jimenez","jimmie","jimmy","jingle","jinx","jitter","jitterbug","jitterbugger","jitterbugging","jittery","jive","jo","joan","joanna","joanne","joaquin","job"
DATA "jobholder","jock","jockey","jockstrap","jocose","jocular","jocund","joe","joel","joey","jog","jogging","joggle","johann","johannes","johannesburg","johansen","johanson","john","johnny"
DATA "johns","johnsen","johnson","johnston","johnstown","join","joint","joke","joliet","jolla","jolly","jolt","jon","jonas","jonathan","jones","jonquil","jordan","jorge","jorgensen"
DATA "jorgenson","jose","josef","joseph","josephine","josephson","josephus","joshua","josiah","joss","jostle","jot","joule","jounce","journal","journalese","journey","journeyman","journeymen","joust"
DATA "jovanovich","jove","jovial","jovian","jowl","jowly","joy","joyce","joyful","joyous","joyride","joystick","jr","juan","juanita","jubilant","jubilate","jubilee","judaism","judas"
DATA "judd","jude","judge","judicable","judicatory","judicature","judicial","judiciary","judicious","judith","judo","judson","judy","jug","jugate","jugging","juggle","jugoslavia","juice","juicy"
DATA "juju","jujube","juke","jukes","julep","jules","julia","julie","juliet","julio","julius","july","jumble","jumbo","jump","jumpy","junco","junction","junctor","juncture"
DATA "june","juneau","jungle","junior","juniper","junk","junkerdom","junketeer","junky","juno","junta","jupiter","jura","jurassic","jure","juridic","jurisdiction","jurisprudent","jurisprudential","juror"
DATA "jury","just","justice","justiciable","justify","justine","justinian","jut","jute","jutish","juvenile","juxtapose","juxtaposition","k","k's","kabuki","kabul","kaddish","kafka","kafkaesque"
DATA "kahn","kaiser","kajar","kalamazoo","kale","kaleidescope","kaleidoscope","kalmia","kalmuk","kamchatka","kamikaze","kampala","kane","kangaroo","kankakee","kansas","kant","kaolin","kaolinite","kaplan"
DATA "kapok","kappa","karachi","karamazov","karate","karen","karl","karma","karol","karp","karyatid","kaskaskia","kate","katharine","katherine","kathleen","kathy","katie","katmandu","katowice"
DATA "katz","kauffman","kaufman","kava","kay","kayo","kazoo","keaton","keats","keddah","keel","keelson","keen","keenan","keep","keeshond","keg","keith","keller","kelley"
DATA "kellogg","kelly","kelp","kelsey","kelvin","kemp","ken","kendall","kennan","kennecott","kennedy","kennel","kenneth","kenney","keno","kensington","kent","kenton","kentucky","kenya"
DATA "kenyon","kepler","kept","kerchief","kermit","kern","kernel","kernighan","kerosene","kerr","kerry","kerygma","kessler","kestrel","ketch","ketchup","ketone","ketosis","kettering","kettle"
DATA "kevin","key","keyboard","keyed","keyes","keyhole","keynes","keynesian","keynote","keypunch","keys","keystone","keyword","khaki","khan","khartoum","khmer","khrushchev","kibbutzim","kibitz"
DATA "kick","kickback","kickoff","kid","kidde","kiddie","kidnap","kidnapped","kidnapping","kidney","kieffer","kiev","kiewit","kigali","kikuyu","kilgore","kill","killdeer","killjoy","kilo"
DATA "kilohm","kim","kimball","kimberly","kimono","kin","kind","kindergarten","kindle","kindred","kinematic","kinesic","kinesthesis","kinetic","king","kingbird","kingdom","kingfisher","kinglet","kingpin"
DATA "kingsbury","kingsley","kingston","kink","kinky","kinney","kinshasha","kiosk","kiowa","kipling","kirby","kirchner","kirchoff","kirk","kirkland","kirkpatrick","kirov","kiss","kissing","kit"
DATA "kitakyushu","kitchen","kitchenette","kite","kitten","kittenish","kittle","kitty","kiva","kivu","kiwanis","kiwi","klan","klaus","klaxon","kleenex","klein","kline","klux","klystron"
DATA "knack","knapp","knapsack","knauer","knead","knee","kneecap","kneel","knell","knelt","knew","knick","knickerbocker","knife","knifelike","knight","knightsbridge","knit","knives","knob"
DATA "knobby","knock","knockdown","knockout","knoll","knot","knott","knotty","know","knoweth","knowhow","knowledge","knowledgeable","knowles","knowlton","known","knox","knoxville","knuckle","knuckleball"
DATA "knudsen","knudson","knurl","knutsen","knutson","koala","kobayashi","koch","kochab","kodachrome","kodak","kodiak","koenig","koenigsberg","kohlrabi","koinonia","kola","kolkhoz","kombu","kong"
DATA "konrad","koppers","koran","korea","kosher","kovacs","kowalewski","kowalski","kowloon","kraft","krakatoa","krakow","kramer","krause","kraut","krebs","kremlin","kresge","krieger","krishna"
DATA "kristin","kronecker","krueger","kruger","kruse","krypton","ks","ku","kudo","kudzu","kuhn","kulak","kumquat","kurd","kurt","kuwait","kwashiorkor","ky","kyle","kyoto"
DATA "l","l'oeil","l's","l'vov","la","lab","laban","label","labia","labial","labile","lability","laboratory","laborious","labour","labrador","labradorite","labyrinth","lac","lace"
DATA "lacerate","lacerta","lacewing","lachesis","lack","lackadaisic","lackey","lackluster","laconic","lacquer","lacrosse","lactate","lactose","lacuna","lacunae","lacustrine","lacy","lad","laden","ladle"
DATA "lady","ladyfern","ladylike","lafayette","lag","lager","lagging","lagoon","lagos","lagrange","lagrangian","laguerre","lahore","laid","laidlaw","lain","lair","laissez","laity","lake"
DATA "lakehurst","lakeside","lam","lamar","lamarck","lamb","lambda","lambert","lame","lamellar","lament","lamentation","laminar","laminate","lamp","lampblack","lamplight","lampoon","lamprey","lana"
DATA "lancashire","lancaster","lance","land","landau","landfill","landhold","landis","landlord","landmark","landowner","landscape","landslide","lane","lang","lange","langley","langmuir","language","languid"
DATA "languish","lank","lanka","lanky","lansing","lantern","lanthanide","lanthanum","lao","laocoon","laos","laotian","lap","lapel","lapelled","lapidary","laplace","laplacian","lappet","lapse"
DATA "laramie","larceny","larch","lard","laredo","lares","large","largemouth","largesse","lariat","lark","larkin","larkspur","larry","lars","larsen","larson","larva","larvae","larval"
DATA "laryngeal","larynges","larynx","lascar","lascivious","lase","lash","lass","lasso","last","laszlo","latch","late","latent","later","latera","lateral","lateran","laterite","latex"
DATA "lath","lathe","lathrop","latin","latinate","latitude","latitudinal","latitudinary","latrobe","latter","lattice","latus","latvia","laud","laudanum","laudatory","lauderdale","laue","laugh","laughingstock"
DATA "laughlin","laughter","launch","launder","laundry","laura","laureate","laurel","lauren","laurence","laurent","laurentian","laurie","lausanne","lava","lavabo","lavatory","lavender","lavish","lavoisier"
DATA "law","lawbreak","lawbreaker","lawbreaking","lawful","lawgive","lawgiver","lawgiving","lawmake","lawman","lawmen","lawn","lawrence","lawrencium","lawson","lawsuit","lawyer","lax","laxative","lay"
DATA "layette","layman","laymen","layoff","layout","layton","layup","lazarus","laze","lazy","lazybones","lea","leach","leachate","lead","leaden","leadeth","leadsman","leadsmen","leaf"
DATA "leaflet","leafy","league","leak","leakage","leaky","lean","leander","leap","leapfrog","leapt","lear","learn","lease","leasehold","leash","least","leather","leatherback","leatherneck"
DATA "leatherwork","leathery","leave","leaven","leavenworth","lebanese","lebanon","lebensraum","lebesgue","lecher","lechery","lectern","lectionary","lecture","led","ledge","lee","leech","leeds","leek"
DATA "leer","leery","leeuwenhoek","leeward","leeway","left","leftmost","leftover","leftward","lefty","leg","legacy","legal","legate","legatee","legato","legend","legendary","legendre","legerdemain"
DATA "legging","leggy","leghorn","legible","legion","legislate","legislature","legitimacy","legitimate","legume","leguminous","lehigh","lehman","leigh","leighton","leila","leisure","leitmotif","leitmotiv","leland"
DATA "lemma","lemming","lemon","lemonade","lemuel","len","lena","lend","length","lengthen","lengthwise","lengthy","lenient","lenin","leningrad","leninism","leninist","lennox","lenny","lenore"
DATA "lens","lent","lenten","lenticular","lentil","leo","leon","leona","leonard","leonardo","leone","leonid","leonine","leopard","leopold","leper","lepidolite","leprosy","leroy","lesbian"
DATA "lesion","leslie","lesotho","less","lessee","lessen","lesson","lessor","lest","lester","let","lethal","lethargic","lethargy","lethe","letitia","letterhead","letterman","lettermen","lettuce"
DATA "leucine","leukemia","lev","levee","level","lever","leverage","levi","levin","levine","levis","levitate","leviticus","levitt","levity","levulose","levy","lew","lewd","lewis"
DATA "lexical","lexicography","lexicon","lexington","leyden","liable","liaison","liar","libation","libel","libelous","liberal","liberate","liberia","libertarian","libertine","liberty","libidinous","libido","librarian"
DATA "library","librate","librettist","libretto","libreville","libya","lice","licensable","licensee","licensor","licentious","lichen","lick","licorice","lid","lie","liechtenstein","lied","lien","lieu"
DATA "lieutenant","life","lifeblood","lifeboat","lifeguard","lifelike","lifelong","lifespan","lifestyle","lifetime","lifo","lift","ligament","ligand","ligature","ligget","liggett","light","lighten","lightface"
DATA "lighthearted","lighthouse","lightning","lightproof","lightweight","lignite","lignum","like","liken","likewise","lila","lilac","lilian","lillian","lilliputian","lilly","lilt","lily","lim","lima"
DATA "limb","limbic","limbo","lime","limelight","limerick","limestone","limit","limitate","limitation","limousine","limp","limpet","limpid","limpkin","lin","lincoln","lind","linda","lindberg"
DATA "lindbergh","linden","lindholm","lindquist","lindsay","lindsey","lindstrom","line","lineage","lineal","linear","linebacker","lineman","linemen","linen","lineprinter","lineup","linger","lingerie","lingo"
DATA "lingua","lingual","linguist","liniment","link","linkage","linoleum","linotype","linseed","lint","linus","lion","lionel","lioness","lip","lipid","lippincott","lipread","lipschitz","lipscomb"
DATA "lipstick","lipton","liquefaction","liquefy","liqueur","liquid","liquidate","liquidus","liquor","lisa","lisbon","lise","lisle","lisp","lissajous","list","listen","lit","litany","literacy"
DATA "literal","literary","literate","literature","lithe","lithic","lithium","lithograph","lithography","lithology","lithosphere","lithospheric","lithuania","litigant","litigate","litigious","litmus","litterbug","little","littleneck"
DATA "littleton","litton","littoral","liturgic","liturgy","live","liven","livermore","liverpool","liverpudlian","liverwort","livery","livestock","liveth","livid","livingston","livre","liz","lizard","lizzie"
DATA "lloyd","lo","load","loaf","loam","loamy","loan","loath","loathe","loathsome","loaves","lob","lobar","lobby","lobe","loblolly","lobo","lobotomy","lobscouse","lobster"
DATA "lobular","lobule","local","locale","locate","loci","lock","locke","lockhart","lockheed","lockian","locknut","lockout","locksmith","lockstep","lockup","lockwood","locomote","locomotion","locomotive"
DATA "locomotor","locomotory","locoweed","locus","locust","locution","locutor","lodestone","lodge","lodgepole","lodowick","loeb","loess","loft","lofty","log","logan","logarithm","logarithmic","loge"
DATA "loggerhead","logging","logic","logician","logistic","logjam","logo","loin","loincloth","loire","lois","loiter","loki","lola","loll","lollipop","lolly","lomb","lombard","lombardy"
DATA "lome","london","lone","lonesome","long","longevity","longfellow","longhand","longhorn","longish","longitude","longitudinal","longleg","longstanding","longtime","longue","look","lookout","lookup","loom"
DATA "loomis","loon","loop","loophole","loose","looseleaf","loosen","loosestrife","loot","lop","lope","lopez","lopseed","lopsided","loquacious","loquacity","loquat","lord","lordosis","lore"
DATA "lorelei","loren","lorenz","loretta","lorinda","lorraine","los","losable","lose","loss","lossy","lost","lot","lotion","lotte","lottery","lottie","lotus","lou","loud"
DATA "loudspeak","loudspeaker","loudspeaking","louis","louisa","louise","louisiana","louisville","lounge","lounsbury","lourdes","louse","lousewort","lousy","louver","louvre","love","lovebird","lovelace","loveland"
DATA "lovelorn","low","lowboy","lowdown","lowe","lowell","lower","lowland","lowry","loy","loyal","loyalty","lozenge","lsi","ltd","ltv","lubbock","lubell","lubricant","lubricate"
DATA "lubricious","lubricity","lucas","lucerne","lucia","lucian","lucid","lucifer","lucille","lucius","luck","lucky","lucrative","lucre","lucretia","lucretius","lucy","ludicrous","ludlow","ludwig"
DATA "lufthansa","luftwaffe","lug","luge","luger","luggage","lugging","luis","luke","lukemia","lukewarm","lull","lullaby","lulu","lumbar","lumber","lumberman","lumbermen","lumen","luminance"
DATA "luminary","luminescent","luminosity","luminous","lummox","lump","lumpish","lumpur","lumpy","lunacy","lunar","lunary","lunate","lunatic","lunch","luncheon","lunchroom","lunchtime","lund","lundberg"
DATA "lundquist","lung","lunge","lupine","lura","lurch","lure","lurid","lurk","lusaka","luscious","lush","lust","lustful","lustrous","lusty","lutanist","lute","lutetium","luther"
DATA "lutheran","lutz","lux","luxe","luxembourg","luxuriant","luxuriate","luxurious","luxury","luzon","lycopodium","lydia","lye","lying","lykes","lyle","lyman","lymph","lymphocyte","lymphoma"
DATA "lynch","lynchburg","lynn","lynx","lyon","lyons","lyra","lyric","lyricism","lysenko","lysergic","lysine","m","m's","ma","mabel","mac","macabre","macaque","macarthur"
DATA "macassar","macbeth","macdonald","macdougall","mace","macedon","macedonia","macgregor","mach","machiavelli","machination","machine","machinelike","machinery","machismo","macho","macintosh","mack","mackenzie","mackerel"
DATA "mackey","mackinac","mackinaw","mackintosh","macmillan","macon","macrame","macro","macromolecular","macromolecule","macrophage","macroprocessor","macroscopic","macrostructure","mad","madagascar","madam","madame","madcap","madden"
DATA "maddox","made","madeira","madeleine","madeline","madhouse","madison","madman","madmen","madonna","madras","madrid","madrigal","madsen","madstone","mae","maelstrom","maestro","mafia","magazine"
DATA "magdalene","magenta","maggie","maggot","maggoty","magi","magic","magician","magisterial","magistrate","magma","magna","magnanimity","magnanimous","magnate","magnesia","magnesite","magnesium","magnet","magnetic"
DATA "magnetite","magneto","magnetron","magnificent","magnify","magnitude","magnolia","magnum","magnuson","magog","magpie","magruder","mahayana","mahayanist","mahogany","mahoney","maid","maiden","maidenhair","maidservant"
DATA "maier","mail","mailbox","mailman","mailmen","maim","main","maine","mainland","mainline","mainstay","mainstream","maintain","maintenance","maitre","majestic","majesty","major","make","makeshift"
DATA "makeup","malabar","maladapt","maladaptive","maladjust","maladroit","malady","malagasy","malaise","malaprop","malaria","malarial","malawi","malay","malaysia","malcolm","malconduct","malcontent","malden","maldistribute"
DATA "maldive","male","maledict","malefactor","malevolent","malfeasant","malformation","malformed","malfunction","mali","malice","malicious","malign","malignant","mall","mallard","malleable","mallet","mallory","mallow"
DATA "malnourished","malnutrition","malocclusion","malone","maloney","malposed","malpractice","malraux","malt","malta","maltese","malton","maltose","maltreat","mambo","mamma","mammal","mammalian","mammoth","man"
DATA "mana","manage","manageable","managerial","managua","manama","manatee","manchester","mandamus","mandarin","mandate","mandatory","mandrake","mandrel","mandrill","mane","maneuver","manfred","manganese","mange"
DATA "mangel","mangle","manhattan","manhole","manhood","mania","maniac","maniacal","manic","manifest","manifestation","manifold","manikin","manila","manipulable","manipulate","manitoba","mankind","manley","mann"
DATA "manna","mannequin","mannerism","manometer","manor","manpower","mans","manse","manservant","mansfield","mansion","manslaughter","mantel","mantic","mantis","mantissa","mantle","mantlepiece","mantrap","manual"
DATA "manuel","manufacture","manumission","manumit","manumitted","manure","manuscript","manville","many","manzanita","mao","maori","map","maple","mar","marathon","maraud","marble","marc","marceau"
DATA "marcel","marcello","march","marcia","marco","marcus","marcy","mardi","mare","margaret","margarine","margery","margin","marginal","marginalia","margo","marguerite","maria","marianne","marie"
DATA "marietta","marigold","marijuana","marilyn","marimba","marin","marina","marinade","marinate","marine","marino","mario","marion","marionette","marital","maritime","marjoram","marjorie","marjory","mark"
DATA "market","marketeer","marketplace","marketwise","markham","markov","markovian","marks","marksman","marksmen","marlboro","marlborough","marlene","marlin","marlowe","marmalade","marmot","maroon","marque","marquee"
DATA "marquess","marquette","marquis","marriage","marriageable","married","marrietta","marriott","marrow","marrowbone","marry","mars","marseilles","marsh","marsha","marshal","marshall","marshland","marshmallow","marsupial"
DATA "mart","marten","martensite","martha","martial","martian","martin","martinez","martingale","martini","martinique","martinson","marty","martyr","martyrdom","marvel","marvelous","marvin","marx","mary"
DATA "maryland","mascara","masculine","maser","maseru","mash","mask","masochism","masochist","mason","masonic","masonite","masonry","masque","masquerade","mass","massachusetts","massacre","massage","masseur"
DATA "massey","massif","massive","mast","masterful","mastermind","masterpiece","mastery","mastic","mastiff","mastodon","masturbate","mat","match","matchbook","matchmake","mate","mateo","mater","material"
DATA "materiel","maternal","maternity","math","mathematic","mathematician","mathematik","mathews","mathewson","mathias","mathieu","matilda","matinal","matinee","matins","matisse","matriarch","matriarchal","matrices","matriculate"
DATA "matrimonial","matrimony","matrix","matroid","matron","matson","matsumoto","matte","matthew","matthews","mattock","mattress","mattson","maturate","mature","maudlin","maul","maureen","maurice","mauricio"
DATA "maurine","mauritania","mauritius","mausoleum","mauve","maverick","mavis","maw","mawkish","mawr","max","maxim","maxima","maximal","maximilian","maximum","maxine","maxwell","maxwellian","may"
DATA "maya","mayapple","maybe","mayer","mayfair","mayflower","mayhem","maynard","mayo","mayonnaise","mayor","mayoral","mayst","mazda","maze","mazurka","mba","mbabane","mcadams","mcallister"
DATA "mcbride","mccabe","mccall","mccallum","mccann","mccarthy","mccarty","mccauley","mcclain","mcclellan","mcclure","mccluskey","mcconnel","mcconnell","mccormick","mccoy","mccracken","mccullough","mcdaniel","mcdermott"
DATA "mcdonald","mcdonnell","mcdougall","mcdowell","mcelroy","mcfadden","mcfarland","mcgee","mcgill","mcginnis","mcgovern","mcgowan","mcgrath","mcgraw","mcgregor","mcguire","mchugh","mcintosh","mcintyre","mckay"
DATA "mckee","mckenna","mckenzie","mckeon","mckesson","mckinley","mckinney","mcknight","mclaughlin","mclean","mcleod","mcmahon","mcmillan","mcmullen","mcnally","mcnaughton","mcneil","mcnulty","mcpherson","md"
DATA "me","mead","meadow","meadowland","meadowsweet","meager","meal","mealtime","mealy","mean","meander","meaningful","meant","meantime","meanwhile","measle","measure","meat","meaty","mecca"
DATA "mechanic","mechanism","mechanist","mecum","medal","medallion","meddle","medea","medford","media","medial","median","mediate","medic","medicate","medici","medicinal","medicine","medico","mediocre"
DATA "mediocrity","meditate","mediterranean","medium","medlar","medley","medusa","meek","meet","meetinghouse","meg","megabit","megabyte","megahertz","megalomania","megalomaniac","megaton","megavolt","megawatt","megaword"
DATA "megohm","meier","meiosis","meistersinger","mekong","mel","melamine","melancholy","melanesia","melange","melanie","melanin","melanoma","melbourne","melcher","meld","melee","melinda","meliorate","melissa"
DATA "mellon","mellow","melodic","melodious","melodrama","melodramatic","melody","melon","melpomene","melt","meltdown","meltwater","melville","melvin","member","membrane","memento","memo","memoir","memorabilia"
DATA "memorable","memoranda","memorandum","memorial","memory","memphis","men","menace","menagerie","menarche","mend","mendacious","mendacity","mendel","mendelevium","mendelssohn","menelaus","menfolk","menhaden","menial"
DATA "meningitis","meniscus","menlo","mennonite","menopause","menstruate","mensurable","mensuration","mental","mention","mentor","menu","menzies","mephistopheles","mercantile","mercator","mercedes","mercenary","mercer","merchandise"
DATA "merchant","merciful","mercilessly","merck","mercurial","mercuric","mercury","mercy","mere","meredith","meretricious","merganser","merge","meridian","meridional","meringue","merit","meritorious","merle","merlin"
DATA "mermaid","merriam","merrill","merrimack","merriment","merritt","merry","merrymake","mervin","mesa","mescal","mescaline","mesenteric","mesh","mesmeric","mesoderm","meson","mesopotamia","mesozoic","mesquite"
DATA "mess","message","messenger","messiah","messieurs","messrs","messy","met","metabole","metabolic","metabolism","metabolite","metal","metallic","metalliferous","metallography","metalloid","metallurgic","metallurgist","metallurgy"
DATA "metalwork","metamorphic","metamorphism","metamorphose","metamorphosis","metaphor","metaphoric","metcalf","mete","meteor","meteoric","meteorite","meteoritic","meteorology","meter","methacrylate","methane","methanol","methionine","method"
DATA "methodic","methodism","methodist","methodology","methuen","methuselah","methyl","methylene","meticulous","metier","metric","metro","metronome","metropolis","metropolitan","mettle","mettlesome","metzler","mew","mexican"
DATA "mexico","meyer","meyers","mezzanine","mezzo","mi","miami","miasma","miasmal","mica","mice","michael","michaelangelo","michel","michelangelo","michele","michelin","michelson","michigan","mickelson"
DATA "mickey","micky","micro","microbial","microcosm","microfiche","micrography","microjoule","micron","micronesia","microscopy","mid","midas","midband","midday","middle","middlebury","middleman","middlemen","middlesex"
DATA "middleton","middletown","middleweight","midge","midget","midland","midmorn","midnight","midpoint","midrange","midscale","midsection","midshipman","midshipmen","midspan","midst","midstream","midterm","midway","midweek"
DATA "midwest","midwestern","midwife","midwinter","midwives","mien","miff","mig","might","mightn't","mighty","mignon","migrant","migrate","migratory","miguel","mike","mila","milan","milch"
DATA "mild","mildew","mildred","mile","mileage","miles","milestone","milieu","militant","militarism","militarist","military","militate","militia","militiamen","milk","milkweed","milky","mill","millard"
DATA "millenarian","millenia","millennia","millennium","miller","millet","millie","millikan","millinery","million","millionaire","millions","millionth","millipede","mills","millstone","milord","milt","milton","miltonic"
DATA "milwaukee","mimeograph","mimesis","mimetic","mimi","mimic","mimicked","mimicking","min","minaret","mince","mincemeat","mind","mindanao","mindful","mine","minefield","mineral","mineralogy","minerva"
DATA "minestrone","minesweeper","mingle","mini","miniature","minibike","minicomputer","minim","minima","minimal","minimax","minimum","minion","ministerial","ministry","mink","minneapolis","minnesota","minnie","minnow"
DATA "minoan","minor","minos","minot","minsk","minsky","minstrel","minstrelsy","mint","minuend","minuet","minus","minuscule","minute","minuteman","minutemen","minutiae","miocene","mira","miracle"
DATA "miraculous","mirage","miranda","mire","mirfak","miriam","mirror","mirth","misanthrope","misanthropic","miscegenation","miscellaneous","miscellany","mischievous","miscible","miscreant","miser","misery","misnomer","misogynist"
DATA "misogyny","mispronunciation","miss","misshapen","missile","mission","missionary","mississippi","mississippian","missive","missoula","missouri","missy","mist","mistletoe","mistress","misty","mit","mitchell","mite"
DATA "miterwort","mitigate","mitochondria","mitosis","mitral","mitre","mitt","mitten","mix","mixture","mixup","mizar","mn","mnemonic","mo","moan","moat","mob","mobcap","mobil"
DATA "mobile","mobility","mobster","moccasin","mock","mockernut","mockery","mockingbird","mockup","modal","mode","model","modem","moderate","modern","modest","modesto","modesty","modicum","modify"
DATA "modish","modular","modulate","module","moduli","modulo","modulus","modus","moe","moen","mogadiscio","mohammedan","mohawk","mohr","moiety","moines","moire","moiseyev","moist","moisten"
DATA "moisture","molal","molar","molasses","mold","moldavia","moldboard","mole","molecular","molecule","molehill","molest","moliere","moline","moll","mollie","mollify","mollusk","molly","mollycoddle"
DATA "moloch","molt","molten","moluccas","molybdate","molybdenite","molybdenum","moment","momenta","momentary","momentous","momentum","mommy","mona","monaco","monad","monadic","monarch","monarchic","monarchy"
DATA "monash","monastery","monastic","monaural","monday","monel","monetarism","monetarist","monetary","money","moneymake","moneywort","mongolia","mongoose","monic","monica","monies","monitor","monitory","monk"
DATA "monkey","monkeyflower","monkish","monmouth","monoceros","monochromatic","monochromator","monocotyledon","monocular","monogamous","monogamy","monoid","monolith","monologist","monologue","monomer","monomeric","monomial","monongahela","monopoly"
DATA "monotonous","monotreme","monoxide","monroe","monrovia","monsanto","monsieur","monsoon","monster","monstrosity","monstrous","mont","montage","montague","montana","montclair","monte","montenegrin","monterey","monteverdi"
DATA "montevideo","montgomery","month","monticello","montmartre","montpelier","montrachet","montreal","monty","monument","moo","mood","moody","moon","mooney","moonlight","moonlit","moor","moore","moorish"
DATA "moose","moot","mop","moraine","moral","morale","moran","morass","moratorium","moravia","morbid","more","morel","moreland","moreover","moresby","morgan","morgen","morgue","moriarty"
DATA "moribund","morley","mormon","morn","moroccan","morocco","moron","morose","morpheme","morphemic","morphine","morphism","morphology","morphophonemic","morrill","morris","morrison","morrissey","morristown","morrow"
DATA "morse","morsel","mort","mortal","mortar","mortem","mortgage","mortgagee","mortgagor","mortician","mortify","mortise","morton","mosaic","moscow","moser","moses","moslem","mosque","mosquito"
DATA "moss","mossy","most","mot","motel","motet","moth","mothball","mother","motherhood","motherland","motif","motion","motivate","motive","motley","motor","motorcycle","motorola","mottle"
DATA "motto","mould","moulton","mound","mount","mountain","mountaineer","mountainous","mountainside","mourn","mournful","mouse","moustache","mousy","mouth","mouthful","mouthpiece","mouton","move","movie"
DATA "mow","moyer","mozart","mph","mr","mrs","ms","mt","mu","much","mucilage","muck","mucosa","mucus","mud","mudd","muddle","muddlehead","muddy","mudguard"
DATA "mudsling","mueller","muezzin","muff","muffin","muffle","mug","mugging","muggy","mugho","muir","mukden","mulatto","mulberry","mulch","mulct","mule","mulish","mull","mullah"
DATA "mullein","mullen","mulligan","mulligatawny","mullion","multi","multifarious","multinomial","multiple","multiplet","multiplex","multiplexor","multipliable","multiplicand","multiplication","multiplicative","multiplicity","multiply","multitude","multitudinous"
DATA "mum","mumble","mumford","mummy","munch","muncie","mundane","mung","munich","municipal","munificent","munition","munson","muon","muong","mural","murder","murderous","muriatic","muriel"
DATA "murk","murky","murmur","murphy","murray","murre","muscat","muscle","muscovite","muscovy","muscular","musculature","muse","museum","mush","mushroom","mushy","music","musicale","musician"
DATA "musicology","musk","muskegon","muskellunge","musket","muskmelon","muskox","muskoxen","muskrat","muslim","muslin","mussel","must","mustache","mustachio","mustang","mustard","mustn't","musty","mutagen"
DATA "mutandis","mutant","mutate","mutatis","mute","mutilate","mutineer","mutiny","mutt","mutter","mutton","mutual","mutuel","muzak","muzo","muzzle","my","mycenae","mycenaean","mycobacteria"
DATA "mycology","myel","myeline","myeloid","myers","mylar","mynah","mynheer","myocardial","myocardium","myofibril","myoglobin","myopia","myopic","myosin","myra","myriad","myron","myrrh","myrtle"
DATA "myself","mysterious","mystery","mystic","mystify","mystique","myth","mythic","mythology","n","n's","naacp","nab","nabisco","nabla","nadia","nadine","nadir","nag","nagasaki"
DATA "nagging","nagoya","nagy","naiad","nail","nair","nairobi","naive","naivete","nakayama","naked","name","nameable","nameplate","namesake","nan","nancy","nanette","nanking","nanometer"
DATA "nanosecond","nantucket","naomi","nap","nape","napkin","naples","napoleon","napoleonic","narbonne","narcissism","narcissist","narcissus","narcosis","narcotic","narragansett","narrate","narrow","nary","nasa"
DATA "nasal","nascent","nash","nashua","nashville","nassau","nasturtium","nasty","nat","natal","natalie","natchez","nate","nathan","nathaniel","nation","nationhood","nationwide","native","nato"
DATA "natty","natural","nature","naturopath","naughty","nausea","nauseate","nauseum","nautical","nautilus","navajo","naval","nave","navel","navigable","navigate","navy","nay","nazarene","nazareth"
DATA "nazi","nazism","nbc","nbs","nc","ncaa","ncar","nco","ncr","nd","ndjamena","ne","neal","neanderthal","neap","neapolitan","near","nearby","nearest","nearsighted"
DATA "neat","neater","neath","nebraska","nebula","nebulae","nebular","nebulous","necessary","necessitate","necessity","neck","necklace","neckline","necktie","necromancer","necromancy","necromantic","necropsy","necrosis"
DATA "necrotic","nectar","nectareous","nectarine","nectary","ned","nee","need","needful","needham","needle","needlepoint","needlework","needn't","needy","neff","negate","neglect","neglecter","negligee"
DATA "negligent","negligible","negotiable","negotiate","negro","negroes","negroid","nehru","neil","neither","nell","nellie","nelsen","nelson","nemesis","neoclassic","neoconservative","neodymium","neolithic","neologism"
DATA "neon","neonatal","neonate","neophyte","neoprene","nepal","nepenthe","nephew","neptune","neptunium","nereid","nero","nerve","nervous","ness","nest","nestle","nestor","net","nether"
DATA "netherlands","netherworld","nettle","nettlesome","network","neumann","neural","neuralgia","neurasthenic","neuritis","neuroanatomic","neuroanatomy","neuroanotomy","neurology","neuromuscular","neuron","neuronal","neuropathology","neurophysiology","neuropsychiatric"
DATA "neuroses","neurosis","neurotic","neuter","neutral","neutrino","neutron","neva","nevada","neve","never","nevertheless","nevins","new","newark","newbold","newborn","newcastle","newcomer","newel"
DATA "newell","newfound","newfoundland","newline","newlywed","newman","newport","newsboy","newscast","newsletter","newsman","newsmen","newspaper","newspaperman","newspapermen","newsreel","newsstand","newsweek","newt","newton"
DATA "newtonian","next","nguyen","nh","niacin","niagara","niamey","nib","nibble","nibelung","nibs","nicaragua","nice","nicety","niche","nicholas","nicholls","nichols","nicholson","nichrome"
DATA "nick","nickel","nickname","nicodemus","nicosia","nicotinamide","nicotine","niece","nielsen","nielson","nietzsche","niger","nigeria","niggardly","nigger","niggle","nigh","night","nightcap","nightclub"
DATA "nightdress","nightfall","nightgown","nighthawk","nightingale","nightmare","nightmarish","nightshirt","nighttime","nih","nihilism","nihilist","nikko","nikolai","nil","nile","nilpotent","nimble","nimbus","nimh"
DATA "nina","nine","ninebark","ninefold","nineteen","nineteenth","ninetieth","ninety","nineveh","ninth","niobe","niobium","nip","nipple","nippon","nirvana","nit","nitpick","nitrate","nitric"
DATA "nitride","nitrite","nitrogen","nitrogenous","nitroglycerine","nitrous","nitty","nixon","nj","nm","nne","nnw","no","noaa","noah","nob","nobel","nobelium","noble","nobleman"
DATA "noblemen","noblesse","nobody","nobody'd","nocturnal","nocturne","nod","nodal","node","nodular","nodule","noel","noetherian","noise","noisemake","noisy","nolan","noll","nolo","nomad"
DATA "nomadic","nomenclature","nominal","nominate","nominee","nomogram","nomograph","non","nonagenarian","nonce","nonchalant","nondescript","none","nonetheless","nonogenarian","nonsensic","nonsensical","noodle","nook","noon"
DATA "noontime","noose","nor","nora","nordhoff","nordstrom","noreen","norfolk","norm","norma","normal","normalcy","norman","normandy","normative","norris","north","northampton","northbound","northeast"
DATA "northeastern","northerly","northern","northernmost","northland","northrop","northrup","northumberland","northward","northwest","northwestern","norton","norwalk","norway","norwegian","norwich","nose","nosebag","nosebleed","nostalgia"
DATA "nostalgic","nostradamus","nostrand","nostril","not","notary","notate","notch","note","notebook","noteworthy","nothing","notice","noticeable","notify","notion","notocord","notoriety","notorious","notre"
DATA "nottingham","notwithstanding","nouakchott","noun","nourish","nouveau","nov","nova","novak","novel","novelty","november","novice","novitiate","novo","novosibirsk","now","nowaday","nowadays","nowhere"
DATA "nowise","noxious","nozzle","nrc","nsf","ntis","nu","nuance","nubia","nubile","nucleant","nuclear","nucleate","nuclei","nucleic","nucleoli","nucleolus","nucleotide","nucleus","nuclide"
DATA "nude","nudge","nugatory","nugget","nuisance","null","nullify","nullstellensatz","numb","numerable","numeral","numerate","numeric","numerische","numerology","numerous","numinous","numismatic","numismatist","nun"
DATA "nuptial","nurse","nursery","nurture","nut","nutate","nutcrack","nuthatch","nutmeg","nutria","nutrient","nutrition","nutritious","nutritive","nutshell","nuzzle","nv","nw","ny","nyc"
DATA "nylon","nymph","nymphomania","nymphomaniac","nyquist","nyu","o","o'brien","o'clock","o'connell","o'connor","o'dell","o'donnell","o'dwyer","o'er","o'hare","o'leary","o'neill","o's","o'shea"
DATA "o'sullivan","oaf","oak","oaken","oakland","oakley","oakwood","oar","oases","oasis","oat","oath","oatmeal","obduracy","obdurate","obedient","obeisant","obelisk","oberlin","obese"
DATA "obey","obfuscate","obfuscatory","obituary","object","objectify","objectivity","objector","objet","oblate","obligate","obligatory","oblige","oblique","obliterate","oblivion","oblivious","oblong","obnoxious","oboe"
DATA "oboist","obscene","obscure","obsequious","obsequy","observant","observation","observatory","observe","obsess","obsession","obsessive","obsidian","obsolescent","obsolete","obstacle","obstetric","obstinacy","obstinate","obstruct"
DATA "obstruent","obtain","obtrude","obtrusion","obtrusive","obverse","obviate","obvious","ocarina","occasion","occident","occidental","occipital","occlude","occlusion","occlusive","occult","occultate","occultation","occupant"
DATA "occupation","occupy","occur","occurred","occurrent","occurring","ocean","oceania","oceanic","oceanographer","oceanography","oceanside","ocelot","oct","octagon","octagonal","octahedra","octahedral","octahedron","octal"
DATA "octane","octant","octave","octavia","octennial","octet","octile","octillion","october","octogenarian","octopus","octoroon","ocular","odd","ode","odessa","odin","odious","odium","odometer"
DATA "odorous","odysseus","odyssey","oedipal","oedipus","oersted","of","off","offal","offbeat","offenbach","offend","offensive","offer","offertory","offhand","office","officeholder","officemate","official"
DATA "officialdom","officiate","officio","officious","offload","offprint","offsaddle","offset","offsetting","offshoot","offshore","offspring","offstage","oft","often","oftentimes","ogden","ogle","ogre","ogress"
DATA "oh","ohio","ohm","ohmic","ohmmeter","oil","oilcloth","oilman","oilmen","oilseed","oily","oint","ointment","ok","okay","okinawa","oklahoma","olaf","olav","old"
DATA "olden","oldenburg","oldsmobile","oldster","oldy","oleander","olefin","oleomargarine","olfactory","olga","oligarchic","oligarchy","oligoclase","oligopoly","olin","olive","oliver","olivetti","olivia","olivine"
DATA "olsen","olson","olympia","olympic","omaha","oman","ombudsman","ombudsperson","omega","omelet","omen","omicron","ominous","omission","omit","omitted","omitting","omnibus","omnipotent","omnipresent"
DATA "omniscient","on","once","oncology","oncoming","one","oneida","onerous","oneself","onetime","oneupmanship","ongoing","onion","onlook","onlooker","onlooking","only","onomatopoeia","onomatopoeic","onondaga"
DATA "onrush","onrushing","onset","onslaught","ontario","onto","ontogeny","ontology","onus","onward","onyx","oocyte","oodles","ooze","opacity","opal","opalescent","opaque","opec","opel"
DATA "open","opera","operable","operand","operant","operate","operatic","operetta","operon","ophiuchus","ophthalmic","ophthalmology","opiate","opine","opinion","opinionate","opium","opossum","oppenheimer","opponent"
DATA "opportune","opposable","oppose","opposite","opposition","oppress","oppression","oppressive","oppressor","opprobrium","opt","optic","optima","optimal","optimism","optimist","optimistic","optimum","option","optoacoustic"
DATA "optoelectronic","optoisolate","optometrist","optometry","opulent","opus","or","oracle","oracular","oral","orange","orangeroot","orangutan","orate","oratoric","oratorical","oratorio","oratory","orb","orbit"
DATA "orbital","orchard","orchestra","orchestral","orchestrate","orchid","orchis","ordain","ordeal","order","orderly","ordinal","ordinance","ordinary","ordinate","ordnance","ore","oregano","oregon","oresteia"
DATA "orestes","organ","organdy","organic","organismic","organometallic","orgasm","orgiastic","orgy","orient","oriental","orifice","origin","original","originate","orin","orinoco","oriole","orion","orkney"
DATA "orlando","orleans","ornament","ornamentation","ornate","ornately","ornery","orographic","orography","orono","orphan","orphanage","orpheus","orphic","orr","ortega","orthant","orthicon","orthoclase","orthodontic"
DATA "orthodontist","orthodox","orthodoxy","orthogonal","orthography","orthonormal","orthopedic","orthophosphate","orthorhombic","orville","orwell","orwellian","osaka","osborn","osborne","oscar","oscillate","oscillatory","oscilloscope","osgood"
DATA "osha","oshkosh","osier","osiris","oslo","osmium","osmosis","osmotic","osprey","osseous","ossify","ostensible","ostentatious","osteology","osteopath","osteopathic","osteopathy","osteoporosis","ostracism","ostracod"
DATA "ostrander","ostrich","oswald","othello","other","otherwise","otherworld","otherworldly","otiose","otis","ott","ottawa","otter","otto","ottoman","ouagadougou","ouch","ought","oughtn't","ounce"
DATA "our","ourselves","oust","out","outermost","outlandish","outlawry","outrageous","ouvre","ouzel","ouzo","ova","oval","ovary","ovate","oven","ovenbird","over","overhang","overt"
DATA "overture","ovid","oviform","ovum","ow","owe","owens","owing","owl","owly","own","ox","oxalate","oxalic","oxcart","oxen","oxeye","oxford","oxidant","oxidate"
DATA "oxide","oxnard","oxonian","oxygen","oxygenate","oyster","ozark","ozone","p","p's","pa","pablo","pabst","pace","pacemake","pacesetting","pacific","pacifism","pacifist","pacify"
DATA "pack","package","packard","packet","pact","pad","paddle","paddock","paddy","padlock","padre","paean","pagan","page","pageant","pageantry","paginate","pagoda","paid","pail"
DATA "pain","paine","painful","painstaking","paint","paintbrush","pair","pairwise","pakistan","pakistani","pal","palace","palate","palatine","palazzi","palazzo","pale","paleolithic","paleozoic","palermo"
DATA "palestine","palestinian","palette","palfrey","palindrome","palindromic","palisade","pall","palladia","palladian","palladium","pallet","palliate","pallid","palm","palmate","palmetto","palmolive","palmyra","palo"
DATA "palomar","palpable","palsy","pam","pamela","pampa","pamper","pamphlet","pan","panacea","panama","pancake","pancho","pancreas","pancreatic","panda","pandanus","pandemic","pandemonium","pander"
DATA "pandora","pane","panel","pang","panhandle","panic","panicked","panicky","panicle","panjandrum","panoply","panorama","panoramic","pansy","pant","pantheism","pantheist","pantheon","panther","pantomime"
DATA "pantomimic","pantry","panty","paoli","pap","papa","papacy","papal","papaw","paper","paperback","paperbound","paperweight","paperwork","papery","papillary","papoose","pappas","pappy","paprika"
DATA "papua","papyri","papyrus","par","parabola","parabolic","paraboloid","paraboloidal","parachute","parade","paradigm","paradigmatic","paradise","paradox","paradoxic","paraffin","paragon","paragonite","paragraph","paraguay"
DATA "parakeet","paralinguistic","parallax","parallel","parallelepiped","parallelogram","paralysis","paramagnet","paramagnetic","paramedic","parameter","paramilitary","paramount","paramus","paranoia","paranoiac","paranoid","paranormal","parapet","paraphernalia"
DATA "paraphrase","parapsychology","parasite","parasitic","parasol","parasympathetic","paratroop","paraxial","parboil","parcel","parch","pardon","pare","paregoric","parent","parentage","parental","parentheses","parenthesis","parenthetic"
DATA "parenthood","pareto","pariah","parimutuel","paris","parish","parishioner","parisian","park","parke","parkinson","parkish","parkland","parks","parkway","parlance","parlay","parley","parliament","parliamentarian"
DATA "parliamentary","parochial","parody","parole","parolee","parquet","parr","parrish","parrot","parry","parse","parsifal","parsimonious","parsimony","parsley","parsnip","parson","parsonage","parsons","part"
DATA "partake","parthenon","partial","participant","participate","participle","particle","particular","particulate","partisan","partition","partner","partook","partridge","party","parvenu","pasadena","pascal","paschal","pasha"
DATA "paso","pass","passage","passageway","passaic","passband","passe","passenger","passer","passerby","passion","passionate","passivate","passive","passover","passport","password","past","paste","pasteboard"
DATA "pastel","pasteup","pasteur","pastiche","pastime","pastor","pastoral","pastry","pasture","pasty","pat","patagonia","patch","patchwork","patchy","pate","patent","patentee","pater","paternal"
DATA "paternoster","paterson","path","pathetic","pathfind","pathogen","pathogenesis","pathogenic","pathology","pathos","pathway","patient","patina","patio","patriarch","patriarchal","patriarchy","patrice","patricia","patrician"
DATA "patrick","patrimonial","patrimony","patriot","patriotic","patristic","patrol","patrolled","patrolling","patrolman","patrolmen","patron","patronage","patroness","patsy","pattern","patterson","patti","patton","patty"
DATA "paucity","paul","paula","paulette","pauli","pauline","paulo","paulsen","paulson","paulus","paunch","paunchy","pauper","pause","pavanne","pave","pavilion","pavlov","paw","pawn"
DATA "pawnshop","pawtucket","pax","pay","paycheck","payday","paymaster","payne","payoff","payroll","paz","pbs","pdp","pea","peabody","peace","peaceable","peaceful","peacemake","peacetime"
DATA "peach","peachtree","peacock","peafowl","peak","peaky","peal","peale","peanut","pear","pearce","pearl","pearlite","pearlstone","pearson","peasant","peasanthood","pease","peat","pebble"
DATA "pecan","peccary","peck","pecos","pectoral","pectoralis","peculate","peculiar","pecuniary","pedagogic","pedagogue","pedagogy","pedal","pedant","pedantic","pedantry","peddle","pedestal","pedestrian","pediatric"
DATA "pediatrician","pedigree","pediment","pedro","pee","peed","peek","peel","peep","peephole","peepy","peer","peg","pegasus","pegboard","pegging","peggy","pejorative","peking","pelham"
DATA "pelican","pellagra","pellet","pelt","peltry","pelvic","pelvis","pembroke","pemmican","pen","penal","penalty","penance","penates","pence","penchant","pencil","pend","pendant","pendulum"
DATA "penelope","penetrable","penetrate","penguin","penh","penicillin","peninsula","penis","penitent","penitential","penitentiary","penman","penmen","penn","penna","pennant","pennsylvania","penny","pennyroyal","penrose"
DATA "pensacola","pension","pensive","pent","pentagon","pentagonal","pentagram","pentane","pentecost","pentecostal","penthouse","penultimate","penumbra","penurious","penury","peony","people","peoria","pep","peppergrass"
DATA "peppermint","pepperoni","peppery","peppy","pepsi","pepsico","peptide","per","perceive","percent","percentage","percentile","percept","perceptible","perception","perceptive","perceptual","perch","perchance","perchlorate"
DATA "percival","percolate","percussion","percussive","percy","perdition","peregrine","peremptory","perennial","perez","perfect","perfecter","perfectible","perfidious","perfidy","perforate","perforce","perform","performance","perfume"
DATA "perfumery","perfunctory","perfuse","perfusion","pergamon","perhaps","periclean","pericles","peridotite","perihelion","peril","perilla","perilous","perimeter","period","periodic","peripatetic","peripheral","periphery","periphrastic"
DATA "periscope","perish","peritectic","periwinkle","perjure","perjury","perk","perkins","perky","perle","permalloy","permanent","permeable","permeate","permian","permissible","permission","permissive","permit","permitted"
DATA "permitting","permutation","permute","pernicious","peroxide","perpendicular","perpetrate","perpetual","perpetuate","perpetuity","perplex","perquisite","perry","persecute","persecution","persecutory","perseus","perseverance","perseverant","persevere"
DATA "pershing","persia","persian","persiflage","persimmon","persist","persistent","person","persona","personage","personal","personify","personnel","perspective","perspicacious","perspicuity","perspicuous","perspiration","perspire","persuade"
DATA "persuasion","persuasive","pert","pertain","perth","pertinacious","pertinent","perturb","perturbate","perturbation","peru","perusal","peruse","peruvian","pervade","pervasion","pervasive","perverse","perversion","pervert"
DATA "pessimal","pessimism","pessimist","pessimum","pest","peste","pesticide","pestilent","pestilential","pestle","pet","petal","pete","petersburg","petersen","peterson","petit","petite","petition","petrel"
DATA "petri","petrifaction","petrify","petrochemical","petroglyph","petrol","petroleum","petrology","petticoat","petty","petulant","petunia","peugeot","pew","pewee","pewter","pfennig","pfizer","ph.d","phage"
DATA "phagocyte","phalanger","phalanx","phalarope","phantasy","phantom","pharaoh","pharmaceutic","pharmacist","pharmacology","pharmacopoeia","pharmacy","phase","phd","pheasant","phelps","phenol","phenolic","phenomena","phenomenal"
DATA "phenomenology","phenomenon","phenotype","phenyl","phenylalanine","phi","phil","philadelphia","philanthrope","philanthropic","philanthropy","philharmonic","philip","philippine","philistine","phillip","phillips","philodendron","philology","philosoph"
DATA "philosopher","philosophic","philosophy","phipps","phloem","phlox","phobic","phoebe","phoenicia","phoenix","phon","phone","phoneme","phonemic","phonetic","phonic","phonograph","phonology","phonon","phony"
DATA "phosgene","phosphate","phosphide","phosphine","phosphor","phosphoresce","phosphorescent","phosphoric","phosphorus","phosphorylate","photo","photogenic","photography","photolysis","photolytic","photometry","photon","phrase","phrasemake","phraseology"
DATA "phthalate","phycomycetes","phyla","phyllis","phylogeny","physic","physician","physik","physiochemical","physiognomy","physiology","physiotherapist","physiotherapy","physique","phytoplankton","pi","pianissimo","pianist","piano","piazza"
DATA "pica","picasso","picayune","piccadilly","piccolo","pick","pickaxe","pickerel","pickering","picket","pickett","pickford","pickle","pickman","pickoff","pickup","picky","picnic","picnicked","picnicker"
DATA "picnicking","picofarad","picojoule","picosecond","pictorial","picture","picturesque","piddle","pidgin","pie","piece","piecemeal","piecewise","piedmont","pier","pierce","pierre","pierson","pietism","piety"
DATA "piezoelectric","pig","pigeon","pigeonberry","pigeonfoot","pigeonhole","pigging","piggish","piggy","piggyback","pigment","pigmentation","pigpen","pigroot","pigskin","pigtail","pike","pilate","pile","pilewort"
DATA "pilfer","pilferage","pilgrim","pilgrimage","pill","pillage","pillar","pillory","pillow","pillsbury","pilot","pimp","pimple","pin","pinafore","pinball","pinch","pincushion","pine","pineapple"
DATA "pinehurst","ping","pinhead","pinhole","pinion","pink","pinkie","pinkish","pinnacle","pinnate","pinochle","pinpoint","pinscher","pinsky","pint","pintail","pinto","pinwheel","pinxter","pion"
DATA "pioneer","piotr","pious","pip","pipe","pipeline","piper","pipette","pipsissewa","piquant","pique","piracy","piraeus","pirate","pirogue","pirouette","piscataway","pisces","piss","pistachio"
DATA "pistol","pistole","piston","pit","pitch","pitchblende","pitchfork","pitchstone","piteous","pitfall","pith","pithy","pitiable","pitiful","pitilessly","pitman","pitney","pitt","pittsburgh","pittsfield"
DATA "pittston","pituitary","pity","pius","pivot","pivotal","pixel","pixy","pizza","pizzeria","pizzicato","pl","placate","placater","place","placeable","placebo","placeholder","placenta","placental"
DATA "placid","plagiarism","plagiarist","plagioclase","plague","plagued","plaguey","plaid","plain","plainfield","plaintiff","plaintive","plan","planar","planck","plane","planeload","planet","planetaria","planetarium"
DATA "planetary","planetesimal","planetoid","plank","plankton","planoconcave","planoconvex","plant","plantain","plantation","plaque","plasm","plasma","plasmon","plaster","plastic","plastisol","plastron","plat","plate"
DATA "plateau","platelet","platen","platform","platinum","platitude","platitudinous","plato","platonic","platonism","platonist","platoon","platte","platypus","plausible","play","playa","playback","playboy","playful"
DATA "playground","playhouse","playmate","playoff","playroom","plaything","playtime","playwright","playwriting","plaza","plea","plead","pleasant","please","pleasure","pleat","plebeian","plebian","pledge","pleiades"
DATA "pleistocene","plenary","plenipotentiary","plenitude","plentiful","plenty","plenum","plethora","pleura","pleural","plexiglas","pliable","pliancy","pliant","pliers","plight","pliny","pliocene","plod","plop"
DATA "plot","plover","plowman","plowshare","pluck","plucky","plug","plugboard","pluggable","plugging","plum","plumage","plumb","plumbago","plumbate","plume","plummet","plump","plunder","plunge"
DATA "plunk","pluperfect","plural","plus","plush","plushy","plutarch","pluto","pluton","plutonium","ply","plymouth","plyscore","plywood","pm","pneumatic","pneumococcus","pneumonia","po","poach"
DATA "pobox","pocket","pocketbook","pocketful","pocono","pocus","pod","podge","podia","podium","poe","poem","poesy","poet","poetic","poetry","pogo","pogrom","poi","poignant"
DATA "poincare","poinsettia","point","pointwise","poise","poison","poisonous","poisson","poke","pokerface","pol","poland","polar","polarimeter","polaris","polariscope","polariton","polarogram","polarograph","polarography"
DATA "polaroid","polaron","pole","polecat","polemic","police","policeman","policemen","policy","polio","poliomyelitis","polis","polish","politburo","polite","politic","politician","politicking","politico","polity"
DATA "polk","polka","polkadot","poll","pollard","pollen","pollinate","pollock","polloi","pollster","pollutant","pollute","pollution","pollux","polo","polonaise","polonium","polopony","polyglot","polygon"
DATA "polygonal","polygynous","polyhedra","polyhedral","polyhedron","polyhymnia","polymer","polymerase","polymeric","polymorph","polymorphic","polynomial","polyphemus","polyphony","polyploidy","polypropylene","polysaccharide","polytechnic","polytope","polytypy"
DATA "pomade","pomegranate","pomona","pomp","pompadour","pompano","pompeii","pompey","pompon","pomposity","pompous","ponce","ponchartrain","poncho","pond","ponder","ponderous","pong","pont","pontiac"
DATA "pontiff","pontific","pontificate","pony","pooch","poodle","pooh","pool","poole","poop","poor","pop","popcorn","pope","popish","poplar","poplin","poppy","populace","popular"
DATA "populate","populism","populist","populous","porcelain","porch","porcine","porcupine","pore","pork","pornographer","pornography","porosity","porous","porphyry","porpoise","porridge","port","portage","portal"
DATA "porte","portend","portent","portentous","porterhouse","portfolio","portia","portico","portland","portmanteau","porto","portrait","portraiture","portray","portrayal","portsmouth","portugal","portuguese","portulaca","posable"
DATA "pose","poseidon","poseur","posey","posh","posit","position","positive","positron","posner","posse","posseman","possemen","possess","possession","possessive","possessor","possible","possum","post"
DATA "postage","postal","postcard","postcondition","postdoctoral","posterior","posteriori","posterity","postfix","postgraduate","posthumous","postlude","postman","postmark","postmaster","postmen","postmortem","postmultiply","postoperative","postorder"
DATA "postpaid","postpone","postposition","postprocess","postprocessor","postscript","postulate","posture","postwar","posy","pot","potable","potash","potassium","potato","potatoes","potbelly","potboil","potent","potentate"
DATA "potential","potentiometer","pothole","potion","potlatch","potomac","potpourri","pottery","potts","pouch","poughkeepsie","poultice","poultry","pounce","pound","pour","pout","poverty","pow","powder"
DATA "powderpuff","powdery","powell","power","powerful","powerhouse","powers","poynting","ppm","pr","practicable","practical","practice","practise","practitioner","prado","praecox","pragmatic","pragmatism","pragmatist"
DATA "prague","prairie","praise","praiseworthy","pram","prance","prank","praseodymium","pratt","pravda","pray","prayer","prayerful","preach","preachy","preamble","precambrian","precarious","precaution","precautionary"
DATA "precede","precedent","precept","precess","precession","precinct","precious","precipice","precipitable","precipitate","precipitous","precis","precise","precision","preclude","precocious","precocity","precursor","predatory","predecessor"
DATA "predicament","predicate","predict","predictor","predilect","predispose","predisposition","predominant","predominate","preeminent","preempt","preemption","preemptive","preemptor","preen","prefab","prefabricate","preface","prefatory","prefect"
DATA "prefecture","prefer","preference","preferential","preferred","preferring","prefix","pregnant","prehistoric","prejudice","prejudicial","preliminary","prelude","premature","premeditate","premier","premiere","premise","premium","premonition"
DATA "premonitory","prentice","preoccupy","prep","preparation","preparative","preparatory","prepare","preponderant","preponderate","preposition","preposterous","prerequisite","prerogative","presage","presbyterian","presbytery","prescott","prescribe","prescript"
DATA "prescription","prescriptive","presence","present","presentation","presentational","preservation","preserve","preside","president","presidential","press","pressure","prestidigitate","prestige","prestigious","presto","preston","presume","presumed"
DATA "presuming","presumption","presumptive","presumptuous","presuppose","presupposition","pretend","pretense","pretension","pretentious","pretext","pretoria","pretty","prevail","prevalent","prevent","prevention","preventive","preview","previous"
DATA "prexy","prey","priam","price","prick","prickle","pride","priest","priestley","prig","priggish","prim","prima","primacy","primal","primary","primate","prime","primeval","primitive"
DATA "primitivism","primordial","primp","primrose","prince","princess","princeton","principal","principia","principle","print","printmake","printout","prior","priori","priory","priscilla","prism","prismatic","prison"
DATA "prissy","pristine","pritchard","privacy","private","privet","privilege","privy","prize","prizewinning","pro","probabilist","probate","probe","probity","problem","problematic","procaine","procedural","procedure"
DATA "proceed","process","procession","processor","proclaim","proclamation","proclivity","procrastinate","procreate","procrustean","procrustes","procter","proctor","procure","procyon","prod","prodigal","prodigious","prodigy","produce"
DATA "producible","product","productivity","prof","profane","profess","profession","professional","professor","professorial","proffer","proficient","profile","profit","profiteer","profligacy","profligate","profound","profundity","profuse"
DATA "profusion","progenitor","progeny","prognosis","prognosticate","programmable","programmed","programmer","programming","progress","progression","progressive","prohibit","prohibition","prohibitive","prohibitory","project","projectile","projector","prokaryote"
DATA "prokofieff","prolate","prolegomena","proletariat","proliferate","prolific","proline","prolix","prologue","prolong","prolongate","prolusion","prom","promenade","promethean","prometheus","promethium","prominent","promiscuity","promiscuous"
DATA "promise","promote","promotion","prompt","promptitude","promulgate","prone","prong","pronoun","pronounce","pronounceable","pronto","pronunciation","proof","proofread","prop","propaganda","propagandist","propagate","propane"
DATA "propel","propellant","propelled","propeller","propelling","propensity","proper","property","prophecy","prophesy","prophet","prophetic","prophylactic","propionate","propitiate","propitious","proponent","proportion","proportionate","propos"
DATA "proposal","propose","proposition","propound","proprietary","proprietor","propriety","proprioception","proprioceptive","propulsion","propyl","propylene","prorate","prorogue","prosaic","proscenium","proscribe","proscription","prose","prosecute"
DATA "prosecution","prosecutor","proserpine","prosodic","prosody","prosopopoeia","prospect","prospector","prospectus","prosper","prosperous","prostate","prostheses","prosthesis","prosthetic","prostitute","prostitution","prostrate","protactinium","protagonist"
DATA "protean","protease","protect","protector","protectorate","protege","protein","proteolysis","proteolytic","protest","protestant","protestation","prothonotary","protocol","proton","protophyta","protoplasm","protoplasmic","prototype","prototypic"
DATA "protozoa","protozoan","protract","protrude","protrusion","protrusive","protuberant","proud","proust","prove","proven","provenance","proverb","proverbial","provide","provident","providential","province","provincial","provision"
DATA "provisional","proviso","provocateur","provocation","provocative","provoke","provost","prow","prowess","prowl","proximal","proximate","proximity","proxy","prudent","prudential","prune","prurient","prussia","pry"
DATA "psalm","psalter","psaltery","pseudo","psi","psych","psyche","psychiatric","psychiatrist","psychiatry","psychic","psycho","psychoacoustic","psychoanalysis","psychoanalyst","psychoanalytic","psychobiology","psychology","psychometry","psychopath"
DATA "psychopathic","psychophysic","psychophysiology","psychopomp","psychoses","psychosis","psychosomatic","psychotherapeutic","psychotherapist","psychotherapy","psychotic","psyllium","pta","ptarmigan","pterodactyl","ptolemaic","ptolemy","pub","puberty","pubescent"
DATA "public","publication","publish","puc","puccini","puck","puckish","pudding","puddingstone","puddle","puddly","pueblo","puerile","puerto","puff","puffball","puffed","puffery","puffin","puffy"
DATA "pug","pugh","pugnacious","puissant","puke","pulaski","pulitzer","pull","pullback","pulley","pullman","pullover","pulmonary","pulp","pulpit","pulsar","pulsate","pulse","pulverable","puma"
DATA "pumice","pummel","pump","pumpkin","pumpkinseed","pun","punch","punctual","punctuate","puncture","pundit","punditry","pungent","punic","punish","punitive","punk","punky","punster","punt"
DATA "puny","pup","pupal","pupate","pupil","puppet","puppeteer","puppy","puppyish","purcell","purchasable","purchase","purdue","pure","purgation","purgative","purgatory","purge","purify","purina"
DATA "purine","puritan","puritanic","purl","purloin","purple","purport","purpose","purposeful","purposive","purr","purse","purslane","pursuant","pursue","pursuer","pursuit","purvey","purveyor","purview"
DATA "pus","pusan","pusey","push","pushbutton","pushout","pushpin","pussy","pussycat","put","putative","putnam","putt","putty","puzzle","pvc","pygmalion","pygmy","pyhrric","pyknotic"
DATA "pyle","pyongyang","pyracanth","pyramid","pyramidal","pyre","pyrex","pyridine","pyrimidine","pyrite","pyroelectric","pyrolyse","pyrolysis","pyrometer","pyrophosphate","pyrotechnic","pyroxene","pyroxenite","pyrrhic","pythagoras"
DATA "pythagorean","python","q","q's","qatar","qed","qua","quack","quackery","quad","quadrangle","quadrangular","quadrant","quadratic","quadrature","quadrennial","quadric","quadriceps","quadrilateral","quadrille"
DATA "quadrillion","quadripartite","quadrivium","quadruple","quadrupole","quaff","quagmire","quahog","quail","quaint","quake","quakeress","qualified","qualify","qualitative","quality","qualm","quandary","quanta","quantico"
DATA "quantify","quantile","quantitative","quantity","quantum","quarantine","quark","quarrel","quarrelsome","quarry","quarryman","quarrymen","quart","quarterback","quartermaster","quartet","quartic","quartile","quartz","quartzite"
DATA "quasar","quash","quasi","quasicontinuous","quasiorder","quasiparticle","quasiperiodic","quasistationary","quaternary","quatrain","quaver","quay","queasy","quebec","queen","queer","quell","quench","querulous","query"
DATA "quest","question","questionnaire","quetzal","queue","quezon","quibble","quick","quicken","quickie","quicklime","quicksand","quicksilver","quickstep","quid","quiescent","quiet","quietus","quill","quillwort"
DATA "quilt","quince","quinine","quinn","quint","quintessence","quintessential","quintet","quintic","quintillion","quintus","quip","quipping","quirinal","quirk","quirky","quirt","quit","quite","quito"
DATA "quitting","quiver","quixote","quixotic","quiz","quizzes","quizzical","quo","quod","quonset","quorum","quota","quotation","quote","quotient","r","r&d","r's","rabat","rabbet"
DATA "rabbi","rabbit","rabble","rabid","rabies","rabin","raccoon","race","racetrack","raceway","rachel","rachmaninoff","racial","rack","racket","racketeer","rackety","racy","radar","radcliffe"
DATA "radial","radian","radiant","radiate","radical","radices","radii","radio","radioactive","radioastronomy","radiocarbon","radiochemical","radiochemistry","radiogram","radiography","radiology","radiometer","radiophysics","radiosonde","radiotelegraph"
DATA "radiotelephone","radiotherapy","radish","radium","radius","radix","radon","rae","rafael","rafferty","raffia","raffish","raffle","raft","rag","rage","ragging","ragout","ragweed","raid"
DATA "rail","railbird","railhead","raillery","railroad","railway","rain","rainbow","raincoat","raindrop","rainfall","rainstorm","rainy","raise","raisin","raj","rajah","rake","rakish","raleigh"
DATA "rally","ralph","ralston","ram","ramada","raman","ramble","ramify","ramo","ramp","rampage","rampant","rampart","ramrod","ramsey","ran","ranch","rancho","rancid","rancorous"
DATA "rand","randall","randolph","random","randy","rang","range","rangeland","rangoon","rangy","ranier","rank","rankin","rankine","rankle","ransack","ransom","rant","raoul","rap"
DATA "rapacious","rape","raphael","rapid","rapier","rapport","rapprochement","rapt","rapture","rare","rarefy","raritan","rasa","rascal","rash","rasmussen","rasp","raspberry","raster","rastus"
DATA "rat","rata","rate","ratepayer","rater","rather","ratify","ratio","ratiocinate","rationale","rattail","rattle","rattlesnake","ratty","raucous","raul","ravage","rave","ravel","raven"
DATA "ravenous","ravine","ravish","raw","rawboned","rawhide","rawlinson","ray","rayleigh","raymond","raytheon","raze","razor","razorback","razzle","rca","rd","re","reach","reactant"
DATA "reactionary","read","readout","ready","reagan","real","realisable","realm","realtor","realty","ream","reap","rear","reason","reave","reb","rebecca","rebel","rebelled","rebelling"
DATA "rebellion","rebellious","rebuke","rebut","rebuttal","rebutted","rebutting","recalcitrant","recappable","receipt","receive","recent","receptacle","reception","receptive","receptor","recess","recession","recessive","recherche"
DATA "recife","recipe","recipient","reciprocal","reciprocate","reciprocity","recital","recitative","reck","reckon","reclamation","recline","recluse","recombinant","recompense","reconcile","recondite","reconnaissance","recovery","recriminate"
DATA "recriminatory","recruit","rectangle","rectangular","rectifier","rectify","rectilinear","rectitude","rector","rectory","recumbent","recuperate","recur","recurred","recurrent","recurring","recursion","recusant","recuse","red"
DATA "redact","redactor","redbird","redbud","redcoat","redden","reddish","redemption","redemptive","redhead","redmond","redneck","redound","redpoll","redshank","redstart","redstone","redtop","reduce","reducible"
DATA "redundant","redwood","reed","reedbuck","reedy","reef","reek","reel","reese","reeve","reeves","refection","refectory","refer","referable","referee","refereeing","referenda","referendum","referent"
DATA "referential","referral","referred","referring","refinery","reflect","reflectance","reflector","reflexive","reformatory","refract","refractometer","refractory","refrain","refrigerate","refuge","refugee","refusal","refutation","refute"
DATA "regal","regale","regalia","regard","regatta","regent","regime","regimen","regiment","regimentation","regina","reginald","region","regional","regis","registrable","registrant","registrar","registration","registry"
DATA "regress","regression","regressive","regret","regretful","regrettable","regretted","regretting","regular","regulate","regulatory","regulus","regurgitate","rehabilitate","rehearsal","rehearse","reich","reid","reign","reilly"
DATA "reimbursable","reimburse","rein","reindeer","reinforce","reinhold","reinstate","reject","rejecter","rejoice","rejoinder","rejuvenate","relate","relaxation","relayed","releasable","relevant","reliant","relic","relict"
DATA "relief","relieve","religion","religiosity","religious","relinquish","reliquary","relish","reluctant","remainder","reman","remand","remark","rembrandt","remediable","remedial","remedy","remember","remembrance","remington"
DATA "reminisce","reminiscent","remiss","remission","remit","remittance","remitted","remitting","remnant","remonstrate","remorse","remorseful","remote","removal","remunerate","remus","rena","renaissance","renal","renault"
DATA "rend","render","rendezvous","rendition","rene","renegotiable","renewal","renoir","renounce","renovate","renown","rensselaer","rent","rental","renunciate","rep","repairman","repairmen","reparation","repartee"
DATA "repeal","repeat","repeater","repel","repelled","repellent","repelling","repent","repentant","repertoire","repertory","repetition","repetitious","repetitive","replaceable","replenish","replete","replica","replicate","report"
DATA "reportorial","repository","reprehensible","representative","repression","repressive","reprieve","reprimand","reprisal","reprise","reproach","reptile","reptilian","republic","republican","repudiate","repugnant","repulsion","repulsive","reputation"
DATA "repute","request","require","requisite","requisition","requited","reredos","rerouted","rerouting","rescind","rescue","resemblant","resemble","resent","resentful","reserpine","reservation","reserve","reservoir","reside"
DATA "resident","residential","residual","residuary","residue","residuum","resign","resignation","resilient","resin","resiny","resist","resistant","resistible","resistive","resistor","resolute","resolution","resolve","resonant"
DATA "resonate","resorcinol","resort","resourceful","respect","respecter","respectful","respiration","respirator","respiratory","respire","respite","resplendent","respond","respondent","response","responsible","responsive","rest","restaurant"
DATA "restaurateur","restful","restitution","restive","restoration","restorative","restrain","restraint","restrict","restroom","result","resultant","resume","resuming","resumption","resurgent","resurrect","resuscitate","ret","retail"
DATA "retain","retaliate","retaliatory","retard","retardant","retardation","retch","retention","retentive","reticent","reticulate","reticulum","retina","retinal","retinue","retire","retiree","retort","retract","retribution"
DATA "retrieval","retrieve","retroactive","retrofit","retrofitted","retrofitting","retrograde","retrogress","retrogression","retrogressive","retrorocket","retrospect","retrovision","return","reub","reuben","reuters","rev","reveal","revel"
DATA "revelation","revelatory","revelry","revenge","revenue","rever","reverberate","revere","reverend","reverent","reverie","reversal","reverse","reversible","reversion","revert","revertive","revery","revet","revile"
DATA "revisable","revisal","revise","revision","revisionary","revival","revive","revocable","revoke","revolt","revolution","revolutionary","revolve","revulsion","revved","revving","reward","rex","reykjavik","reynolds"
DATA "rhapsodic","rhapsody","rhea","rhenish","rhenium","rheology","rheostat","rhesus","rhetoric","rhetorician","rheum","rheumatic","rheumatism","rhine","rhinestone","rhino","rhinoceros","rho","rhoda","rhode"
DATA "rhodes","rhodesia","rhodium","rhododendron","rhodolite","rhodonite","rhombi","rhombic","rhombohedral","rhombus","rhubarb","rhyme","rhythm","rhythmic","ri","rib","ribald","ribbon","riboflavin","ribonucleic"
DATA "ribose","ribosome","rica","rice","rich","richard","richards","richardson","richfield","richmond","richter","rick","rickets","rickettsia","rickety","rickshaw","rico","ricochet","rid","riddance"
DATA "ridden","riddle","ride","ridge","ridgepole","ridgway","ridicule","ridiculous","riemann","riemannian","riffle","rifle","rifleman","riflemen","rift","rig","riga","rigel","rigging","riggs"
DATA "right","righteous","rightful","rightmost","rightward","rigid","rigorous","riley","rill","rilly","rim","rime","rimy","rinehart","ring","ringlet","ringmaster","ringside","rink","rinse"
DATA "rio","riordan","riot","riotous","rip","riparian","ripe","ripen","ripley","ripoff","ripple","rise","risen","risible","risk","risky","ritchie","rite","ritter","ritual"
DATA "ritz","rival","rivalry","riven","river","riverbank","riverfront","riverine","riverside","rivet","riviera","rivulet","riyadh","rna","roach","road","roadbed","roadblock","roadhouse","roadside"
DATA "roadster","roadway","roam","roar","roast","rob","robbery","robbin","robbins","robe","robert","roberta","roberto","roberts","robertson","robin","robinson","robot","robotic","robotics"
DATA "robust","rocco","rochester","rock","rockabye","rockaway","rockbound","rockefeller","rocket","rockford","rockies","rockland","rockwell","rocky","rococo","rod","rode","rodent","rodeo","rodgers"
DATA "rodney","rodriguez","roe","roebuck","roentgen","roger","rogers","rogue","roil","roister","roland","role","roll","rollback","rollick","rollins","roman","romance","romania","romano"
DATA "romantic","rome","romeo","romp","romulus","ron","ronald","rondo","ronnie","rood","roof","rooftop","rooftree","rook","rookie","rooky","room","roomful","roommate","roomy"
DATA "roosevelt","rooseveltian","roost","root","rope","rosa","rosalie","rosary","rose","rosebud","rosebush","roseland","rosemary","rosen","rosenberg","rosenblum","rosenthal","rosenzweig","rosetta","rosette"
DATA "ross","roster","rostrum","rosy","rot","rotarian","rotary","rotate","rotc","rote","rotenone","roth","rothschild","rotogravure","rotor","rototill","rotten","rotund","rotunda","rouge"
DATA "rough","roughcast","roughen","roughish","roughneck","roughshod","roulette","round","roundabout","roundhead","roundhouse","roundoff","roundtable","roundup","roundworm","rouse","rousseau","roustabout","rout","route"
DATA "routine","rove","row","rowboat","rowdy","rowe","rowena","rowland","rowley","roxbury","roy","royal","royalty","royce","rpm","rsvp","ruanda","rub","rubbery","rubbish"
DATA "rubble","rubdown","rube","ruben","rubicund","rubidium","rubin","rubric","ruby","ruckus","rudder","ruddy","rude","rudiment","rudimentary","rudolf","rudolph","rudy","rudyard","rue"
DATA "rueful","ruff","ruffian","ruffle","rufous","rufus","rug","ruin","ruination","ruinous","rule","rum","rumania","rumble","rumen","rumford","ruminant","ruminate","rummage","rummy"
DATA "rump","rumple","rumpus","run","runabout","runaway","rundown","rune","rung","runge","runic","runneth","runnymede","runoff","runt","runty","runway","runyon","rupee","rupture"
DATA "rural","ruse","rush","rushmore","rusk","russ","russell","russet","russia","russo","russula","rust","rustic","rustle","rustproof","rusty","rut","rutabaga","rutgers","ruth"
DATA "ruthenium","rutherford","ruthless","rutile","rutland","rutledge","rutty","rwanda","ryan","rydberg","ryder","rye","s","s's","sa","sabbath","sabbatical","sabina","sabine","sable"
DATA "sabotage","sabra","sac","saccade","saccharine","sachem","sachs","sack","sacral","sacrament","sacramento","sacred","sacrifice","sacrificial","sacrilege","sacrilegious","sacrosanct","sad","sadden","saddle"
DATA "saddlebag","sadie","sadism","sadist","sadler","safari","safe","safeguard","safekeeping","safety","saffron","sag","saga","sagacious","sagacity","sage","sagebrush","sagging","saginaw","sagittal"
DATA "sagittarius","sago","saguaro","sahara","said","saigon","sail","sailboat","sailfish","sailor","saint","sainthood","sake","sal","salaam","salacious","salad","salamander","salami","salaried"
DATA "salary","sale","salem","salerno","salesgirl","salesian","saleslady","salesman","salesmen","salesperson","salient","salina","saline","salisbury","salish","saliva","salivary","salivate","salk","salle"
DATA "sallow","sally","salmon","salmonberry","salmonella","salon","saloon","saloonkeep","saloonkeeper","salsify","salt","saltbush","saltwater","salty","salubrious","salutary","salutation","salute","salvador","salvage"
DATA "salvageable","salvation","salvatore","salve","salvo","sam","samarium","samba","same","sammy","samoa","samovar","sample","sampson","samson","samuel","samuelson","san","sana","sanatoria"
DATA "sanatorium","sanborn","sanchez","sancho","sanctify","sanctimonious","sanction","sanctity","sanctuary","sand","sandal","sandalwood","sandbag","sandblast","sandburg","sanderling","sanders","sanderson","sandhill","sandia"
DATA "sandman","sandpaper","sandpile","sandpiper","sandra","sandstone","sandusky","sandwich","sandy","sane","sanford","sang","sangaree","sanguinary","sanguine","sanguineous","sanhedrin","sanicle","sanitarium","sanitary"
DATA "sanitate","sank","sans","sanskrit","santa","santayana","santiago","santo","sao","sap","sapiens","sapient","sapling","saponify","sapphire","sappy","sapsucker","sara","saracen","sarah"
DATA "saran","sarasota","saratoga","sarcasm","sarcastic","sarcoma","sarcophagus","sardine","sardonic","sargent","sari","sarsaparilla","sarsparilla","sash","sashay","saskatchewan","saskatoon","sassafras","sat","satan"
DATA "satanic","satellite","satiable","satiate","satiety","satin","satire","satiric","satisfaction","satisfactory","satisfy","saturable","saturate","saturater","saturday","saturn","saturnalia","saturnine","satyr","sauce"
DATA "saucepan","saucy","saud","saudi","sauerkraut","saul","sault","saunders","sausage","saute","sauterne","savage","savagery","savannah","savant","save","saviour","savonarola","savoy","savoyard"
DATA "savvy","saw","sawbelly","sawdust","sawfish","sawfly","sawmill","sawtimber","sawtooth","sawyer","sax","saxifrage","saxon","saxony","saxophone","say","sc","scab","scabbard","scabious"
DATA "scabrous","scaffold","scala","scalar","scald","scale","scallop","scalp","scam","scamp","scan","scandal","scandalous","scandinavia","scandium","scant","scanty","scapegoat","scapula","scapular"
DATA "scar","scarborough","scarce","scare","scarecrow","scarf","scarface","scarify","scarlatti","scarlet","scarsdale","scarves","scary","scat","scathe","scatterbrain","scattergun","scaup","scavenge","scenario"
DATA "scene","scenery","scenic","scent","sceptic","schaefer","schafer","schantz","schedule","schelling","schema","schemata","schematic","scheme","schenectady","scherzo","schiller","schism","schist","schizoid"
DATA "schizomycetes","schizophrenia","schizophrenic","schlesinger","schlieren","schlitz","schloss","schmidt","schmitt","schnabel","schnapps","schneider","schoenberg","schofield","scholar","scholastic","school","schoolbook","schoolboy","schoolgirl"
DATA "schoolgirlish","schoolhouse","schoolmarm","schoolmaster","schoolmate","schoolroom","schoolteacher","schoolwork","schooner","schottky","schroeder","schroedinger","schubert","schultz","schulz","schumacher","schumann","schuster","schuyler","schuylkill"
DATA "schwab","schwartz","schweitzer","sci","sciatica","science","scientific","scientist","scimitar","scintillate","scion","scissor","sclerosis","sclerotic","scm","scoff","scold","scoop","scoot","scope"
DATA "scopic","scops","scorch","score","scoreboard","scorecard","scoria","scorn","scornful","scorpio","scorpion","scot","scotch","scotia","scotland","scotsman","scotsmen","scott","scottish","scottsdale"
DATA "scotty","scoundrel","scour","scourge","scout","scowl","scrabble","scraggly","scram","scramble","scranton","scrap","scrapbook","scrape","scratch","scratchy","scrawl","scrawny","scream","screech"
DATA "screechy","screed","screen","screenplay","screw","screwball","screwbean","screwdriver","screwworm","scribble","scribe","scribners","scrim","scrimmage","scripps","script","scription","scriptural","scripture","scriven"
DATA "scroll","scrooge","scrotum","scrounge","scrub","scrumptious","scruple","scrupulosity","scrupulous","scrutable","scrutiny","scuba","scud","scuff","scuffle","scull","sculpin","sculpt","sculptor","sculptural"
DATA "sculpture","scum","scurrilous","scurry","scurvy","scuttle","scutum","scylla","scythe","scythia","sd","se","sea","seaboard","seacoast","seafare","seafood","seagram","seagull","seahorse"
DATA "seal","sealant","seam","seaman","seamen","seamstress","seamy","sean","seance","seaport","seaquake","sear","search","searchlight","sears","seashore","seaside","season","seasonal","seat"
DATA "seater","seattle","seaward","seaweed","sebastian","sec","secant","secede","secession","seclude","seclusion","second","secondary","secondhand","secrecy","secret","secretarial","secretariat","secretary","secrete"
DATA "secretion","secretive","sect","sectarian","section","sector","sectoral","secular","secure","sedan","sedate","sedentary","seder","sedge","sediment","sedimentary","sedimentation","sedition","seditious","seduce"
DATA "seduction","seductive","sedulous","see","seeable","seed","seedbed","seedling","seedy","seeing","seek","seem","seen","seep","seepage","seersucker","seethe","seethed","seething","segment"
DATA "segmentation","segovia","segregant","segregate","segundo","seidel","seismic","seismograph","seismography","seismology","seize","seizure","seldom","select","selectman","selectmen","selector","selectric","selena","selenate"
DATA "selenite","selenium","self","selfadjoint","selfish","selfridge","selkirk","sell","seller","sellout","selma","seltzer","selves","selwyn","semantic","semaphore","semblance","semester","semi","seminal"
DATA "seminar","seminarian","seminary","seminole","semiramis","semite","semitic","semper","sen","senate","senatorial","send","seneca","senegal","senile","senior","senor","senora","senorita","sensate"
DATA "sense","sensible","sensitive","sensor","sensorimotor","sensory","sensual","sensuous","sent","sentence","sentential","sentient","sentiment","sentinel","sentry","seoul","sepal","separable","separate","sepia"
DATA "sepoy","sept","septa","septate","september","septennial","septic","septillion","septuagenarian","septum","sepuchral","sepulchral","seq","sequel","sequent","sequential","sequester","sequestration","sequin","sequitur"
DATA "sequoia","sera","seraglio","serape","seraphim","serbia","serenade","serendipitous","serendipity","serene","serf","serfdom","serge","sergeant","sergei","serial","seriate","seriatim","series","serif"
DATA "serine","serious","sermon","serology","serpens","serpent","serpentine","serum","servant","serve","service","serviceable","serviceberry","serviceman","servicemen","serviette","servile","servitor","servitude","servo"
DATA "servomechanism","sesame","session","set","setback","seth","seton","setscrew","settle","setup","seven","sevenfold","seventeen","seventeenth","seventh","seventieth","seventy","sever","several","severalfold"
DATA "severalty","severe","severn","seville","sew","sewage","seward","sewerage","sewn","sex","sextans","sextet","sextillion","sexton","sextuple","sextuplet","sexual","sexy","seymour","sforzando"
DATA "shabby","shack","shackle","shad","shadbush","shade","shadflower","shadow","shadowy","shady","shafer","shaffer","shaft","shag","shagbark","shagging","shaggy","shah","shake","shakeable"
DATA "shakedown","shaken","shakespeare","shakespearean","shakespearian","shako","shaky","shale","shall","shallot","shallow","shalom","sham","shamble","shame","shameface","shamefaced","shameful","shampoo","shamrock"
DATA "shan't","shanghai","shank","shannon","shantung","shanty","shape","shapiro","shard","share","sharecrop","shareholder","shareown","shari","shark","sharon","sharp","sharpe","sharpen","sharpshoot"
DATA "shasta","shatter","shatterproof","shattuck","shave","shaven","shaw","shawl","shawnee","shay","she","she'd","she'll","shea","sheaf","shear","shearer","sheath","sheathe","sheave"
DATA "shed","shedir","sheehan","sheen","sheep","sheepskin","sheer","sheet","sheffield","sheik","sheila","shelby","sheldon","shelf","shell","shelley","shelter","shelton","shelve","shenandoah"
DATA "shenanigan","shepard","shepherd","sheppard","sheraton","sherbet","sheridan","sheriff","sherlock","sherman","sherrill","sherry","sherwin","sherwood","shibboleth","shied","shield","shields","shift","shifty"
DATA "shill","shiloh","shim","shimmy","shin","shinbone","shine","shingle","shinto","shiny","ship","shipboard","shipbuild","shipbuilding","shiplap","shipley","shipman","shipmate","shipmen","shipshape"
DATA "shipwreck","shipyard","shire","shirk","shirley","shirt","shirtmake","shish","shitepoke","shiv","shiver","shivery","shmuel","shoal","shock","shockley","shod","shoddy","shoe","shoehorn"
DATA "shoelace","shoemake","shoestring","shoji","shone","shoo","shoofly","shook","shoot","shop","shopkeep","shopworn","shore","shoreline","short","shortage","shortcoming","shortcut","shorten","shortfall"
DATA "shorthand","shortish","shortsighted","shortstop","shot","shotbush","shotgun","should","shoulder","shouldn't","shout","shove","shovel","show","showboat","showcase","showdown","showman","showmen","shown"
DATA "showpiece","showplace","showroom","showy","shrank","shrapnel","shred","shreveport","shrew","shrewd","shrewish","shriek","shrift","shrike","shrill","shrilly","shrimp","shrine","shrink","shrinkage"
DATA "shrive","shrivel","shroud","shrove","shrub","shrubbery","shrug","shrugging","shrunk","shrunken","shu","shuck","shudder","shuddery","shuffle","shuffleboard","shulman","shun","shunt","shut"
DATA "shutdown","shutoff","shutout","shuttle","shuttlecock","shy","shylock","sial","siam","siamese","sian","sib","siberia","sibilant","sibley","sibling","sibyl","sic","sicilian","sicily"
DATA "sick","sicken","sickish","sickle","sicklewort","sickroom","side","sidearm","sideband","sideboard","sidecar","sidelight","sideline","sidelong","sideman","sidemen","sidereal","siderite","sidesaddle","sideshow"
DATA "sidestep","sidestepping","sidetrack","sidewalk","sidewall","sideway","sidewinder","sidewise","sidle","sidney","siege","siegel","siegfried","sieglinda","siegmund","siemens","siena","sienna","sierra","siesta"
DATA "sieve","sift","sigh","sight","sightsee","sightseeing","sightseer","sigma","sigmund","sign","signal","signature","signboard","signet","significant","signify","signor","signora","signpost","sikorsky"
DATA "silage","silane","silas","silent","silhouette","silica","silicate","siliceous","silicic","silicide","silicon","silicone","silk","silken","silkworm","silky","sill","silly","silo","silt"
DATA "siltation","siltstone","silty","silver","silverman","silversmith","silverware","silvery","sima","similar","simile","similitude","simmer","simmons","simon","simons","simonson","simper","simple","simplectic"
DATA "simpleminded","simpleton","simplex","simplicial","simplicity","simplify","simplistic","simply","simpson","sims","simulate","simulcast","simultaneity","simultaneous","sin","sinai","since","sincere","sinclair","sine"
DATA "sinew","sinewy","sinful","sing","singable","singapore","singe","single","singlehanded","singlet","singleton","singsong","singular","sinh","sinister","sinistral","sink","sinkhole","sinter","sinuous"
DATA "sinus","sinusoid","sinusoidal","sioux","sip","sir","sire","siren","sirius","sis","sisal","siskin","sister","sistine","sisyphean","sisyphus","sit","site","situ","situate"
DATA "situs","siva","six","sixfold","sixgun","sixteen","sixteenth","sixth","sixtieth","sixty","size","sizzle","skat","skate","skater","skeet","skeletal","skeleton","skeptic","sketch"
DATA "sketchbook","sketchpad","sketchy","skew","ski","skid","skiddy","skied","skiff","skill","skillet","skillful","skim","skimp","skimpy","skin","skindive","skinny","skip","skipjack"
DATA "skippy","skirmish","skirt","skit","skittle","skopje","skulk","skull","skullcap","skullduggery","skunk","sky","skye","skyhook","skyjack","skylark","skylight","skyline","skyrocket","skyscrape"
DATA "skyward","skywave","skyway","slab","slack","slacken","sladang","slag","slain","slake","slam","slander","slanderous","slang","slant","slap","slapstick","slash","slat","slate"
DATA "slater","slaughter","slaughterhouse","slav","slave","slavery","slavic","slavish","slavonic","slay","sled","sledge","sledgehammer","sleek","sleep","sleepwalk","sleepy","sleet","sleety","sleeve"
DATA "sleigh","sleight","slender","slept","sleuth","slew","slice","slick","slid","slide","slight","slim","slime","slimy","sling","slingshot","slip","slippage","slippery","slit"
DATA "slither","sliver","slivery","sloan","sloane","slob","slocum","sloe","slog","slogan","sloganeer","slogging","sloop","slop","slope","sloppy","slosh","slot","sloth","slothful"
DATA "slouch","slough","slovakia","sloven","slovenia","slow","slowdown","sludge","slug","slugging","sluggish","sluice","slum","slumber","slump","slung","slur","slurp","slurry","slut"
DATA "sly","smack","small","smaller","smalley","smallish","smallpox","smalltime","smart","smash","smatter","smattering","smear","smell","smelt","smile","smirk","smith","smithereens","smithfield"
DATA "smithson","smithsonian","smithy","smitten","smog","smoke","smokehouse","smokescreen","smokestack","smoky","smolder","smooch","smooth","smoothbore","smother","smucker","smudge","smudgy","smug","smuggle"
DATA "smut","smutty","smyrna","smythe","snack","snafu","snag","snagging","snail","snake","snakebird","snakelike","snakeroot","snap","snapback","snapdragon","snappish","snappy","snapshot","snare"
DATA "snark","snarl","snatch","snazzy","sneak","sneaky","sneer","sneeze","snell","snick","snider","sniff","sniffle","sniffly","snifter","snigger","snip","snipe","snippet","snippy"
DATA "snivel","snob","snobbery","snobbish","snook","snoop","snoopy","snore","snorkel","snort","snotty","snout","snow","snowball","snowfall","snowflake","snowmobile","snowshoe","snowstorm","snowy"
DATA "snub","snuff","snuffer","snuffle","snuffly","snug","snuggle","snuggly","snyaptic","snyder","so","soak","soap","soapstone","soapsud","soapy","soar","sob","sober","sobriety"
DATA "sobriquet","soc","soccer","sociable","social","societal","societe","society","socioeconomic","sociology","sociometry","sock","socket","sockeye","socrates","socratic","sod","soda","sodden","sodium"
DATA "sofa","soffit","sofia","soft","softball","soften","software","softwood","soggy","soignee","soil","soiree","sojourn","sol","solace","solar","sold","solder","soldier","soldiery"
DATA "sole","solecism","solemn","solemnity","solenoid","solicit","solicitation","solicitor","solicitous","solicitude","solid","solidarity","solidify","solidus","soliloquy","solipsism","solitaire","solitary","soliton","solitude"
DATA "solo","solomon","solon","solstice","soluble","solute","solution","solvate","solve","solvent","soma","somal","somali","somatic","somber","sombre","some","somebody","somebody'll","someday"
DATA "somehow","someone","someone'll","someplace","somers","somersault","somerset","somerville","something","sometime","somewhat","somewhere","sommelier","sommerfeld","somnolent","son","sonant","sonar","sonata","song"
DATA "songbag","songbook","songful","sonic","sonnet","sonny","sonogram","sonoma","sonora","sonority","sonorous","sony","soon","soot","sooth","soothe","soothsay","soothsayer","sop","sophia"
DATA "sophie","sophism","sophisticate","sophistry","sophoclean","sophocles","sophomore","sophomoric","soprano","sora","sorb","sorcery","sordid","sore","sorensen","sorenson","sorghum","sorority","sorption","sorrel"
DATA "sorrow","sorrowful","sorry","sort","sortie","sou","souffle","sough","sought","soul","soulful","sound","soundproof","soup","sour","sourberry","source","sourdough","sourwood","sousa"
DATA "soutane","south","southampton","southbound","southeast","southeastern","southern","southernmost","southey","southland","southpaw","southward","southwest","southwestern","souvenir","sovereign","sovereignty","soviet","sovkhoz","sow"
DATA "sowbelly","sown","soy","soya","soybean","spa","space","spacecraft","spacesuit","spacetime","spacious","spade","spaghetti","spain","spalding","span","spandrel","spangle","spaniard","spaniel"
DATA "spanish","spar","spare","sparge","spark","sparkle","sparkman","sparky","sparling","sparrow","sparse","sparta","spartan","spasm","spastic","spat","spate","spatial","spatlum","spatterdock"
DATA "spatula","spaulding","spavin","spawn","spay","spayed","speak","speakeasy","spear","spearhead","spearmint","spec","special","specie","species","specific","specify","specimen","specious","speck"
DATA "speckle","spectacle","spectacular","spectator","spector","spectra","spectral","spectrogram","spectrograph","spectrography","spectrometer","spectrophotometer","spectroscope","spectroscopic","spectroscopy","spectrum","specular","speculate","sped","speech"
DATA "speed","speedboat","speedometer","speedup","speedwell","speedy","spell","spellbound","spencer","spencerian","spend","spent","sperm","spermatophyte","sperry","spew","sphagnum","sphalerite","sphere","spheric"
DATA "spheroid","spheroidal","spherule","sphinx","spica","spice","spicebush","spicy","spider","spiderwort","spidery","spiegel","spigot","spike","spikenard","spiky","spill","spilt","spin","spinach"
DATA "spinal","spindle","spine","spinnaker","spinneret","spinodal","spinoff","spinster","spiny","spiral","spire","spirit","spiritual","spiro","spit","spite","spiteful","spitfire","spittle","spitz"
DATA "splash","splashy","splat","splay","splayed","spleen","spleenwort","splendid","splenetic","splice","spline","splint","splintery","split","splotch","splotchy","splurge","splutter","spoil","spoilage"
DATA "spokane","spoke","spoken","spokesman","spokesmen","spokesperson","sponge","spongy","sponsor","spontaneity","spontaneous","spoof","spook","spooky","spool","spoon","spoonful","sporadic","spore","sport"
DATA "sportsman","sportsmen","sportswear","sportswrite","sportswriter","sportswriting","sporty","spot","spotlight","spotty","spouse","spout","sprague","sprain","sprang","sprawl","spray","spread","spree","sprig"
DATA "sprightly","spring","springboard","springe","springfield","springtail","springtime","springy","sprinkle","sprint","sprite","sprocket","sproul","sprout","spruce","sprue","sprung","spud","spume","spumoni"
DATA "spun","spunk","spur","spurge","spurious","spurn","spurt","sputnik","sputter","spy","spyglass","squabble","squad","squadron","squalid","squall","squamous","squander","square","squash"
DATA "squashberry","squashy","squat","squatted","squatter","squatting","squaw","squawbush","squawk","squawroot","squeak","squeaky","squeal","squeamish","squeegee","squeeze","squelch","squibb","squid","squill"
DATA "squint","squire","squirehood","squirm","squirmy","squirrel","squirt","squishy","sri","sse","sst","ssw","st","stab","stabile","stable","stableman","stablemen","staccato","stack"
DATA "stacy","stadia","stadium","staff","stafford","stag","stage","stagecoach","stagestruck","stagnant","stagnate","stagy","stahl","staid","stain","stair","staircase","stairway","stairwell","stake"
DATA "stalactite","stale","stalemate","staley","stalin","stalk","stall","stallion","stalwart","stamen","stamford","stamina","staminate","stammer","stamp","stampede","stan","stance","stanch","stanchion"
DATA "stand","standard","standby","standeth","standish","standoff","standpoint","standstill","stanford","stanhope","stank","stanley","stannic","stannous","stanton","stanza","staph","staphylococcus","staple","stapleton"
DATA "star","starboard","starch","starchy","stardom","stare","starfish","stargaze","stark","starkey","starlet","starlight","starling","starr","start","startle","startup","starvation","starve","stash"
DATA "stasis","state","staten","stater","stateroom","statesman","statesmanlike","statesmen","statewide","static","stationarity","stationary","stationery","stationmaster","statistician","statler","stator","statuary","statue","statuette"
DATA "stature","status","statute","statutory","stauffer","staunch","staunton","stave","stay","stayed","stead","steadfast","steady","steak","steal","stealth","stealthy","steam","steamboat","steamy"
DATA "stearate","stearic","stearns","steed","steel","steele","steelmake","steely","steen","steep","steepen","steeple","steeplebush","steeplechase","steer","steeve","stefan","stegosaurus","stein","steinberg"
DATA "steiner","stella","stellar","stem","stench","stencil","stenographer","stenography","stenotype","step","stepchild","stephanie","stephanotis","stephen","stephens","stephenson","stepmother","steppe","steprelation","stepson"
DATA "stepwise","steradian","stereo","stereography","stereoscopy","sterile","sterling","stern","sternal","sternberg","sterno","sternum","steroid","stethoscope","stetson","steuben","steve","stevedore","steven","stevens"
DATA "stevenson","stew","steward","stewardess","stewart","stick","stickle","stickleback","stickpin","sticktight","sticky","stiff","stiffen","stifle","stigma","stigmata","stile","stiletto","still","stillbirth"
DATA "stillwater","stilt","stimulant","stimulate","stimulatory","stimuli","stimulus","sting","stingy","stink","stinkpot","stinky","stint","stipend","stipple","stipulate","stir","stirling","stirrup","stitch"
DATA "stochastic","stock","stockade","stockbroker","stockholder","stockholm","stockpile","stockroom","stockton","stocky","stodgy","stoic","stoichiometry","stoke","stokes","stole","stolen","stolid","stomach","stomp"
DATA "stone","stonecrop","stonehenge","stonewall","stoneware","stonewort","stony","stood","stooge","stool","stoop","stop","stopband","stopcock","stopgap","stopover","stoppage","stopwatch","storage","store"
DATA "storehouse","storekeep","storeroom","storey","stork","storm","stormbound","stormy","story","storyboard","storyteller","stout","stove","stow","stowage","stowaway","strabismic","strabismus","straddle","strafe"
DATA "straggle","straight","straightaway","straighten","straightforward","straightway","strain","strait","strand","strange","strangle","strangulate","strap","strata","stratagem","strategic","strategist","strategy","stratford","stratify"
DATA "stratosphere","stratospheric","stratton","stratum","strauss","straw","strawberry","strawflower","stray","streak","stream","streamline","streamside","street","streetcar","strength","strengthen","strenuous","streptococcus","streptomycin"
DATA "stress","stressful","stretch","strewn","striate","stricken","strickland","strict","stricter","stricture","stride","strident","strife","strike","strikebreak","string","stringent","stringy","strip","stripe"
DATA "striptease","stripy","strive","striven","strobe","stroboscopic","strode","stroke","stroll","strom","stromberg","strong","stronghold","strongroom","strontium","strop","strophe","strove","struck","structural"
DATA "structure","struggle","strum","strung","strut","strychnine","stu","stuart","stub","stubble","stubborn","stubby","stucco","stuck","stud","studebaker","student","studio","studious","study"
DATA "stuff","stuffy","stultify","stumble","stump","stumpage","stumpy","stun","stung","stunk","stunt","stupefaction","stupefy","stupendous","stupid","stupor","sturbridge","sturdy","sturgeon","sturm"
DATA "stutter","stuttgart","stuyvesant","stygian","style","styli","stylish","stylites","stylus","stymie","styrene","styrofoam","styx","suave","sub","subject","subjectivity","subjunctive","sublimate","subliminal"
DATA "submersible","submit","submittal","submitted","submitting","subpoena","subrogation","subservient","subsidiary","subsidy","subsist","subsistent","substantial","substantiate","substantive","substituent","substitute","substitution","substitutionary","substrate"
DATA "subsume","subsumed","subsuming","subterfuge","subterranean","subtle","subtlety","subtly","subtracter","subtrahend","suburb","suburbia","subversive","subvert","succeed","success","successful","succession","successive","successor"
DATA "succinct","succubus","succumb","such","suck","suckling","sucrose","suction","sud","sudan","sudanese","sudden","suds","sue","suey","suez","suffer","suffice","sufficient","suffix"
DATA "suffocate","suffolk","suffrage","suffragette","suffuse","sugar","suggest","suggestible","suggestion","suggestive","suicidal","suicide","suit","suitcase","suite","suitor","sulfa","sulfanilamide","sulfate","sulfide"
DATA "sulfite","sulfonamide","sulfur","sulfuric","sulfurous","sulk","sulky","sullen","sullivan","sully","sulphur","sultan","sultanate","sultry","sum","sumac","sumatra","sumeria","sumerian","summand"
DATA "summarily","summary","summate","summation","summers","summertime","summit","summitry","summon","sumner","sumptuous","sumter","sun","sunbeam","sunbonnet","sunburn","sunburnt","sunday","sunder","sundew"
DATA "sundial","sundown","sundry","sunfish","sunflower","sung","sunglasses","sunk","sunken","sunlight","sunlit","sunny","sunnyvale","sunrise","sunscreen","sunset","sunshade","sunshine","sunshiny","sunspot"
DATA "suntan","suntanned","suntanning","suny","sup","super","superannuate","superb","superbly","supercilious","superficial","superfluity","superfluous","superintendent","superior","superlative","superlunary","supernatant","supernovae","superposable"
DATA "supersede","superstition","superstitious","supervene","supervisory","supine","supplant","supple","supplementary","supplicate","supply","support","supposable","suppose","supposition","suppress","suppressible","suppression","suppressor","supra"
DATA "supranational","supremacy","supreme","supremum","surcease","surcharge","sure","surety","surf","surface","surfactant","surfeit","surge","surgeon","surgery","surgical","surjection","surjective","surmise","surmount"
DATA "surname","surpass","surplus","surprise","surreal","surrender","surreptitious","surrey","surrogate","surround","surtax","surtout","surveillant","survey","surveyor","survival","survive","survivor","sus","susan"
DATA "susanne","susceptance","susceptible","sushi","susie","suspect","suspend","suspense","suspension","suspensor","suspicion","suspicious","sussex","sustain","sustenance","sutherland","sutton","suture","suzanne","suzerain"
DATA "suzerainty","suzuki","svelte","sw","swab","swabby","swag","swage","swahili","swain","swallow","swallowtail","swam","swami","swamp","swampy","swan","swank","swanky","swanlike"
DATA "swanson","swap","swarm","swart","swarthmore","swarthout","swarthy","swastika","swat","swatch","swath","swathe","sway","swaziland","swear","sweat","sweatband","sweater","sweatshirt","sweaty"
DATA "swede","sweden","swedish","sweeney","sweep","sweepstake","sweet","sweeten","sweetheart","sweetish","swell","swelt","swelter","swenson","swept","swerve","swift","swig","swigging","swim"
DATA "swimsuit","swindle","swine","swing","swingable","swingy","swipe","swirl","swirly","swish","swishy","swiss","switch","switchblade","switchboard","switchgear","switchman","switzer","switzerland","swivel"
DATA "swizzle","swollen","swoop","sword","swordfish","swordplay","swordtail","swore","sworn","swum","swung","sybarite","sybil","sycamore","sycophant","sycophantic","sydney","syenite","sykes","syllabi"
DATA "syllabic","syllabify","syllable","syllabus","syllogism","syllogistic","sylow","sylvan","sylvania","sylvester","sylvia","symbiosis","symbiotic","symbol","symbolic","symmetry","sympathetic","sympathy","symphonic","symphony"
DATA "symplectic","symposia","symposium","symptom","symptomatic","synagogue","synapse","synapses","synaptic","synchronism","synchronous","synchrony","synchrotron","syncopate","syndic","syndicate","syndrome","synergism","synergistic","synergy"
DATA "synge","synod","synonym","synonymous","synonymy","synopses","synopsis","synoptic","syntactic","syntax","syntheses","synthesis","synthetic","syracuse","syria","syringa","syringe","syrinx","syrup","syrupy"
DATA "system","systematic","systemic","systemization","systemwide","syzygy","szilard","t","t's","ta","tab","tabernacle","table","tableau","tableaux","tablecloth","tableland","tablespoon","tablespoonful","tablet"
DATA "tabloid","taboo","tabu","tabula","tabular","tabulate","tachinid","tachistoscope","tachometer","tacit","tacitus","tack","tackle","tacky","tacoma","tact","tactful","tactic","tactician","tactile"
DATA "tactual","tad","tadpole","taffeta","taffy","taft","tag","tagging","tahiti","tahoe","tail","tailgate","tailor","tailspin","tailwind","taint","taipei","taiwan","take","taken"
DATA "takeoff","takeover","taketh","talc","talcum","tale","talent","talisman","talismanic","talk","talkative","talkie","talky","tall","tallahassee","tallow","tally","tallyho","talmud","talon"
DATA "talus","tam","tamale","tamarack","tamarind","tambourine","tame","tammany","tamp","tampa","tampon","tan","tanager","tanaka","tananarive","tandem","tang","tangent","tangential","tangerine"
DATA "tangible","tangle","tango","tangy","tanh","tank","tannin","tansy","tantalum","tantalus","tantamount","tantrum","tanya","tanzania","tao","taoist","taos","tap","tapa","tape"
DATA "taper","tapestry","tapeworm","tapir","tapis","tappa","tappet","tar","tara","tarantara","tarantula","tarbell","tardy","target","tariff","tarnish","tarpaper","tarpaulin","tarpon","tarry"
DATA "tarrytown","tart","tartar","tartary","tarzan","task","taskmaster","tasmania","tass","tassel","taste","tasteful","tasting","tasty","tat","tate","tater","tattle","tattler","tattletale"
DATA "tattoo","tatty","tau","taught","taunt","taurus","taut","tautology","tavern","taverna","tawdry","tawny","tax","taxation","taxi","taxicab","taxied","taxiway","taxonomic","taxonomy"
DATA "taxpayer","taxpaying","taylor","tea","teacart","teach","teacup","teahouse","teakettle","teakwood","teal","team","teammate","teamster","teamwork","teapot","tear","teardrop","tearful","tease"
DATA "teasel","teaspoon","teaspoonful","teat","tech","technetium","technic","technician","technion","technique","technocrat","technocratic","technology","tectonic","tecum","ted","teddy","tedious","tedium","tee"
DATA "teeing","teem","teen","teenage","teensy","teet","teeter","teeth","teethe","teethed","teething","teetotal","teflon","tegucigalpa","teheran","tehran","tektite","tektronix","tel","telecommunicate"
DATA "teleconference","teledyne","telefunken","telegram","telegraph","telegraphy","telekinesis","telemeter","teleology","teleost","telepathic","telepathy","telephone","telephonic","telephony","telephotography","teleprinter","teleprocessing","teleprompter","telescope"
DATA "telescopic","telethon","teletype","teletypesetting","teletypewrite","televise","television","telex","tell","teller","telltale","tellurium","temerity","temper","tempera","temperance","temperate","temperature","tempest","tempestuous"
DATA "template","temple","templeton","tempo","temporal","temporary","tempt","temptation","temptress","ten","tenable","tenacious","tenacity","tenant","tend","tendency","tenderfoot","tenderloin","tendon","tenebrous"
DATA "tenement","tenet","tenfold","tenneco","tennessee","tenney","tennis","tennyson","tenon","tenor","tense","tensile","tension","tensional","tensor","tenspot","tent","tentacle","tentative","tenterhooks"
DATA "tenth","tenuous","tenure","tepee","tepid","teratogenic","teratology","terbium","tercel","teresa","term","terminable","terminal","terminate","termini","terminology","terminus","termite","tern","ternary"
DATA "terpsichore","terpsichorean","terra","terrace","terrain","terramycin","terrapin","terre","terrestrial","terrible","terrier","terrific","terrify","territorial","territory","terror","terry","terse","tertiary","tess"
DATA "tessellate","test","testament","testamentary","testate","testbed","testes","testicle","testicular","testify","testimonial","testimony","testy","tetanus","tete","tether","tetrachloride","tetrafluoride","tetrafluouride","tetragonal"
DATA "tetrahedra","tetrahedral","tetrahedron","tetravalent","teutonic","texaco","texan","texas","text","textbook","textile","textron","textual","textural","texture","thai","thailand","thalia","thallium","thallophyte"
DATA "than","thank","thankful","thanksgiving","that","that'd","that'll","thatch","thaw","thayer","the","thea","theatric","thebes","thee","theft","their","theism","theist","thelma"
DATA "them","thematic","theme","themselves","then","thence","thenceforth","theocracy","theodore","theodosian","theologian","theology","theorem","theoretic","theoretician","theorist","theory","therapeutic","therapist","therapy"
DATA "there","there'd","there'll","thereabouts","thereafter","thereat","thereby","therefor","therefore","therefrom","therein","thereof","thereon","theresa","thereto","theretofore","thereunder","thereupon","therewith","thermal"
DATA "thermionic","thermistor","thermo","thermofax","thermostat","thesaurus","these","theses","theseus","thesis","thespian","theta","thetis","they","they'd","they'll","they're","they've","thiamin","thick"
DATA "thicken","thicket","thickish","thief","thieves","thieving","thigh","thimble","thimbu","thin","thine","thing","think","thinnish","thiocyanate","thiouracil","third","thirst","thirsty","thirteen"
DATA "thirteenth","thirtieth","thirty","this","this'll","thistle","thistledown","thither","thomas","thomistic","thompson","thomson","thong","thor","thoreau","thoriate","thorium","thorn","thornton","thorny"
DATA "thorough","thoroughbred","thoroughfare","thoroughgoing","thorpe","thorstein","those","thou","though","thought","thoughtful","thousand","thousandfold","thousandth","thrall","thrash","thread","threadbare","threat","threaten"
DATA "three","threefold","threesome","threonine","thresh","threshold","threw","thrice","thrift","thrifty","thrill","thrips","thrive","throat","throaty","throb","throes","thrombosis","throne","throng"
DATA "throttle","through","throughout","throughput","throw","throwaway","throwback","thrown","thrum","thrush","thrust","thruway","thuban","thud","thug","thuggee","thule","thulium","thumb","thumbnail"
DATA "thump","thunder","thunderbird","thunderbolt","thunderclap","thunderflower","thunderous","thundershower","thunderstorm","thurman","thursday","thus","thwack","thwart","thy","thyme","thymine","thymus","thyratron","thyroglobulin"
DATA "thyroid","thyroidal","thyronine","thyrotoxic","thyroxine","ti","tiber","tibet","tibetan","tibia","tic","tick","ticket","tickle","ticklish","tid","tidal","tidbit","tide","tideland"
DATA "tidewater","tidy","tie","tied","tientsin","tier","tiffany","tift","tiger","tight","tighten","tigress","tigris","til","tilde","tile","till","tilt","tilth","tim"
DATA "timber","timberland","timbre","time","timeout","timepiece","timeshare","timetable","timeworn","timex","timid","timon","timothy","tin","tina","tincture","tinder","tine","tinfoil","tinge"
DATA "tingle","tinker","tinkle","tinsel","tint","tintype","tiny","tioga","tip","tipoff","tipperary","tipple","tippy","tipsy","tiptoe","tirade","tirana","tire","tiresome","tissue"
DATA "tit","titan","titanate","titanic","titanium","tithe","titian","titillate","title","titmouse","titrate","titular","titus","tn","tnt","to","toad","toady","toast","toastmaster"
DATA "tobacco","tobago","toby","toccata","today","today'll","todd","toddle","toe","toefl","toenail","toffee","tofu","tog","together","togging","toggle","togo","togs","toil"
DATA "toilet","toiletry","toilsome","tokamak","token","tokyo","told","toledo","tolerable","tolerant","tolerate","toll","tollgate","tollhouse","tolstoy","toluene","tom","tomato","tomatoes","tomb"
DATA "tombstone","tome","tomlinson","tommie","tommy","tomograph","tomography","tomorrow","tompkins","ton","tonal","tone","tong","tongue","toni","tonic","tonight","tonk","tonnage","tonsil"
DATA "tonsillitis","tony","too","toodle","took","tool","toolkit","toolmake","toolsmith","toot","tooth","toothbrush","toothpaste","toothpick","tootle","top","topaz","topcoat","topeka","topgallant"
DATA "topic","topmost","topnotch","topocentric","topography","topologize","topology","topple","topsoil","topsy","tor","torah","torch","tore","tori","torn","tornado","toroid","toroidal","toronto"
DATA "torpedo","torpid","torpor","torque","torr","torrance","torrent","torrid","torsion","torso","tort","tortoise","tortoiseshell","tortuous","torture","torus","tory","toshiba","toss","tot"
DATA "total","totalitarian","tote","totem","totemic","touch","touchdown","touchstone","touchy","tough","tour","tournament","tousle","tout","tow","toward","towboat","towel","tower","towhead"
DATA "towhee","town","townhouse","townsend","townsman","townsmen","toxic","toxicology","toxin","toy","toyota","trace","traceable","tracery","trachea","track","trackage","tract","tractor","tracy"
DATA "trade","trademark","tradeoff","tradesman","tradesmen","tradition","traffic","trafficked","trafficking","trag","tragedian","tragedy","tragic","tragicomic","trail","trailblaze","trailhead","trailside","train","trainee"
DATA "trainman","trainmen","traipse","trait","traitor","traitorous","trajectory","tram","trammel","tramp","trample","tramway","trance","tranquil","tranquillity","transact","transalpine","transatlantic","transceiver","transcend"
DATA "transcendent","transcendental","transconductance","transcontinental","transcribe","transcript","transcription","transducer","transduction","transect","transept","transfer","transferable","transferee","transference","transferor","transferral","transferred","transferring","transfinite"
DATA "transfix","transform","transformation","transfusable","transfuse","transfusion","transgress","transgression","transgressor","transient","transistor","transit","transite","transition","transitive","transitory","translate","transliterate","translucent","transmissible"
DATA "transmission","transmit","transmittable","transmittal","transmittance","transmitted","transmitter","transmitting","transmogrify","transmutation","transmute","transoceanic","transom","transpacific","transparent","transpiration","transpire","transplant","transplantation","transpond"
DATA "transport","transportation","transposable","transpose","transposition","transship","transshipped","transshipping","transversal","transverse","transvestite","transylvania","trap","trapezium","trapezoid","trapezoidal","trash","trashy","trastevere","trauma"
DATA "traumatic","travail","travel","travelogue","traversable","traversal","traverse","travertine","travesty","travis","trawl","tray","treacherous","treachery","tread","treadle","treadmill","treason","treasonous","treasure"
DATA "treasury","treat","treatise","treaty","treble","tree","treetop","trefoil","trek","trellis","tremble","tremendous","tremor","tremulous","trench","trenchant","trencherman","trenchermen","trend","trendy"
DATA "trenton","trepidation","trespass","tress","trestle","trevelyan","triable","triac","triad","trial","triangle","triangular","triangulate","triangulum","trianon","triassic","triatomic","tribal","tribe","tribesman"
DATA "tribesmen","tribulate","tribunal","tribune","tributary","tribute","triceratops","trichinella","trichloroacetic","trichloroethane","trichrome","trick","trickery","trickle","trickster","tricky","trident","tridiagonal","tried","triennial"
DATA "trifle","trifluoride","trifluouride","trig","trigonal","trigonometry","trigram","trihedral","trill","trillion","trillionth","trilobite","trilogy","trim","trimer","trimester","trinidad","trinitarian","trinity","trinket"
DATA "trio","triode","trioxide","trip","tripartite","tripe","triphenylphosphine","triple","triplet","triplett","triplex","triplicate","tripod","tripoli","triptych","trisodium","tristan","tristate","trisyllable","trite"
DATA "tritium","triton","triumph","triumphal","triumphant","triune","trivalent","trivia","trivial","trivium","trod","trodden","troglodyte","troika","trojan","troll","trolley","trollop","trombone","trompe"
DATA "troop","trophic","trophy","tropic","tropopause","troposphere","tropospheric","trot","troubador","trouble","troubleshoot","troublesome","trough","trounce","troupe","trouser","trout","troutman","troy","truancy"
DATA "truant","truce","truck","truculent","trudge","trudy","true","truism","truly","truman","trumbull","trump","trumpery","trumpet","truncate","trundle","trunk","truss","trust","trustee"
DATA "trustful","trustworthy","truth","truthful","trw","try","trypsin","trytophan","tsar","tsarina","tsunami","ttl","tty","tub","tuba","tube","tuberculin","tuberculosis","tubular","tubule"
DATA "tuck","tucker","tucson","tudor","tuesday","tuff","tuft","tug","tugging","tuition","tulane","tularemia","tulip","tulle","tulsa","tum","tumble","tumbrel","tumult","tumultuous"
DATA "tun","tuna","tundra","tune","tuneful","tung","tungstate","tungsten","tunic","tunis","tunisia","tunnel","tupelo","tuple","turban","turbid","turbidity","turbinate","turbine","turbofan"
DATA "turbojet","turbulent","turf","turgid","turin","turing","turk","turkey","turkish","turmoil","turn","turnabout","turnaround","turnery","turnip","turnkey","turnoff","turnout","turnover","turnpike"
DATA "turnstone","turntable","turpentine","turpitude","turquoise","turret","turtle","turtleback","turtleneck","turvy","tuscaloosa","tuscan","tuscany","tuscarora","tusk","tuskegee","tussle","tutelage","tutor","tutorial"
DATA "tuttle","tutu","tuxedo","tv","tva","twa","twaddle","twain","tweak","tweed","tweedy","tweeze","twelfth","twelve","twentieth","twenty","twice","twiddle","twig","twigging"
DATA "twilight","twill","twin","twine","twinge","twinkle","twirl","twirly","twist","twisty","twit","twitch","twitchy","two","twofold","twombly","twosome","twx","tx","tyburn"
DATA "tycoon","tying","tyler","tyndall","type","typeface","typescript","typeset","typesetter","typesetting","typewrite","typewritten","typhoid","typhon","typhoon","typhus","typic","typify","typo","typographer"
DATA "typography","typology","tyrannic","tyrannicide","tyrannosaurus","tyranny","tyrant","tyrosine","tyson","u","u's","u.s","u.s.a","ubiquitous","ubiquity","ucla","uganda","ugh","ugly","uhf"
DATA "uk","ukraine","ukrainian","ulan","ulcer","ulcerate","ullman","ulster","ulterior","ultimate","ultimatum","ultra","ulysses","umber","umbilical","umbilici","umbilicus","umbra","umbrage","umbrella"
DATA "umlaut","umpire","un","unanimity","unanimous","unary","unbeknownst","unbidden","unchristian","uncle","uncouth","unction","under","underclassman","underclassmen","underling","undulate","unesco","uniaxial","unicorn"
DATA "unidimensional","unidirectional","uniform","unify","unilateral","unimodal","unimodular","uninominal","union","uniplex","unipolar","uniprocessor","unique","uniroyal","unisex","unison","unit","unital","unitarian","unitary"
DATA "unite","unity","univac","univalent","univariate","universal","universe","unix","unkempt","unruly","until","unwieldy","up","upbeat","upbraid","upbring","upcome","update","updraft","upend"
DATA "upgrade","upheaval","upheld","uphill","uphold","upholster","upholstery","upkeep","upland","uplift","upon","upper","upperclassman","upperclassmen","uppercut","uppermost","upraise","upright","uprise","upriver"
DATA "uproar","uproarious","uproot","upset","upsetting","upshot","upside","upsilon","upslope","upstair","upstand","upstart","upstate","upstater","upstream","upsurge","upswing","uptake","upton","uptown"
DATA "uptrend","upturn","upward","upwind","uracil","urania","uranium","uranus","uranyl","urban","urbana","urbane","urbanite","urchin","urea","uremia","urethane","urethra","urge","urgency"
DATA "urgent","urging","uri","urinal","urinary","urine","uris","urn","ursa","ursula","ursuline","uruguay","us","usa","usable","usaf","usage","usc","usc&gs","usda"
DATA "use","useful","usgs","usher","usia","usn","usps","ussr","usual","usurer","usurious","usurp","usurpation","usury","ut","utah","utensil","uterine","uterus","utica"
DATA "utile","utilitarian","utility","utmost","utopia","utopian","utrecht","utter","utterance","uttermost","v","v's","va","vacant","vacate","vacationland","vaccinate","vaccine","vacillate","vacua"
DATA "vacuo","vacuolate","vacuole","vacuous","vacuum","vade","vaduz","vagabond","vagary","vagina","vaginal","vagrant","vague","vail","vain","vainglorious","vale","valediction","valedictorian","valedictory"
DATA "valent","valentine","valerie","valery","valet","valeur","valhalla","valiant","valid","validate","valine","valkyrie","valletta","valley","valois","valparaiso","valuate","value","valve","vamp"
DATA "vampire","van","vanadium","vance","vancouver","vandal","vandenberg","vanderbilt","vanderpoel","vane","vanguard","vanilla","vanish","vanity","vanquish","vantage","vapid","vaporous","variable","variac"
DATA "varian","variant","variate","variegate","variety","various","varistor","varitype","varnish","varsity","vary","vascular","vase","vasectomy","vasquez","vassal","vassar","vast","vat","vatican"
DATA "vaudeville","vaudois","vaughan","vaughn","vault","vaunt","veal","vector","vectorial","veda","vee","veer","veery","vega","vegetable","vegetarian","vegetate","vehement","vehicle","vehicular"
DATA "veil","vein","velar","velasquez","veldt","vella","vellum","velocity","velours","velvet","velvety","venal","vend","vendetta","vendible","vendor","veneer","venerable","venerate","venereal"
DATA "venetian","veneto","venezuela","vengeance","vengeful","venial","venice","venison","venom","venomous","venous","vent","ventilate","ventricle","venture","venturesome","venturi","venus","venusian","vera"
DATA "veracious","veracity","veranda","verandah","verb","verbal","verbatim","verbena","verbiage","verbose","verbosity","verdant","verde","verdi","verdict","verge","veridic","verify","verisimilitude","veritable"
DATA "verity","verlag","vermeil","vermiculite","vermilion","vermin","vermont","vermouth","verna","vernacular","vernal","verne","vernier","vernon","verona","veronica","versa","versailles","versatec","versatile"
DATA "verse","version","versus","vertebra","vertebrae","vertebral","vertebrate","vertex","vertical","vertices","vertigo","verve","very","vesicular","vesper","vessel","vest","vestal","vestibule","vestige"
DATA "vestigial","vestry","vet","vetch","veteran","veterinarian","veterinary","veto","vex","vexation","vexatious","vhf","vi","via","viaduct","vial","vibrant","vibrate","vibrato","viburnum"
DATA "vicar","vicarious","vice","viceroy","vichy","vicinal","vicinity","vicious","vicissitude","vicksburg","vicky","victim","victor","victoria","victorian","victorious","victory","victrola","victual","vida"
DATA "vide","video","videotape","vie","vienna","viennese","vientiane","viet","vietnam","vietnamese","view","viewpoint","viewport","vigil","vigilant","vigilante","vigilantism","vignette","vigorous","vii"
DATA "viii","viking","vile","vilify","villa","village","villain","villainous","villein","vincent","vindicate","vindictive","vine","vinegar","vineyard","vinson","vintage","vintner","vinyl","viola"
DATA "violate","violent","violet","violin","virgil","virgin","virginal","virginia","virginian","virgo","virgule","virile","virtual","virtue","virtuosi","virtuosity","virtuoso","virtuous","virulent","virus"
DATA "vis","visa","visage","viscera","visceral","viscoelastic","viscometer","viscosity","viscount","viscous","vise","vishnu","visible","visigoth","vision","visionary","visit","visitation","visitor","visor"
DATA "vista","visual","vita","vitae","vital","vitamin","vitiate","vito","vitreous","vitrify","vitriol","vitriolic","vitro","viva","vivace","vivacious","vivacity","vivaldi","vivian","vivid"
DATA "vivify","vivo","vixen","viz","vladimir","vladivostok","vocable","vocabularian","vocabulary","vocal","vocalic","vocate","vociferous","vogel","vogue","voice","voiceband","void","volatile","volcanic"
DATA "volcanism","volcano","volition","volkswagen","volley","volleyball","volstead","volt","volta","voltage","voltaic","voltaire","volterra","voltmeter","voluble","volume","volumetric","voluminous","voluntarism","voluntary"
DATA "volunteer","voluptuous","volvo","vomit","von","voodoo","voracious","voracity","vortex","vortices","vorticity","voss","votary","vote","votive","vouch","vouchsafe","vought","vow","vowel"
DATA "voyage","vreeland","vt","vulcan","vulgar","vulnerable","vulpine","vulture","vying","w","w's","wa","waals","wabash","wac","wack","wacke","wacky","waco","wad"
DATA "waddle","wade","wadi","wadsworth","wafer","waffle","wag","wage","wagging","waggle","wagner","wagoneer","wah","wahl","wail","wainscot","wainwright","waist","waistcoat","waistline"
DATA "wait","waite","waitress","waive","wake","wakefield","wakeful","waken","wakerobin","wakeup","walcott","walden","waldo","waldorf","waldron","wale","walgreen","walk","walkie","walkout"
DATA "walkover","walkway","wall","wallaby","wallace","wallboard","waller","wallet","wallis","wallop","wallow","wallpaper","walls","wally","walnut","walpole","walrus","walsh","walt","walter"
DATA "walters","waltham","walton","waltz","waltzing","wan","wand","wander","wane","wang","wangle","want","wanton","wapato","wapiti","wappinger","war","warble","ward","warden"
DATA "wardrobe","wardroom","ware","warehouse","warehouseman","warfare","warhead","waring","warlike","warm","warmhearted","warmish","warmonger","warmth","warmup","warn","warp","warplane","warrant","warranty"
DATA "warren","warrior","warsaw","wart","wartime","warty","warwick","wary","was","wash","washbasin","washboard","washbowl","washburn","washington","washout","washy","wasn't","wasp","waspish"
DATA "wasserman","wast","wastage","waste","wastebasket","wasteful","wasteland","wastewater","wastrel","watanabe","watch","watchband","watchdog","watchful","watchmake","watchman","watchmen","watchword","water","waterbury"
DATA "watercourse","waterfall","waterfront","watergate","waterhouse","waterline","waterloo","waterman","watermelon","waterproof","waters","watershed","waterside","watertown","waterway","watery","watkins","watson","watt","wattage"
DATA "wattle","watts","wave","waveform","wavefront","waveguide","wavelength","wavelet","wavenumber","wavy","wax","waxen","waxwork","waxy","way","waybill","waylaid","waylay","wayne","wayside"
DATA "wayward","we","we'd","we'll","we're","we've","weak","weaken","weal","wealth","wealthy","wean","weapon","weaponry","wear","wearied","wearisome","weary","weasel","weather"
DATA "weatherbeaten","weatherproof","weatherstrip","weatherstripping","weave","web","webb","weber","webster","weco","wed","wedge","wedlock","wednesday","wee","weed","weedy","week","weekday","weekend"
DATA "weeks","weep","wehr","wei","weierstrass","weigh","weight","weighty","weinberg","weinstein","weir","weird","weiss","welch","welcome","weld","weldon","welfare","well","wellbeing"
DATA "weller","welles","wellesley","wellington","wells","welsh","welt","wendell","wendy","went","wept","were","weren't","werner","wert","werther","wesley","wesleyan","west","westbound"
DATA "westchester","westerly","western","westernmost","westfield","westinghouse","westminster","weston","westward","wet","wetland","weyerhauser","whack","whale","whalen","wham","wharf","wharton","wharves","what"
DATA "what'd","what're","whatever","whatley","whatnot","whatsoever","wheat","wheatstone","whee","wheedle","wheel","wheelbase","wheelchair","wheelhouse","wheeze","wheezy","whelan","whelk","wheller","whelm"
DATA "whelp","when","whence","whenever","where","where'd","where're","whereabout","whereas","whereby","wherefore","wherein","whereof","whereon","wheresoever","whereupon","wherever","wherewith","wherewithal","whet"
DATA "whether","which","whichever","whiff","whig","while","whim","whimper","whimsey","whimsic","whine","whinny","whip","whiplash","whippany","whippet","whipple","whipsaw","whir","whirl"
DATA "whirligig","whirlpool","whirlwind","whish","whisk","whisper","whistle","whistleable","whit","whitaker","whitcomb","white","whiteface","whitehall","whitehead","whitehorse","whiten","whitetail","whitewash","whither"
DATA "whitlock","whitman","whitney","whittaker","whittier","whittle","whiz","whizzing","who","who'd","who'll","who've","whoa","whoever","whole","wholehearted","wholesale","wholesome","wholly","whom"
DATA "whomever","whomsoever","whoop","whoosh","whop","whore","whose","whosoever","whup","why","wi","wichita","wick","wicket","wide","widen","widespread","widgeon","widget","widow"
DATA "widowhood","width","widthwise","wield","wiener","wier","wife","wig","wigging","wiggins","wiggle","wiggly","wightman","wigmake","wigwam","wilbur","wilcox","wild","wildcat","wildcatter"
DATA "wilderness","wildfire","wildlife","wile","wiley","wilfred","wilful","wilhelm","wilhelmina","wilkes","wilkie","wilkins","wilkinson","will","willa","willard","willful","william","williams","williamsburg"
DATA "williamson","willie","willis","willoughby","willow","willowy","wills","wilma","wilmington","wilshire","wilson","wilsonian","wilt","wily","win","wince","winch","winchester","wind","windbag"
DATA "windbreak","windfall","windmill","window","windowpane","windowsill","windshield","windsor","windstorm","windsurf","windup","windward","windy","wine","winemake","winemaster","winery","wineskin","winfield","wing"
DATA "wingback","wingman","wingmen","wingspan","wingtip","winifred","wink","winkle","winnetka","winnie","winnipeg","winnipesaukee","winnow","wino","winslow","winsome","winston","winter","winters","wintertime"
DATA "winthrop","wintry","winy","wipe","wire","wireman","wiremen","wiretap","wiretapper","wiretapping","wiry","wisconsin","wisdom","wise","wiseacre","wisecrack","wisenheimer","wish","wishbone","wishful"
DATA "wishy","wisp","wispy","wistful","wit","witch","witchcraft","with","withal","withdraw","withdrawal","withdrawn","withdrew","withe","wither","withheld","withhold","within","without","withstand"
DATA "withstood","withy","witness","witt","witty","wive","wizard","wobble","woe","woebegone","woeful","wok","woke","wolcott","wold","wolf","wolfe","wolff","wolfgang","wolfish"
DATA "wolve","wolves","woman","womanhood","womb","wombat","women","won","won't","wonder","wonderful","wonderland","wondrous","wong","wont","woo","wood","woodard","woodbury","woodcarver"
DATA "woodcock","woodcut","wooden","woodgrain","woodhen","woodland","woodlawn","woodlot","woodpeck","woodrow","woodruff","woods","woodshed","woodside","woodward","woodwind","woodwork","woody","woodyard","wool"
DATA "woolgather","woolworth","wooster","wop","worcester","word","wordsworth","wordy","wore","work","workaday","workbench","workbook","workday","workforce","workhorse","workload","workman","workmanlike","workmen"
DATA "workout","workpiece","workplace","worksheet","workshop","workspace","workstation","worktable","world","worldwide","worm","wormy","worn","worrisome","worry","worse","worsen","worship","worshipful","worst"
DATA "worth","worthington","worthwhile","worthy","wotan","would","wouldn't","wound","wove","woven","wow","wrack","wraith","wrangle","wrap","wrapup","wrath","wrathful","wreak","wreath"
DATA "wreathe","wreck","wreckage","wrench","wrest","wrestle","wretch","wriggle","wright","wrigley","wring","wrinkle","wrist","wristband","wristwatch","writ","write","writeup","writhe","written"
DATA "wrong","wrongdo","wrongdoer","wrongdoing","wrongful","wronskian","wrote","wrought","wry","wu","wuhan","wv","wy","wyandotte","wyatt","wyeth","wylie","wyman","wyner","wynn"
DATA "wyoming","x","x's","xavier","xenon","xenophobia","xerography","xerox","xerxes","xi","xylem","xylene","xylophone","y","y's","yacht","yachtsman","yachtsmen","yah","yak"
DATA "yakima","yale","yalta","yam","yamaha","yang","yank","yankee","yankton","yaounde","yap","yapping","yaqui","yard","yardage","yardstick","yarmouth","yarmulke","yarn","yarrow"
DATA "yates","yaw","yawl","yawn","ye","yea","yeager","yeah","year","yearbook","yearn","yeast","yeasty","yeats","yell","yellow","yellowish","yellowknife","yellowstone","yelp"
DATA "yemen","yen","yeoman","yeomanry","yerkes","yeshiva","yesterday","yesteryear","yet","yiddish","yield","yin","yip","yipping","ymca","yodel","yoder","yoga","yoghurt","yogi"
DATA "yogurt","yoke","yokel","yokohama","yokuts","yolk","yon","yond","yonkers","yore","york","yorktown","yosemite","yost","you","you'd","you'll","you're","you've","young"
DATA "youngish","youngster","youngstown","your","yourself","yourselves","youth","youthful","yow","ypsilanti","ytterbium","yttrium","yucatan","yucca","yuck","yugoslav","yugoslavia","yuh","yuki","yukon"
DATA "yule","yves","yvette","ywca","z","z's","zachary","zag","zagging","zagreb","zaire","zambia","zan","zanzibar","zap","zazen","zeal","zealand","zealot","zealous"
DATA "zebra","zeiss","zellerbach","zen","zenith","zero","zeroes","zeroth","zest","zesty","zeta","zeus","ziegler","zig","zigging","zigzag","zigzagging","zilch","zimmerman","zinc"
DATA "zing","zion","zionism","zip","zippy","zircon","zirconium","zloty","zodiac","zodiacal","zoe","zomba","zombie","zone","zoo","zoology","zoom","zorn","zoroaster","zoroastrian"
DATA "zounds","zucchini","zurich","zygote"

DATA "XDONE"

